<?php

/**
 * agent.php
 * ---------
 * @version 5.4.0
 * @copyright 2002-2010 Melbis Company
 * @link http://www.melbis.com
 * @author Dmitriy Kasyanov
 **/

// Set Agent info
define('ITS_AGENT', true);

// Define script folder 
define('FOLDER', './../');

 
// Require classes and includes
require_once('./privat/privat.php');
require_once('./includes/common.php');
require_once('./includes/admin.php');
require_once('./class/show/class.XML.php');
require_once('./class/util/class.PclZip.php');



// Set time limit 
@set_time_limit(300); 

// Start session
session_start();

// Connect to Data
$gData = data_connect(true);

// What you need?
switch ($_POST['command'])
{
	case 'GET_SHOP_LOG' : 
		get_shop_log(); 
		break;
	case 'GET_SHOP_STAT' : 
		get_shop_stat(); 
		break;
	default : 
		echo "PHP_ERROR: Unknow command in line [".__LINE__."] :: Fail Command";
}

/**
 * Function get_shop_log
 * Return last shop log events
 **/
function get_shop_log()
{
	global $gData, $gOptions;

	list($start_datetime, $end_datetime) = explode('I', zip_file_to_string($_FILES['string_file']['tmp_name']));
	
	// Get base shop options
	$my_url = str_replace('www.', '', $gOptions['attr_base_url']);
	$my_url = str_replace('http://', '', $my_url);
	
	// Start XML file
	$xml_file = './tmp/'.md5(session_id()).'.xml';
	$xml = new XML(SHOP_CHARSET, $xml_file);
	$xml->StartTag('MELBISSHOP', array('Version' => SCRIPT_VERSION));
	

	// Query statistic
	$diff_seconds = strtotime($end_datetime) - strtotime(get_now());
	$log = $gData->GetShopLog($start_datetime, $end_datetime);
	$rows = $gData->GetNumRows($log);
	$xml->StartTag('VISITS', array('DiffSeconds' => $diff_seconds));
	for ( $i = 1; $i <= $rows; $i++ ) 
	{	
		$hash = $gData->FetchRow($log);
		if ( strpos($hash[2], $my_url) === false )
		{
			$from_type = 'alien';
			$from_page = $hash[2];
		}
		else 
		{
			$from_type = 'local';
			$from_page = '';
		}
		$to_type = $hash[3];
		switch ( $hash[3] )
		{
			case 'dir' : 
				if ( $hash[4] > 0 )
				{	
					list($path, $link, $link_title) = $gData->GetPath($hash[4]);
					$to_page = join('/', array_reverse($path)); 
				}
				else 
				{
					$to_page = '?';
				}
				break;
			case 'search' : 
				$to_page = $hash[5];
				if ( $hash[4] == 1 ) $to_type = 'goods_hit';
				if ( $hash[4] == 2 ) $to_type = 'goods_new';
				if ( $hash[4] == 3 ) $to_type = 'goods_disc';
				break;
			case 'goods' : 
				$goods = $gData->GetGoods($hash[4]);
				$to_page = $goods['name'];
				break;
			case 'descr' : 
				$goods = $gData->GetGoods($hash[4]);
				$to_page = $goods['name'];
				break;
			case 'buy' :
				$goods = $gData->GetGoods($hash[4]);
				$to_page = ' ('.$hash[5].' '.$goods['meas'].') - '.$goods['name'];
				break;
			case 'login' :
				$to_page = $hash[5];
				break;
			case 'order' :
				$to_page = $hash[5];
				break;
			case 'change' :
				$to_page = $hash[5];
				break;
			case 'config' :
				$config = $gData->GetConfig($hash[4]);	
				$to_page = $config['name'];
				break;
			default : 
				$to_page = '';
		}
		$xml->PutTag('VISIT', array('sid' 		=> $hash[0], 
									'ip' 		=> long2ip($hash[1]),
									'from_type' => $from_type,
									'from_page' => $from_page,
									'user_agent'=> $hash[7],
									'to_type'	=> $to_type,
									'to_page'	=> $to_page,
									'date'		=> date($gOptions['main_fmt_date'], strtotime($hash[6])),
									'time'		=> date($gOptions['main_fmt_time'], strtotime($hash[6])),
									'date_id'	=> date("dmY", strtotime($hash[6]))
									));
	}	
	$xml->CloseTag('VISITS');
		
	$xml->CloseTag('MELBISSHOP');
	$xml->Free();

	
	// Put result to archive
	xml_to_zip_answer($xml_file);
}



/**
 * Function get_shop_stat
 * Return shop statistic
 **/
function get_shop_stat()
{
	global $gData, $gOptions;

	$vars = explode(';', rtrim($_POST['values'], ';'));
	foreach ($vars as $var)
	{
		$input[$var] = true;
	}
		
	// Get base shop options
	$my_url = str_replace('www.', '', $gOptions['attr_base_url']);
	$my_url = str_replace('http://', '', $my_url);
	
	// Start XML file
	$xml_file = './tmp/'.md5(session_id()).'.xml';
	$xml = new XML(SHOP_CHARSET, $xml_file);
	$xml->StartTag('MELBISSHOP', array('Version' => SCRIPT_VERSION));
	
	// Visitor for days, week, month
	//==============================
	if ( $input['visitor'] ) 
	{
		// Query stat for days
		$log = $gData->GetStatVisitorDay(make_date(-86400*30, "Y-m-d"), get_date());
		$rows = $gData->GetNumRows($log);
		$xml->StartTag('VISITOR_DAY');
		for ( $i = 1; $i <= $rows; $i++ ) 
		{	
			$hash = $gData->FetchHash($log);
			$xml->PutTag('ROW', $hash);
		}	
		$xml->CloseTag('VISITOR_DAY');
		
		// Query stat for week
		$log = $gData->GetStatVisitorWeek(get_week());
		$rows = $gData->GetNumRows($log);
		$xml->StartTag('VISITOR_WEEK');
		for ( $i = 1; $i <= $rows; $i++ ) 
		{	
			$hash = $gData->FetchHash($log);
			$xml->PutTag('ROW', $hash);
		}	
		$xml->CloseTag('VISITOR_WEEK');
	
		// Query stat for month
		$log = $gData->GetStatVisitorMonth(get_month());
		$rows = $gData->GetNumRows($log);
		$xml->StartTag('VISITOR_MONTH');
		for ( $i = 1; $i <= $rows; $i++ ) 
		{	
			$hash = $gData->FetchHash($log);
			$xml->PutTag('ROW', $hash);
		}	
		$xml->CloseTag('VISITOR_MONTH');
	}
	
	// Visitor Domen
	//==============
	if ( $input['visitor_domen'] ) 
	{
		// Query stat for days
		$log = $gData->GetStatVisitorInfoDay('domen', make_date(-86400*30, "Y-m-d"), get_date(), 30);
		$rows = $gData->GetNumRows($log);
		$xml->StartTag('VISITOR_DOMEN_DAY');
		for ( $i = 1; $i <= $rows; $i++ ) 
		{	
			$hash = $gData->FetchHash($log);
			$xml->PutTag('ROW', $hash);
		}	
		$xml->CloseTag('VISITOR_DOMEN_DAY');
	
		// Query stat for weeks
		$log = $gData->GetStatVisitorInfoWeek('domen', get_week(), 30);
		$rows = $gData->GetNumRows($log);
		$xml->StartTag('VISITOR_DOMEN_WEEK');
		for ( $i = 1; $i <= $rows; $i++ ) 
		{	
			$hash = $gData->FetchHash($log);
			$xml->PutTag('ROW', $hash);
		}	
		$xml->CloseTag('VISITOR_DOMEN_WEEK');
		
		// Query stat for month
		$log = $gData->GetStatVisitorInfoMonth('domen', get_month(), 30);
		$rows = $gData->GetNumRows($log);
		$xml->StartTag('VISITOR_DOMEN_MONTH');
		for ( $i = 1; $i <= $rows; $i++ ) 
		{	
			$hash = $gData->FetchHash($log);
			$xml->PutTag('ROW', $hash);
		}	
		$xml->CloseTag('VISITOR_DOMEN_MONTH');
	}

	// Visitor Keyword
	//================
	if ( $input['visitor_keyword'] ) 
	{
		// Query stat for days
		$log = $gData->GetStatVisitorInfoDay('keyword', make_date(-86400*30, "Y-m-d"), get_date(), 30);
		$rows = $gData->GetNumRows($log);
		$xml->StartTag('VISITOR_KEYWORD_DAY');
		for ( $i = 1; $i <= $rows; $i++ ) 
		{	
			$hash = $gData->FetchHash($log);
			$xml->PutTag('ROW', $hash);
		}	
		$xml->CloseTag('VISITOR_KEYWORD_DAY');
	
		// Query stat for weeks
		$log = $gData->GetStatVisitorInfoWeek('keyword', get_week(), 30);
		$rows = $gData->GetNumRows($log);
		$xml->StartTag('VISITOR_KEYWORD_WEEK');
		for ( $i = 1; $i <= $rows; $i++ ) 
		{	
			$hash = $gData->FetchHash($log);
			$xml->PutTag('ROW', $hash);
		}	
		$xml->CloseTag('VISITOR_KEYWORD_WEEK');
	
		// Query stat for month
		$log = $gData->GetStatVisitorInfoMonth('keyword', get_month(), 30);
		$rows = $gData->GetNumRows($log);
		$xml->StartTag('VISITOR_KEYWORD_MONTH');
		for ( $i = 1; $i <= $rows; $i++ ) 
		{	
			$hash = $gData->FetchHash($log);
			$xml->PutTag('ROW', $hash);
		}	
		$xml->CloseTag('VISITOR_KEYWORD_MONTH');
	}
	
	// Top topic
	//==========
	if ( $input['top_topic'] ) 
	{
		// Query stat for day
		$log = $gData->GetStatTopicDay(make_date(-86400*30, "Y-m-d"), get_date(), 40);
		$rows = $gData->GetNumRows($log);
		$xml->StartTag('TOP_TOPIC_DAY');
		for ( $i = 1; $i <= $rows; $i++ ) 
		{	
			$hash = $gData->FetchHash($log);
			$xml->PutTag('ROW', $hash);
		}	
		$xml->CloseTag('TOP_TOPIC_DAY');

		// Query stat for weeks
		$log = $gData->GetStatTopicWeek(get_week(), 40);
		$rows = $gData->GetNumRows($log);
		$xml->StartTag('TOP_TOPIC_WEEK');
		for ( $i = 1; $i <= $rows; $i++ ) 
		{	
			$hash = $gData->FetchHash($log);
			$xml->PutTag('ROW', $hash);
		}	
		$xml->CloseTag('TOP_TOPIC_WEEK');
	
		// Query stat for month
		$log = $gData->GetStatTopicMonth(get_month(), 40);
		$rows = $gData->GetNumRows($log);
		$xml->StartTag('TOP_TOPIC_MONTH');
		for ( $i = 1; $i <= $rows; $i++ ) 
		{	
			$hash = $gData->FetchHash($log);
			$xml->PutTag('ROW', $hash);
		}	
		$xml->CloseTag('TOP_TOPIC_MONTH');
	}
	
	// Top goods
	//==========
	if ( $input['top_goods'] ) 
	{
		// Query stat for day
		$log = $gData->GetStatGoodsDay(make_date(-86400*30, "Y-m-d"), get_date(), 40);
		$rows = $gData->GetNumRows($log);
		$xml->StartTag('TOP_GOODS_DAY');
		for ( $i = 1; $i <= $rows; $i++ ) 
		{	
			$hash = $gData->FetchHash($log);
			$xml->PutTag('ROW', $hash);
		}	
		$xml->CloseTag('TOP_GOODS_DAY');

		// Query stat for weeks
		$log = $gData->GetStatGoodsWeek(get_week(), 40);
		$rows = $gData->GetNumRows($log);
		$xml->StartTag('TOP_GOODS_WEEK');
		for ( $i = 1; $i <= $rows; $i++ ) 
		{	
			$hash = $gData->FetchHash($log);
			$xml->PutTag('ROW', $hash);
		}	
		$xml->CloseTag('TOP_GOODS_WEEK');
	
		// Query stat for month
		$log = $gData->GetStatGoodsMonth(get_month(), 40);
		$rows = $gData->GetNumRows($log);
		$xml->StartTag('TOP_GOODS_MONTH');
		for ( $i = 1; $i <= $rows; $i++ ) 
		{	
			$hash = $gData->FetchHash($log);
			$xml->PutTag('ROW', $hash);
		}	
		$xml->CloseTag('TOP_GOODS_MONTH');
	}
	
	
	// Order Domen
	//============
	if ( $input['order_domen'] ) 
	{
		// Query stat for weeks
		$log = $gData->GetStatOrderInfoWeek('domen', get_week(), 40);
		$rows = $gData->GetNumRows($log);
		$xml->StartTag('ORDER_DOMEN_WEEK');
		for ( $i = 1; $i <= $rows; $i++ ) 
		{	
			$hash = $gData->FetchHash($log);
			$xml->PutTag('ROW', $hash);
		}	
		$xml->CloseTag('ORDER_DOMEN_WEEK');
		
		// Query stat for month
		$log = $gData->GetStatOrderInfoMonth('domen', get_month(), 40);
		$rows = $gData->GetNumRows($log);
		$xml->StartTag('ORDER_DOMEN_MONTH');
		for ( $i = 1; $i <= $rows; $i++ ) 
		{	
			$hash = $gData->FetchHash($log);
			$xml->PutTag('ROW', $hash);
		}	
		$xml->CloseTag('ORDER_DOMEN_MONTH');
	}

	// Order Keyword
	//==============
	if ( $input['order_keyword'] ) 
	{
		// Query stat for weeks
		$log = $gData->GetStatOrderInfoWeek('keyword', get_week(), 40);
		$rows = $gData->GetNumRows($log);
		$xml->StartTag('ORDER_KEYWORD_WEEK');
		for ( $i = 1; $i <= $rows; $i++ ) 
		{	
			$hash = $gData->FetchHash($log);
			$xml->PutTag('ROW', $hash);
		}	
		$xml->CloseTag('ORDER_KEYWORD_WEEK');
	
		// Query stat for month
		$log = $gData->GetStatOrderInfoMonth('keyword', get_month(), 40);
		$rows = $gData->GetNumRows($log);
		$xml->StartTag('ORDER_KEYWORD_MONTH');
		for ( $i = 1; $i <= $rows; $i++ ) 
		{	
			$hash = $gData->FetchHash($log);
			$xml->PutTag('ROW', $hash);
		}	
		$xml->CloseTag('ORDER_KEYWORD_MONTH');
	}
	
	// Shop Search
	//============
	if ( $input['shop_search'] ) 
	{
		// Query stat for days
		$log = $gData->GetStatShopSearchDay(make_date(-86400*30, "Y-m-d"), get_date(), 40);
		$rows = $gData->GetNumRows($log);
		$xml->StartTag('SHOP_SEARCH_DAY');
		for ( $i = 1; $i <= $rows; $i++ ) 
		{	
			$hash = $gData->FetchHash($log);
			$xml->PutTag('ROW', $hash);
		}	
		$xml->CloseTag('SHOP_SEARCH_DAY');
	
		// Query stat for week
		$log = $gData->GetStatShopSearchWeek(get_week(), 40);
		$rows = $gData->GetNumRows($log);
		$xml->StartTag('SHOP_SEARCH_WEEK');
		for ( $i = 1; $i <= $rows; $i++ ) 
		{	
			$hash = $gData->FetchHash($log);
			$xml->PutTag('ROW', $hash);
		}	
		$xml->CloseTag('SHOP_SEARCH_WEEK');
	
		// Query stat for month
		$log = $gData->GetStatShopSearchMonth(get_month(), 40);
		$rows = $gData->GetNumRows($log);
		$xml->StartTag('SHOP_SEARCH_MONTH');
		for ( $i = 1; $i <= $rows; $i++ ) 
		{	
			$hash = $gData->FetchHash($log);
			$xml->PutTag('ROW', $hash);
		}	
		$xml->CloseTag('SHOP_SEARCH_MONTH');
	}
	
	$xml->CloseTag('MELBISSHOP');
	$xml->Free();
	
	// Put result to archive
	xml_to_zip_answer($xml_file);
}

?>