<?php

/**
 * class.Emailer.php
 * -----------------
 * @version 5.4.0
 * @copyright 2002-2010 Melbis Company
 * @link http://www.melbis.com
 * @author Dmitriy Kasyanov
 **/

/** 
 * Class Emailer
 * Send e-mail's
 **/
class Emailer
{

	/**
	 * Vars 
	 **/
	var $gTypeHTML;
	var $gCharset;
	var $gServer;
 	var $gHeaders; 
	var $gMime; 
	var $gMessage; 
	var $gParts = array();
  	 
	/**
	 * Constructor
	 **/
	function Emailer($mServer = '')
	{
		$this->gTypeHTML = false;
		$this->gServer = $mServer;
		$this->Clear();
    }       

	/**
	 * Clear
	 **/
    function Clear() 
	{
		$this->gHeaders = '';
		$this->gMultipart = '';
		$this->gMime = '';
		$this->gMessage = '';
		$this->gParts = array();
    }       

	/**
	 * SetCharset
	 **/
    function SetCharset($mCharset) 
	{
		$this->gCharset = $mCharset;
    }       

	/**
	 * SetTypeHTML
	 **/
    function SetTypeHTML() 
	{
		$this->gTypeHTML = true;
    }  
	
	/**
	 * SetTypeText
	 **/
    function SetTypeText() 
	{
		$this->gTypeHTML = false;
    }       
	
	/**
	 * AddMessage
	 **/
    function AddMessage($mText) 
	{
		$this->gMessage = $mText;
    }       

	/**
	 * AddAttachment
	 **/
	function AddAttachment($mFile, $mAttachName, $mType = 'application/octet-stream') 
	{ 
        if ( is_file($mFile) ) 
		{
			$body = @implode("", (file($mFile)));
			array_push($this->gParts, array('body' => $body, 'name' => basename($mAttachName), 'type' => $mType));
        }
	} 
	
	/**
	 * BuildMessage
	 **/	
	function BuildMessage() 
	{ 
    	$boundary = '=_'.md5(uniqid(time())); 
	    $this->gHeaders = "MIME-Version: 1.0\n"; 
	    $this->gHeaders .= "Content-Type: multipart/mixed; boundary=\"$boundary\"\n"; 
    	$this->gMime = ''; 
	    $this->gMime .= "This is a MIME encoded message.\n\n"; 
    	$this->gMime .= "--$boundary\n";
		if ( $this->gTypeHTML ) 
		{
		    $this->gMime .= "Content-Type: text/html; charset=$this->gCharset\n";
			$this->gMime .= "Content-Transfer-Encoding: Quot-Printed\n\n"; 
		}
		else
		{
			$this->gMime .= "Content-Type: text/plain; charset=$this->gCharset\n";
			$this->gMime .= "Content-Transfer-Encoding: 8bit\n\n"; 
		}
    	$this->gMime .= $this->gMessage."\n\n";		
	    for ( $i = count($this->gParts)-1; $i >= 0; $i-- )
		{
    		$this->gMime .= "--$boundary\n".$this->BuildPart($i); 
		}
    	$this->gMime .= "--$boundary--\n"; 
	} 	
	
	/**
	 * BuildPart
	 **/
	function BuildPart($mNum) 
	{ 
    	$message_part = ''; 
	    $message_part .= "Content-Type: ".$this->gParts[$mNum][type]; 
    	if ( $this->gParts[$mNum][name] != '')
		{ 
       		$message_part .= "; name = \"".$this->gParts[$mNum][name]."\"\n"; 
		}
    	else 
		{
       		$message_part .= "\n";
		} 
    	$message_part .= "Content-Transfer-Encoding: base64\n"; 
    	$message_part .= "Content-Disposition: attachment; filename = \"".$this->gParts[$mNum][name]."\"\n\n"; 
	    $message_part .= chunk_split(base64_encode($this->gParts[$mNum][body]))."\n";
   	 	
		return $message_part; 
	} 

	/**
	 * Send
	 **/
	function Send($mTo, $mFrom, $mSubject) 
	{ 
    	$rcpt = explode(',', $mTo);
    	$mSubject = preg_replace("/\r\n|\n\r|\n|\r/", "", $mSubject);
    	$headers = $this->gHeaders;
		$headers .= "From: $mFrom\n";
		$headers .= "Date: ".date("D, d M Y H:i:s") . " UT\n";
		$headers .= "Reply-To:$mFrom\n";

		if ( strlen($this->gServer) > 0 ) 
		{
	    	// Send via socket
			$fp = @fsockopen($this->gServer, 25, $err_num, $err_text, 20);
    		if ( !$fp )
			{
       			return false;
				//die(" Server $this->gServer. Connection failed: $err_num, $err_text");
			}
    		$headers .= "Subject: $mSubject\n";
    		$headers .= "X-Mailer: PHP/".phpversion()."\n";
    		
			@fputs($fp, "HELO $this->gServer\n");
			@fputs($fp, "MAIL FROM: $mFrom\n");
			foreach ( $rcpt as $to_email ) @fputs($fp, "RCPT TO: ".trim($to_email)."\n");
	    	
		    @fputs($fp, "DATA\n");
			if ( count($rcpt) == 1 ) @fputs($fp, "To: $mTo\n");
    		
			@fputs($fp, $headers);
	    	@fputs($fp, $this->gMime);
		    @fputs($fp, "\n.\nQUIT\n");
    		
		    while( !feof($fp) )	$resp .= @fgets($fp, 1024);
	    	@fclose($fp);
		}
		else
		{
			// Send via mail function
			$headers .= "X-Mailer: PHP/".phpversion()."\n";
			foreach ( $rcpt as $to_email ) $resp .= @mail(trim($to_email), $mSubject, $this->gMime, $headers);
		}
	
	return $resp;
  	}	
	
} 
?>
