<?php

/**
 * basket.php
 * ----------
 * @version 5.4.0
 * @copyright 2002-2010 Melbis Company
 * @link http://www.melbis.com
 * @author Dmitriy Kasyanov
 **/
 
 
/**
 * Function buy_goods
 * Add one goods to basket
 **/
function buy_goods($mHow, $mStoreID, $mParamValueID, $mModifyCode, $mTimeShift = 0)
{
	global $gData;

	// Get Goods options
	$goods = $gData->GetGoods($mStoreID);
	if (($goods['id'] == 0) || ($goods['active'] == 0)) shop_die('no_goods', $goods['id'], __LINE__, $_SERVER['REQUEST_URI']);

	// Get Goods basket params
	$basket_goods = $gData->GetCurrentBasketGoods(session_id(), $mStoreID, $mParamValueID, addslashes($mModifyCode));
	$how_sum = $basket_goods['how'] + $mHow; 
	
	// Normalize how for step
	$max_order = $gData->GetMaxOrderGoods($mStoreID, $mParamValueID);
	if ( $how_sum == 0 ) $how_sum = $goods['min_order'];
	if ( $how_sum > $max_order ) $how_sum = $max_order;
	if ( $max_order != $how_sum )
	{
		$how_sum = ($how_sum - ($how_sum % $goods['step_order']));
		if ( $how_sum < $goods['step_order'] ) $how_sum = $goods['step_order'];
		if ( $how_sum < $goods['min_order'] ) $how_sum = $goods['min_order'];	
	}
	$how_plus = ($how_sum - $basket_goods['how']);
	
	// Calc prices
	list($new_price, $disc_proc, $disc_suma, $price_offer) = calc_goods_price($goods['id'], $goods['price'], $goods['disc_price'], $how_sum);
	$price = $goods['price'];
	
	// Get and calc goods param if exists
	if ( $mParamValueID > 0 ) 
	{
		$param = $gData->GetGoodsParamValue($mStoreID, $mParamValueID);	
		if ( strlen($param['price']) > 0 ) 
		{
			$price = $param['price'];
		}		
		else
		{
			$price = round($price*(1 + $param['proc']/100), 2) + $param['suma'];
		}
		$new_price = round($price*(1 - $disc_proc/100) - $disc_suma, 2);
	}

	// Calc modify suma and names (from param phis type "modification")
	$modify_suma = 0;
	$modify_name = '';
	$tmp_code = '';
	foreach ( explode('I', $mModifyCode) as $modify_value_id )
	{
		if ( $modify_value_id*1 == 0 ) continue; // Attempt hack
		$modify_param = $gData->GetGoodsParamValue($mStoreID, $modify_value_id*1);
		if ( strlen($modify_param['proc']) == 0 ) continue; // Attempt hack or wrong param value id
		$tmp_code .= $modify_value_id.'I';
		if ( strlen($modify_param['price']) > 0 ) 
		{
			// Special fixed add sum
			$modify_suma += $modify_param['price'];
			$modify_tax += $modify_param['tax'];
		}		
		else
		{
			// Add sum calc by param proc and sum
			$modify_suma += round($price*$modify_param['proc']/100, 2) + $modify_param['suma'];
			$modify_tax += $modify_param['param_tax'];
		}
		$modify_name .= $modify_param['param_name'].': '.$modify_param['name'].'; ';
	}
	$modify_code = rtrim($tmp_code, 'I');
	$modify_name = rtrim($modify_name, '; ');
	$new_price += $modify_suma;
	
	// Make informational fields
	$code = $goods['code'];
	$tax = $goods['tax'];
	$status = $goods['status'];
	$param_personal = 0;
	$param_price = 0;
	$param_proc = 0;
	$param_suma = 0;
	$param_name = '';
	if ( $mParamValueID > 0 ) 
	{
	    $tax += $param['param_tax'];
		$param_proc = $param['proc'];
		$param_suma = $param['suma'];
		$param_name = $param['param_name'].': '.$param['name'];
		if ( strlen($param['price']) > 0 ) 
		{
	    	$param_personal = 1;
			$code = $param['code'];
			$tax = $param['tax'];
			$status = $param['status'];
			$param_price = $param['price'];
		}
	}
	if ( strlen($modify_name) > 0 )
	{
		$param_name .= '; '.$modify_name;
		$param_name = ltrim($param_name, '; ');
	}
	$tax += $modify_tax;
	
	// Save goods to basket if ordered
	if ( $how_plus > 0 ) 
	{
		if ( $basket_goods['how'] == 0 ) 
		{
			$gData->PutCurrentBasket(session_id(), 
									 $mStoreID, 
									 addslashes($code), 
									 $tax, 
									 $status,
									 $how_sum, 
									 $goods['price'],
									 $goods['disc_price'],
									 $mParamValueID, 
									 addslashes($param_name), 
									 $param_personal,
									 $param_price,
									 $param_proc,
									 $param_suma,
									 make_date($mTimeShift), 
									 $modify_suma,
									 addslashes($modify_code),
									 addslashes($goods['name']),
									 addslashes($goods['meas']),
									 $goods['part_proc'],
									 $goods['provider_id'],
									 $goods['prov_price']
									 );
		}
		else
		{
			$gData->UpdateCurrentBasket($basket_goods['id'], $how_sum);		
		}									 
		
		// Save shop statistic
		save_shop_stat('buy', $mStoreID, $how_plus);		
	}
	
		
	return $how_plus;
} 
 
 
/**
 * Function calc_basket_goods
 * Calc the basket information about input goods
 **/
function calc_basket_goods($mHash, $mClient)
{
	global $gData;

	//Define variales for calc price
	$client_proc = $mClient['proc'];
	$client_category = $mClient['category_id'];
	
	$price = $mHash['price'];
	
	// Client special
	if ($client_category > 0 || $client_proc > 0)
	{
		// Discount system
		list($disc_proc, $disc_suma) = $gData->GetGoodsDiscParam($mHash['store_id'], $mHash['how'], $client_category);
		$new_price = round($price*(1-$disc_proc/100)-$disc_suma, 2);
		if ( $price == $new_price )
		{
			$disc_proc = $client_proc;
			$new_price = round($price*(1-$client_proc/100), 2);
		}
	}
	// Simple client
	else
	{
		// Total sale
		if ( $mHash['disc_price']*1 > 0 && $price != 0 ) 
		{
			$disc_proc = round(100-100*$mHash['disc_price']/$price, 2);
			$new_price = $mHash['disc_price']*1;
		}
		// Discount system
		else 
		{
			list($disc_proc, $disc_suma) = $gData->GetGoodsDiscParam($mHash['store_id'], $mHash['how'], 0);
			$new_price = round($price*(1-$disc_proc/100)-$disc_suma, 2);
		}	
	}	
	
	// Get and calc goods param if exists
	if ( $mHash['param_value_id'] > 0 ) 
	{
		if ( $mHash['param_personal'] > 0 ) 
		{
			$price = $mHash['param_price'];
		}		
		else
		{
			$price = round($price*(1+$mHash['param_proc']/100), 2)+$mHash['param_suma'];
		}
		$new_price = round($price*(1-$disc_proc/100)-$disc_suma, 2);
	}
	
	// Add modify suma (from parameters values where phisical type is "modification")
	$price += $mHash['modify_suma'];
	$new_price += round($mHash['modify_suma']*(1 - $disc_proc/100), 2);
	//$new_price += $mHash['modify_suma'];
	
	
	return array($price, $new_price);
} 

/**
 * Function calc_basket_info
 * Calc the basket information about goods: order sum, tax sum, how ordered
 **/
function calc_basket_info($mClient, $mSID = '')
{
	global $gData, $gOptions;

	//Define variales for calc price
	if ( $mSID == '' ) $mSID = session_id();
	$client_proc = $mClient['proc']*1;
	$client_suma = $mClient['suma']*1;
	$client_category = $mClient['category_id']*1;
	
	// Get Goods list
	$goods = $gData->GetCurrentBasket($mSID);
	$rows = $gData->GetNumRows($goods);
	$tax_sum = 0;
	$how_ordered = 0;
	$total_sum = 0;
	$itogo_sum = 0;
	if ( $rows > 0 ) 
	{
		for ( $i = 1; $i <= $rows; $i++ ) 
		{			
			$hash = $gData->FetchHash($goods);
			// Calc prices
			list($price, $new_price) = calc_basket_goods($hash, $mClient);
			// Itogo sum
			$itogo_sum += $new_price*$hash['how'];
			$how_ordered += $hash['how'];
			$tax_sum += $hash['tax']*$hash['how'];
		}
		// Common discount for order sum
		$disc_order_sum = $client_suma;
		if ( $client_proc == 0 && $client_suma == 0 && $client_category == 0 ) 
		{
			$calc_disc_sum = ( $gOptions['main_disc_type'] == 'True' ) ? $itogo_sum + $mClient['orders_suma']*1 : $itogo_sum;
			$disc = $gData->GetDiscountOrder($calc_disc_sum);
			if ( $disc['id'] > 0 ) 
			{
			    $disc_order_sum = round($itogo_sum*$disc['proc']/100, 2);
			}
		}
		$total_sum = $itogo_sum - $disc_order_sum;		
	}
	// May be gifts?
	$gift = $gData->GetGiftForSum($itogo_sum);
	$rows = $gData->GetNumRows($gift);
	for ( $i = 1; $i <= $rows; $i++ ) 
	{			
		$hash = $gData->FetchHash($gift);
		$tax_sum += $hash['tax'];
	}	
	
	return array($how_ordered, $itogo_sum, $total_sum, $tax_sum);
}
 
/**
 * Function calc_basket_delivery
 * Calc the delivery information
 **/
function calc_basket_delivery($mDeliveryID, $mTax, $mItogoSum)
{
	global $gData;

	$deliv = $gData->GetDeliveryValue($mDeliveryID, $mTax, $mItogoSum);
	$rows = $gData->GetNumRows($deliv);
	$deliv_name = '';
	$deliv_cost = 0;
	if ( $rows > 0 ) 
	{
		$hash = $gData->FetchRow($deliv);	
		$deliv_name = $hash[1];
		$deliv_cost = $hash[7];
		$deliv_cost += round($mItogoSum*$hash[6]/100, 2);
		if ( $hash[10]*1 > 0 ) 
		{
			$deliv_cost += $mTax*$hash[11];
		}
		if ( $hash[12]*1 > 0 ) 
		{
			$deliv_cost += $hash[13];
		}
		if ( $mItogoSum >= $hash[8]*1 && $hash[8]*1 > 0 ) 
		{
		    $deliv_cost = 0;
		}
	}	
					  
	return array(($rows > 0), $deliv_name, $deliv_cost);
} 

/**
 * Function calc_basket_condition
 * Calc the condition information
 **/
function calc_basket_condition($mConditionID, $mTax, $mItogoSum, $mHowOrdered)
{
	global $gData;

	$cond = $gData->GetCondition();
	$rows = $gData->GetNumRows($cond);
	$cond_name = '';
	$cond_cost = 0;
	$set_cond = false;
	if ( $rows > 0 ) 
	{
		$cond_check = explode(",", $mConditionID);
		$cond_name = '';
		for ( $i = 1; $i <= $rows; $i++ ) 
		{			
			$hash = $gData->FetchRow($cond);	
			if ( in_array($hash[0], $cond_check) ) 
			{
				$set_cond = true;
				$cond_name .= $hash[1].'; ';
				$cond_cost += $hash[7];
				$cond_cost += round($mItogoSum*$hash[6]/100, 2);
				$cond_cost += $mHowOrdered*$hash[8];
				$cond_cost += $mTax*$hash[9];
			}
		}
	}
						  
	return array($set_cond, rtrim($cond_name, '; '), $cond_cost);
} 

/**
 * Function calc_basket_payment
 * Calc the payment information
 **/
function calc_basket_payment($mPaymentID, $mOrderSum, $mCurr, $mPrec)
{
	global $gData;

	$payment = $gData->GetPaymentValue($mPaymentID);
	$rows = $gData->GetNumRows($payment);
	$payment_name = '';
	$payment_curr = $mCurr;
	$payment_prec = $mPrec;
	$payment_cost = $mOrderSum;
	if ( $rows > 0 ) 
	{
		$hash = $gData->FetchRow($payment);	
		$payment_name = $hash[1];
		$payment_curr = $hash[7];
		$payment_cost = $hash[11];
		$payment_prec = $hash[10];
		if ( $hash[9] == 1 && $hash[8] > 0) 
		{
		    $payment_mult = round(1/$hash[8], 12);
		}
		else
		{
			$payment_mult = $hash[8];
		}	
		$payment_cost += round($mOrderSum*$payment_mult, 2);			
	}	

	return array(($rows > 0), $payment_name, $payment_cost, $payment_curr, $payment_prec);
} 

/**
 * Function test_basket_reload
 * Clear basket goods after base reloading
 **/
function test_basket_reload()
{
	global $gData, $gOptions, $gTpl, $gStartPoint;

	// Test if set start time
	if ( !isset($_SESSION['start_time']) ) 
	{
		$_SESSION['start_time'] = get_now();
		return false;
	}
	
	// Test if need clear
	if ( $gOptions['main_basket_clear'] != 'True' || 
		 strtotime($_SESSION['start_time']) > strtotime($gOptions['main_update_time']) ) return false;
	
	// Now clearing basket goods if they exists
	$goods = $gData->GetCurrentBasket(session_id());
	$rows = $gData->GetNumRows($goods);
	if ( $rows == 0  ) return false;
	for ( $i = 1; $i <= $rows; $i++ ) 
	{			
		$hash = $gData->FetchHash($goods);
		$gData->RemoveCurrentBasket($hash['id']);
	}			
	$_SESSION['start_time'] = get_now();
				
	// Echo information
	$gTpl = new FastTemplate('./'.TEMPLATES);
	$gTpl->DefineTemplate(array('blank' 		=> 'blank.htm',
							    'main'			=> 'reload/main.htm',
							    'page_title'	=> 'reload/page_title.htm'
			   					));
	$gTpl->Assign('PAGEPATH', $_SERVER['REQUEST_URI']);
	$gTpl->Parse('CONTENT', 'main');
	$gTpl->Parse('PAGETITLE', 'page_title');
		
	// Echo shop variables
	echo_shop_variables('in_techpage', true);

	// Additional modules
	use_php_mod('other');
			
	// Parse main page
	$gTpl->Parse('BLANK', 'blank');
	$gEndPoint = run_time($gStartPoint);
	$gTpl->FastPrint('BLANK');
					
	// Echo page compilate time
	echo_page_time($gEndPoint);
					
	return true;

}

?>