<?php

/**
 * common.php
 * ----------
 * @version 5.4.0
 * @copyright 2002-2010 Melbis Company
 * @link http://www.melbis.com
 * @author Dmitriy Kasyanov
 **/

 
// Test for right path
if ( !@file_exists(SHOP_CWD.'/admin/includes/common.php') && !isset($gCWD) ) 
{
	die('PHP_ERROR: shop path is wrong. Run MShop.exe and go to server setup');
}
 
// Require classes and includes 
if ( !isset($gCWD) ) 
{
	require_once(SHOP_CWD.'/admin/includes/messages.php');
	require_once(SHOP_CWD.'/admin/includes/search_engines.php');
}	




/************************************************************************************************************
 *
 *											Autorun some procedures
 *
 ************************************************************************************************************/

 
// Error control
error_reporting(E_ALL ^ E_NOTICE);

// Set Local Setting 
setlocale (LC_CTYPE, SHOP_LOCALE); 

// Hash data coding
@ini_set('session.hash_function', 1);
@ini_set('session.hash_bits_per_character', 5);

// Magic Quotes Normalize 
@ini_set('magic_quotes_runtime', 0);
if ( get_magic_quotes_gpc() )
{
	strip_it($_GET);
	strip_it($_POST);
	strip_it($_COOKIE);
}
 
	

/************************************************************************************************************
 *
 *											Common functions
 *
 ************************************************************************************************************\

/**
 * Function strip_it
 **/
function strip_it(&$a)
{
	if ( is_array($a) )
	{
		foreach ( $a as $name => $val )
		{
			if ( is_array($val) )
			{
				strip_it($a[$name], $tmp[$name]);
			} 
			else 
			{
				$a[$name]=stripslashes($val);
			}
		}
	}
}

/** 
 * Function data_connect
 * Do connection to DataBase via class for MySQL, ODBC, Oracle etc.
 **/
function data_connect($mSimpleError = false, $mParam = array(), $mItsUpdate = false)
{
	global $gOptions;
	
	// Shop available?
	if ( LOCK_SHOP == 'True' ) 
	{
		if ( $mSimpleError ) 
		{ 
			echo "SHOP_IS_LOCK";
			exit;
		}
		else 
		{
			shop_die('lock_shop_admin', 'Shop is locked', __LINE__, $_SERVER['REQUEST_URI']);
		}
	}
	
	
	// Connect
	require_once(SHOP_CWD.'/admin/class/data/class.DataBase.php');
	switch(DB_TYPE)
	{
		case 'Oracle': 
			require_once(SHOP_CWD.'/admin/class/data/class.DataBaseOracle.php');
			$data = new DataBaseOracle($mSimpleError, $mParam);
			break;
		case 'ODBC':
			require_once(SHOP_CWD.'/admin/class/data/class.DataBaseODBC.php');
			$data = new DataBaseODBC($mSimpleError, $mParam);
			break;
		default:
			$data = new DataBase($mSimpleError, $mParam);
	} // switch
	
	// Test for lock shop to updating
	if ( !$mItsUpdate ) $gOptions = $data->GetShopValues();
	if ( !$mItsUpdate && $gOptions['main_available'] == 'False' ) 
	{
		if ( $mSimpleError ) 
		{ 
			echo "SHOP_IS_LOCK";
			exit;
		}
		else 
		{
			shop_die('lock_shop', 'Shop is locked', __LINE__, $_SERVER['REQUEST_URI']);
		}
	}


	// Prepare options
	if ( !$mItsUpdate )
	{
		if ( strlen($gOptions['main_prec']) == 0 ) shop_die('empty_shop', '', __LINE__, $_SERVER['REQUEST_URI']);
		$gOptions['orig_base_curr'] = $gOptions['main_base_curr'];
		$gOptions['orig_prec'] = $gOptions['main_prec'];	
		if ( $_SESSION['payment']['multiplex'] > 0 ) 
		{
	    	$gOptions['main_base_curr'] = $_SESSION['payment']['curr_name'];
			$gOptions['main_prec'] = $_SESSION['payment']['curr_prec'];
		}		
	}


	return $data;
}



/** 
 * Function user_ip
 * Return user's ip-address
 **/
function user_ip() 
{
	if ( $_SERVER['HTTP_X_FORWARDED_FOR'] != '' ) 
	{
		$client_ip = ( !empty($_SERVER['REMOTE_ADDR']) ) ? $_SERVER['REMOTE_ADDR'] : $_ENV['REMOTE_ADDR'];
		$entries = explode(',', $_SERVER['HTTP_X_FORWARDED_FOR']);
		reset($entries);
		while (list(, $entry) = each($entries)) 
		{
			$entry = trim($entry);
			if ( preg_match("/^([0-9]+\.[0-9]+\.[0-9]+\.[0-9]+)/", $entry, $ip_list) ) 
			{
				$gPrivate_ip = array('/^0\./', '/^127\.0\.0\.1/', '/^192\.168\..*/', '/^172\.((1[6-9])|(2[0-9])|(3[0-1]))\..*/', '/^10\..*/', '/^224\..*/', '/^240\..*/');
				$found_ip = preg_replace($gPrivate_ip, $client_ip, $ip_list[1]);
				if ($client_ip != $found_ip) 
				{
					$client_ip = $found_ip;
					break;
				}
			}
		}
	} 
	else 
	{
		$client_ip = ( !empty($_SERVER['REMOTE_ADDR']) ) ? $_SERVER['REMOTE_ADDR'] : $_ENV['REMOTE_ADDR'];
	}

	return $client_ip;
}


/** 
 * Function ip_in_range
 * Return true if ip in range list
 **/
function ip_in_range($mMeIP, $mRangeIPs) 
{
	$ip_exists = false;
	
	$me_ip_part = explode('.', $mMeIP);
	if ( count($me_ip_part) == 4 ) 
	{
		foreach ( $mRangeIPs as $ip )
		{
			$ip_part = explode('.', $ip);
			$ip_exists = true;
			for ( $i = 0; $i <= 3; $i++ )
			{
				if ( $ip_part[$i] == '*' ) continue;
				list ( $start_ip, $end_ip ) = explode('-', $ip_part[$i]);
				if ( $end_ip*1 > 0 )
				{
					if ( $me_ip_part[$i]*1 >= $start_ip*1 && $me_ip_part[$i]*1 <= $end_ip*1 ) continue;
				}
				else 
				{
					if ( $me_ip_part[$i]*1 == $ip_part[$i]*1 ) continue;
				}
				$ip_exists = false;
				break;
			}
			if ( $ip_exists ) break;
		}
	}

	return $ip_exists;
}

/** 
 * Function run_time
 * Return time after start point
 **/
function run_time ($mStartPoint = 0) 
{
	$time = explode(" ", microtime());
    $usec = (double)$time[0];
    $sec = (double)$time[1];
        
	return round($sec + $usec - $mStartPoint, 2);
}

/** 
 * Function echo_page_time
 * Just echo page compilate time
 **/
function echo_page_time($mTime) 
{
	if ( isset($_GET['page_time_on']) ) $_SESSION['page_time'] = true;
	if ( isset($_GET['page_time_off']) ) $_SESSION['page_time'] = false;
	
	if ( $_SESSION['page_time'] ) echo "<center><span style='COLOR: red; FONT-SIZE: 9px; FONT-FAMILY: Arial'>Time of compilate this page: <b>$mTime</b> seconds</span></center>";
	
	return TRUE;
}

/** 
 * Function get_date
 * Return current date
 **/
function get_date() 
{
	return gmdate("Y-m-d", time() + (3600 * SHOP_GMT));
}

/** 
 * Function get_week
 * Return first date of current week
 **/
function get_week() 
{

	$time = time() + (3600 * SHOP_GMT);
	$now_day = gmdate("w", $time);
	if ( $now_day == 0 ) $now_day = 7;
	
	return gmdate("Y-m-d", $time - ($now_day-1)*86400 );
}

/** 
 * Function get_month
 * Return current month date
 **/
function get_month() 
{
	return gmdate("Y-m-1",  time() + (3600 * SHOP_GMT) );
}

/** 
 * Function get_time
 * Return current time
 **/
function get_time() 
{
	return gmdate("H:i:s", time() + (3600 * SHOP_GMT));
}

/** 
 * Function get_now
 * Return current formated date and time
 **/
function get_now($mFormat = "Y-m-d H:i:s") 
{
	return gmdate($mFormat, time() + (3600 * SHOP_GMT));
}

/** 
 * Function make_date
 * Return datetime formated with offset
 **/
function make_date($mOffSet, $mFormat = "Y-m-d H:i:s") 
{
	return gmdate($mFormat, time() + (3600 * SHOP_GMT) + $mOffSet);
}


/** 
 * Function str2low
 * Return string to low case
 **/
function str2low($mString) 
{
	return strtr(strtolower($mString), $gCaseUp, $gCaseLow);
}

/** 
 * Function str2up
 * Return string to up case
 **/
function str2up($mString) 
{
	return strtr(strtolower($mString), $gCaseLow, $gCaseUp);
}



/************************************************************************************************************
 *
 *											Common for shop catalog
 *
 ************************************************************************************************************\

/** 
 * Function shop_session
 * Start shop session with check for searchers
 **/
function shop_session() 
{
	global $gSEUserAgentHave, $gSEUserAgentHaveNot, $gSELockIP ;
	
	if ( !@eregi($gSEUserAgentHaveNot, $_SERVER['HTTP_USER_AGENT']) || @eregi( $gSEUserAgentHave, $_SERVER['HTTP_USER_AGENT']) ) return false;

	if ( ip_in_range(user_ip(), $gSELockIP) ) return false;
	
	session_name(DB_NICK.'_MSS');
	session_start();

	if ( session_id() == 'deleted' )
	{
		@session_destroy();
		setcookie(session_name(), "", time(), "/");
		header("Location: ./");  
		exit;
	}


	
	return true;
}


/** 
 * Function make_back_path
 * Start shop session with check for searchers
 **/
function make_back_path() 
{
	$query_line = ltrim(@ereg_replace('(&?(order_sid|'.session_name().')=[[:alnum:]]+)', '', $_SERVER['QUERY_STRING']), '&');
	if ( strlen($query_line) > 0 ) 
	{
		$path = pathinfo($_SERVER['PHP_SELF']);
		if ( substr($query_line, 0, 4) == 'psu=' && ( $path['basename'] == 'dir.php' || $path['basename'] == 'goods.php' ) )
		{
			$current_path = ( $path['basename'] == 'dir.php' ) ? 'dir_' : 'goods_';
			$current_path .= urlencode(substr($query_line, 4)).'.htm';
		}
		else 
		{	
			$current_path = $_SERVER['PHP_SELF'].'?'.$query_line;
		}
	}		
	else 
	{
		$current_path = $_SERVER['PHP_SELF'];	
	}
	
	if ( $_SESSION['last_path'] != $current_path ) 
	{ 
		$_SESSION['before_path'] = $_SESSION['last_path']; 
		if ( @eregi('dir.php', $_SESSION['before_path']) || 
			 @eregi('goods.php', $_SESSION['before_path']) || 
			 @eregi('index.php', $_SESSION['before_path']) 
		   ) 
		{
			$_SESSION['shop_path'] = $_SESSION['before_path']; 
		}
		else 
		{
			if ( strlen($_SESSION['shop_path']) == 0 ) $_SESSION['shop_path'] = './';
		}
	}
	$_SESSION['last_path'] = $current_path;
}

/** 
 * Function save_shop_stat
 * Save shop statistic
 **/
function save_shop_stat($mPageCode = 'index', $mElemID = 0, $mElemCode = '', $mElemAddCode = '') 
{
	global $gData, $gSE, $gSECharset;
	
	// Common
	$gData->SaveShopStat(session_id(),
						 sprintf("%u\n", ip2long(user_ip())),
						 addslashes($_SERVER['HTTP_REFERER']),
						 addslashes($_SERVER['HTTP_USER_AGENT']),
						 $mPageCode,
						 $mElemID,
						 addslashes($mElemCode),
					 	 get_now() 
					 	 );		
	
	// Topic & Goods
	if ( $mPageCode == 'dir' && $mElemID > 0 )
	{
		$gData->SaveStatTopic(get_date(), get_week(), get_month(), $mElemID);
	}
	if ( $mPageCode == 'search' && strlen($mElemCode) > 0 )
	{
		$words = explode(' ', $mElemCode);
		foreach ($words as $word )
		{
			if ( strlen($word) > 0 ) $gData->SaveStatSearch(get_date(), get_week(), get_month(), addslashes(str2low($word)), addslashes(str2low($mElemCode)));
		}
	}
	if ( $mPageCode == 'goods' && $mElemID > 0 )
	{
		$gData->SaveStatGoods(get_date(), get_week(), get_month(), $mElemID);
	}
	
		$my_url = ( substr($_SERVER['HTTP_HOST'], 0, 4) == 'www.' ) ? substr($_SERVER['HTTP_HOST'], 4) : $_SERVER['HTTP_HOST'];
		$my_url .= dirname($_SERVER['PHP_SELF']);		

		$my_host = ( substr($_SERVER['HTTP_HOST'], 0, 4) == 'www.' ) ? substr($_SERVER['HTTP_HOST'], 4) : $_SERVER['HTTP_HOST'];
		
		$url = parse_url($_SERVER['HTTP_REFERER']);
		$from_url = ( substr($url['host'], 0, 4) == 'www.' ) ? substr($url['host'], 4) : $url['host'];
		$from_url .= $url['path'];
		

	// Save if need Visitor 
	if ( $mPageCode == 'index' || $mPageCode == 'dir' || $mPageCode == 'search' || $mPageCode == 'goods' || $mPageCode == 'descr' || $mPageCode == 'config' ) 
	{
		$my_url = ( substr($_SERVER['HTTP_HOST'], 0, 4) == 'www.' ) ? substr($_SERVER['HTTP_HOST'], 4) : $_SERVER['HTTP_HOST'];
		$my_url .= dirname($_SERVER['PHP_SELF']);		

		$my_host = ( substr($_SERVER['HTTP_HOST'], 0, 4) == 'www.' ) ? substr($_SERVER['HTTP_HOST'], 4) : $_SERVER['HTTP_HOST'];
		
		$url = parse_url($_SERVER['HTTP_REFERER']);
		$from_url = ( substr($url['host'], 0, 4) == 'www.' ) ? substr($url['host'], 4) : $url['host'];
		$from_url .= $url['path'];
		
		$cookie_name = @ereg_replace('[^[:alnum:]]', '_', $my_url.'_visitor');
		$cookie_value = $_COOKIE[$cookie_name]*1;
		if ( get_now('U') > $cookie_value )
		{
			$end_day = gmmktime(23, 59, 59, get_now("m"), get_now("d"), get_now("Y"));
			setcookie($cookie_name, $end_day, time() + 8640*30, '/', '.'.$my_host);
			$visitor = 1;
		}
		else
		{
			$visitor = 0;
		}
		if ( strlen(session_id()) > 0 )	$gData->SaveStatVisitor(get_date(), get_week(), get_month(), $visitor);
		
		// Save visitor from page
		if ( strlen($my_url) > 0 && strlen($from_url) > 0 && substr($from_url, 0, strlen($my_url)) != $my_url )
		{
			define_se_vars();

			$keyword = '';
			$url = parse_url($_SERVER['HTTP_REFERER']);
			$domen = ( substr($url['host'], 0, 4) == 'www.' ) ? substr($url['host'], 4) : $url['host'];
			$domen = strtolower(trim($domen));
	
			if ( strlen($domen) > 0 )
			{
				if ( array_key_exists($domen, $gSE) ) 
				{
					$input = explode('&', $url['query']);
					foreach ($input as $para)
					{
						list ($key, $value) = explode('=', $para);
						if ( $key == $gSE[$domen] ) 
						{
							if ( array_key_exists($domen, $gSECharset) )
							{
								$keyword = iconv($gSECharset[$domen], SHOP_CHARSET, urldecode($value));
							}
							else 
							{
								$keyword = urldecode($value);
							}
							$keyword = str2low($keyword);
							break;
						}
					}
				}
				$gData->SaveStatVisitorFrom(get_date(), 
											get_week(),
											get_month(), 
											addslashes($domen),
											addslashes($keyword)
											);		
											
				// Fix cookies from page for order										
				$cookie_name = @ereg_replace('[^[:alnum:]]', '_', $my_url.'_from_page');
				setcookie($cookie_name, urlencode($_SERVER['HTTP_REFERER']), time() + 8640*365, '/', '.'.$my_host);
			}
		}
	}

	// Save order stat
	if ($mPageCode == 'order' )
	{
		$my_url = ( substr($_SERVER['HTTP_HOST'], 0, 4) == 'www.' ) ? substr($_SERVER['HTTP_HOST'], 4) : $_SERVER['HTTP_HOST'];
		$my_url .= dirname($_SERVER['PHP_SELF']);		
		
		$cookie_name = @ereg_replace('[^[:alnum:]]', '_', $my_url.'_from_page');
		$from_page = urldecode($_COOKIE[$cookie_name]);
		
		$keyword = '';
		$url = parse_url($from_page);
		$domen = ( substr($url['host'], 0, 4) == 'www.' ) ? substr($url['host'], 4) : $url['host'];
		$domen = strtolower(trim($domen));
		
		define_se_vars();
		
		if ( strlen($domen) > 0 )
		{
			if ( array_key_exists($domen, $gSE) ) 
			{
				$input = explode('&', $url['query']);
				foreach ($input as $para)
				{
					list ($key, $value) = explode('=', $para);
					if ( $key == $gSE[$domen] ) 
					{
						if ( array_key_exists($domen, $gSECharset) )
						{
							$keyword = iconv($gSECharset[$domen], SHOP_CHARSET, urldecode($value));
						}
						else 
						{
							$keyword = urldecode($value);
						}
						$keyword = str2low($keyword);
						break;
					}
				}
			}
		
			$gData->SaveStatOrder(get_date(), 
								  get_week(),
								  get_month(), 
								  addslashes($from_page),
								  addslashes($domen),
								  addslashes($keyword),
								  $mElemAddCode,
								  get_now()
								  );		
		}
	}
	
	return true;
}

/** 
 * Function echo_shop_variables
 * Return current formated date and time
 **/
function echo_shop_variables($mPlace, $mParseSections = false) 
{
	global $gTpl, $gData, $gOptions;
	
	// Parse text blocks
	$places = explode(';', $gOptions['main_how_text']);
	foreach ( $places as $key ) $gTpl->Assign($key, '');	
	
	$block = $gData->GetTextBlocks($mPlace);
	$rows = $gData->GetNumRows($block);
	for ( $i = 1 ; $i <= $rows; $i++ )
	{
		$hash = $gData->FetchRow($block);
		$template = @implode('',@file('./'.TEMPLATES.'/text_block/'.$hash[3].'/main.htm'));
		$template = str_replace('{NAME}', htmlspecialchars($hash[0]), $template);
		$gTpl->Append($hash[2], str_replace('{CONTENT}', $hash[1], $template));
	}
	
	
	// Parse sections list
	if ( $mParseSections ) $gTpl->Assign(sections());	
	
	// Parse reserved names
	$ic_value = $_SESSION['payment']['multiplex'];
	$total_sum = $_SESSION['total_sum'];
	if ( $ic_value > 0 ) $total_sum = round($total_sum*$ic_value, 2);
	$gTpl->Assign(array('CURR'			=> htmlspecialchars($gOptions['main_base_curr']),
					    'PHPSESSID'		=> session_name().'='.session_id(),
					    'DATETIME'		=> get_now($gOptions['main_fmt_date_time']),
					    'DATE'			=> get_now($gOptions['main_fmt_date']),
					    'TIME'			=> get_now($gOptions['main_fmt_time']),
					    'DBVERS'		=> $gOptions['main_version'],
					    'VERSION'		=> SCRIPT_VERSION,
					    'UPDATEDATE'	=> date($gOptions['main_fmt_date'], strtotime($gOptions['main_update_time'])),
					    'UPDATETIME'	=> date($gOptions['main_fmt_time'], strtotime($gOptions['main_update_time'])),
					    'LASTMODIFY'	=> gmdate("D, d M Y H:i:s", strtotime($gOptions['main_update_time'])).' GMT',
					    'CHARSET'		=> SHOP_CHARSET,
					    'TEMPLATES'		=> TEMPLATES,
					    'CLIENTNAME' 	=> $_SESSION['client']['login'],
					    'HOWORDER'		=> $_SESSION['how_ordered']*1,
					    'TOTALSUM'		=> number_format($total_sum, $gOptions['main_prec'], "," ,"'"),
					    'BEFOREPATH'	=> $_SESSION['before_path'],
					    'SHOPPATH'		=> $_SESSION['shop_path']
					    ));

	return true;	
}


/** 
 * Function shop_die
 * Returm info message about error and die
 **/
function shop_die($mCode, $mTechCode, $mLine, $mScript) 
{
	global $gMessage, $gMessageCharset;
	
	require_once(SHOP_CWD.'/admin/class/show/class.FastTemplate.php');	
		
	// Init templates
	$tpl = new FastTemplate(SHOP_CWD.'/'.TEMPLATES);
	$tpl->DefineTemplate(array('main' => 'error.htm'));
	$error = htmlspecialchars(iconv($gMessageCharset, SHOP_CHARSET, $gMessage[$mCode]));
	$pos = strpos($mScript, session_name())*1;
	$script = ( $pos != 0 ) ? substr($mScript, 0, $pos-1) : $mScript;
	$tpl->Assign(array('CHARSET' 	=> SHOP_CHARSET,
					   'ERROR'		=> $error,
					   'TECHERROR'	=> htmlspecialchars($mTechCode),
					   'LINE'		=> $mLine,
					   'URL'		=> $mScript,
					   'PATH'		=> FOLDER,
					   'TEMPLATES'	=> TEMPLATES,
					   'SCRIPT'		=> $script
					   ));
					   
	$tpl->Parse('MAIN', 'main');
	$tpl->FastPrint('MAIN');	
	
	exit;
}


/** 
 * Function use_php_mod
 * Connect additional php files (modules) to project
 **/
function use_php_mod($mPageType) 
{
	$handle = opendir('./php_mod/');
	while ( $file = readdir($handle) )
	{ 
		if ( $file != "." && $file != ".." && substr($file, 0, 3) == 'mod' && substr($file, -3) == 'php' )
		{ 
			require_once('./php_mod/'.$file);
			eval(basename($file, '.php').'(\''.$mPageType.'\');');
		}
	}
	closedir($handle); 	
}


// Define vars for function HTML2Text

$gSearchHTML = array ("'<script[^>]*?>.*?</script>'si", 
 	   	              "'<[\/\!]*?[^<>]*?>'si",
                 	  "'([\r\n])[\s]+'", 
                 	  "'&(quot|#34);'i",
	                  "'&(amp|#38);'i",
                 	  "'&(lt|#60);'i",
	                  "'&(gt|#62);'i",
    	              "'&(nbsp|#160);'i",
	                  "'&(iexcl|#161);'i",
    	              "'&(cent|#162);'i",
        	          "'&(pound|#163);'i",
	                  "'&(copy|#169);'i",
    	              "'&#(\d+);'e");
$gReplaceText = array ("",
	                   "",
	                   "\\1",
	                   "\"",
	                   "&",
	                   "<",
	                   ">",
                  	   " ",
	                   chr(161),
	               	   chr(162),
	                   chr(163),
    	               chr(169),
        	           "chr(\\1)");

/** 
 * Function html2text
 * Covert HTML string code to text string
 **/
function html2text($mHTMLString) 
{
	global $gSearchHTML, $gReplaceText;
        	          
	return preg_replace ($gSearchHTML, $gReplaceText, $mHTMLString);
}


/** 
 * Function emo2img
 * Convert emotion text to image name
 **/
function emo2img($mText) 
{
	// Define emo
	$emo = array (':!:' 		=> 'icon_exclaim.gif',
				  ':?:'			=> 'icon_question.gif',
				  ':idea:' 		=> 'icon_idea.gif',
				  ':arrow:' 	=> 'icon_arrow.gif',
				  ':grin:' 		=> 'icon_biggrin.gif',
				  ':smile:' 	=> 'icon_smile.gif',
				  ':sad:' 		=> 'icon_sad.gif',
				  ':eek:' 		=> 'icon_surprised.gif',
				  ':shock:' 	=> 'icon_eek.gif',
				  ':???:' 		=> 'icon_confused.gif',
				  ':cool:' 		=> 'icon_cool.gif',
				  ':lol:' 		=> 'icon_lol.gif',
				  ':mad:' 		=> 'icon_mad.gif',
				  ':razz:' 		=> 'icon_razz.gif',
				  ':oops:' 		=> 'icon_redface.gif',
				  ':cry:' 		=> 'icon_cry.gif',
				  ':evil:' 		=> 'icon_evil.gif',
				  ':twisted:' 	=> 'icon_twisted.gif',
				  ':roll:' 		=> 'icon_rolleyes.gif',
				  ':wink:' 		=> 'icon_wink.gif',
				  ':neutral:' 	=> 'icon_neutral.gif',
				  ':mrgreen:' 	=> 'icon_mrgreen.gif',
				  ':D' 			=> 'icon_biggrin.gif',
				  ':-D' 		=> 'icon_biggrin.gif',
				  ':)' 			=> 'icon_smile.gif',
				  ':-)' 		=> 'icon_smile.gif',
				  ':(' 			=> 'icon_sad.gif',
				  ':-(' 		=> 'icon_sad.gif',
				  ':o' 			=> 'icon_surprised.gif',
				  ':-o' 		=> 'icon_surprised.gif',
				  ':?' 			=> 'icon_confused.gif',
				  ':-?' 		=> 'icon_confused.gif',
				  '8)' 			=> 'icon_cool.gif',
				  '8-)' 		=> 'icon_cool.gif',
				  ':x' 			=> 'icon_mad.gif',
				  ':-x' 		=> 'icon_mad.gif',
				  ':P' 			=> 'icon_razz.gif',
				  ':-P' 		=> 'icon_razz.gif',
				  ';)' 			=> 'icon_wink.gif',
				  ';-)' 		=> 'icon_wink.gif',
				  ':|' 			=> 'icon_neutral.gif',
				  ':-|' 		=> 'icon_neutral.gif'
				  );

	foreach ( $emo as $key => $value )
	{
		$mText = str_replace($key, '<img src="./images/emo/'.$value.'" border=0 align="absmiddle" vspace=2 hspace=2>', $mText);
	}
	
	return $mText;
}				  


?>