<?php

/**
 * filter.php
 * ----------
 * @version 5.4.0
 * @copyright 2002-2010 Melbis Company
 * @link http://www.melbis.com
 * @author Dmitriy Kasyanov
 **/
 

/**
 * Function filters
 * Return array text blocks with filers
 **/
function filters($mType, $mPath, $mTotalGoods = 1000, $mIsSelectPage = false)
{
	global $gData, $gOptions, $gPage;
	
	// init vars
	$dir[0] = 'table';
	$dir[1] = 'list';
	$dir[2] = 'menu';
	$filter_key = '';
	$parse = array();
	$places = explode(';', $gOptions['main_how_filter']);
	foreach ( $places as $key ) $parse[$key] = '';
	if ( strlen($_GET['filter']) > 0 ) 
	{
		$init_filters = explode('and', $_GET['filter']); 
		foreach ($init_filters as $filter_id) 
		{
		    if ( $filter_id*1 == 0 ) continue;
			$init_values[$filter_id*1] = explode('or', $_GET['filter'.$filter_id]);
		}
	}
	else
	{
		$init_filters = array();
	}
	// Get filters	
	$filter = ( $mType == 'dir' ) ? $gData->GetFilterGoods() : $gData->GetFilterIndex();
	$rows = $gData->GetNumRows($filter);	
	for ( $i = 1; $i <= $rows; $i++ )
	{
		$hash = $gData->FetchRow($filter);
		// Init templates
		$tpl = new FastTemplate('./'.TEMPLATES.'/filter/'.$hash[8].'/'.$dir[$hash[4]]);
		$tpl->DefineTemplate(array('main' 			=> 'main.htm',  	 
				 				   'unit'			=> 'unit.htm',
				    			   'unit_empty'		=> 'unit_empty.htm',
								   'unit_sel'		=> 'unit_sel.htm',
								   'between_row'	=> 'between_row.htm',
								   'icon'			=> 'icon.htm'
								   ));
		// Parse only all filters
		$sense_to_parse = ($mTotalGoods > 0 && !$mIsSelectPage);
		if ( ($mType == 'dir') && ($hash[6] != 1) && (!$sense_to_parse) ) continue;
		// Is no select page option
		if ( $hash[10] == 1 && $mIsSelectPage ) continue;		
		// All goods on page option
		if ( $hash[11] == 1 && ( $mTotalGoods <= $gPage['step_goods'] ) ) continue;		
		// Get filters values
		if ( ($mType == 'dir') && ($hash[6] != 1) )
		{
			$value = $gData->GetFilterValuesGoods($hash[1]);
		}
		else 
		{
			$value = $gData->GetFilterValuesIndex($hash[1]);
		}
		$value_rows = $gData->GetNumRows($value);								   
		$col_cnt = 1;	
		if ( $value_rows == 0 ) continue;
		// One more option
		if ( $hash[9] == 1 && $value_rows == 1 ) continue;		
		// start parse filters values		   
		for ( $n = 1; $n <= $value_rows; $n++ )
		{
			$hash_value = $gData->FetchRow($value);
			if ( ( $col_cnt == $hash[3] || $hash[4] > 0 ) && ($n <> $value_rows)) 
			{
				$tpl->Parse('BETWEENROW', 'between_row');  
				$col_cnt = 1; 
			} 
			else 
			{ 
				$tpl->Assign('BETWEENROW', ''); 
				$col_cnt += 1; 
			}		
			$tpl->Assign('NAME', htmlspecialchars($hash_value[1]));
			// make icons
			if ( ( $hash[4] != 2 ) && ( is_file('./files/info_value'.$hash_value[0].'.jpg') ) ) 
			{
			    $tpl->Assign('URL', 'files/info_value'.$hash_value[0].'.jpg');
				$tpl->Parse('ICON', 'icon');
			} 
			else
			{
				$tpl->Assign('ICON', '');
			}
			// Make link
			$filters = $init_filters;
			$values = $init_values;
			if ( !in_array($hash[1], $filters) ) 
			{
			    array_push($filters, $hash[1]);
			}
			if ( !is_array($values[$hash[1]]) ) 
			{
			    $values[$hash[1]] = array();
			}
			if ( !in_array($hash_value[0], $values[$hash[1]]) ) 
			{
				if ( $hash[4] == 2 ) $values[$hash[1]] = array();
				$unit_sel = FALSE;
				array_push($values[$hash[1]], $hash_value[0]);
				
			}
			else
			{
			    $unit_sel = TRUE;
				unset($values[$hash[1]][array_search($hash_value[0], $values[$hash[1]])]);
			}
			if ( $hash[6] != 1 )
			{
				$link_add = $mPath;
				$link_one = $mPath;
			}
			else 
			{
				$link_add = 'dir.php?search_words=';
				$link_one = 'dir.php?search_words=';
			}
			foreach ($values as $key => $val)
			{
				if ( count($val) > 0) 
				{
				    if ( $key == $hash[1] ) 
					{
				        $link_one.= '&filter'.$key.'='.$hash_value[0];
				    }
					else
					{
						$link_one .= '&filter'.$key.'='.implode('or', $val);
					}
					$link_add .= '&filter'.$key.'='.implode('or', $val);
				}
				else
				{
					unset($filters[array_search($key, $filters)]);
				}
			}
			if ( count($filters) > 0 ) 
			{
			    $link_add .= '&filter='.implode('and', $filters);
				$link_one .= '&filter='.implode('and', $filters);
			}
			$tpl->Assign(array('LINKADD'	=> $link_add,
							   'LINKONE'	=> $link_one
								));
			
			// Parse unit
			if ( $unit_sel ) 
			{
				$tpl->Parse('UNIT', '.unit_sel');
				$filter_key .= ' '.htmlspecialchars($hash_value[1]);
			}
			else 
			{
				$tpl->Parse('UNIT', '.unit');
			}
		}	
		// Parsing empty units  
		if ( $hash[4] == 0 && $value_rows > $hash[3] ) 
		{
			for ( $n = $col_cnt; $n <= $hash[3]; $n++ ) 
			{
				$tpl->parse('UNIT', '.unit_empty');
			}		
		}
		$tpl->Assign(array('COLSPAN'	=> $hash[3],
						   'ID'			=> $hash[1],
						   'NAME'		=> htmlspecialchars($hash[12])
						  ));
		$tpl->Parse('MAIN', 'main');
		$parse[$hash[2]] .= $tpl->Fetch('MAIN');

		// Filter key	
		$parse['FILTERKEY'] = $filter_key;
	}
	
	return $parse;
}

/**
 * Function select
 * Return select window
 **/
function select($mTopic)
{
	global $gData, $gPage;
	
	// Get info for filters
	$info = $gData->GetInfoTopicFilter($mTopic);
	$info_rows = $gData->GetNumRows($info);
	if ( $info_rows == 0 ) return '';
	
	// init vars
	$dir[0] = 'table';
	$dir[1] = 'list';
	$dir[2] = 'menu';
	if ( strlen($_GET['filter']) > 0 ) 
	{
		$init_filters = explode('and', $_GET['filter']); 
		foreach ($init_filters as $filter_id) 
		{
		    if ( $filter_id*1 == 0 ) continue;
			$init_values[$filter_id*1] = explode('or', $_GET['filter'.$filter_id]);
		}
	}
	
	// Parse info-select tree
	$tpl = new FastTemplate('./'.TEMPLATES.'/_dir/'.$gPage['select_dir_name']);
	$tpl->DefineTemplate(array('main' => 'main.htm',  	 
				 			   'unit' => 'unit.htm'
							   ));
	$allow = array();
	$filter_code = '';
	for ( $i = 1; $i <= $info_rows; $i++ ) 
	{			
		$hash = $gData->FetchRow($info);
		if ( (strlen($hash[5]) > 0) || ($allow[$hash[0]] == 1) ) 
		{
			$allow[$hash[3]] = 1;
			if ( $hash[4] != 1 )
			{
				// Get filters values
				$value = $gData->GetTopicFilterValues($hash[0], $mTopic);
				$value_rows = $gData->GetNumRows($value);								   
				if ( $value_rows == 0 ) continue;
								
				// Parse filter start
				$filter_code .= $hash[0].'I';

				// Init templates
				$tpl_sub = new FastTemplate('./'.TEMPLATES.'/_dir/'.$gPage['select_dir_name'].'/'.$dir[$hash[7]]);
				$tpl_sub->DefineTemplate(array('main' 			=> 'main.htm',  	 
				 				   			   'unit'			=> 'unit.htm',
				 				   			   'unit_empty'		=> 'unit_empty.htm',
				 				   			   'unit_sel'		=> 'unit_sel.htm',
				 				   			   'between_row'	=> 'between_row.htm',
				 				   			   'icon'			=> 'icon.htm'
				 				   			   ));
				$col_cnt = 1;
				$value_code = '';
				
				// start parse filters values	
				$tpl_sub->Assign('UNIT', '');	   
				for ( $n = 1; $n <= $value_rows; $n++ )
				{
					$hash_value = $gData->FetchRow($value);
					if ( ( $col_cnt == $hash[6] || $hash[7] > 0 ) && ($n <> $value_rows) ) 
					{
						$tpl_sub->Parse('BETWEENROW', 'between_row');  
						$col_cnt = 1; 
					} 
					else 
					{ 
						$tpl_sub->Assign('BETWEENROW', ''); 
						$col_cnt += 1; 
					}		
					$tpl_sub->Assign(array('NAME'		=> htmlspecialchars($hash_value[1]),
							   		   	   'VALUEID'	=> $hash_value[0]
										   ));
					// make icons
					if ( ( $hash[7] != 2 ) && ( is_file('./files/info_value'.$hash_value[0].'.jpg') ) ) 
					{
			    		$tpl_sub->Assign('URL', 'files/info_value'.$hash_value[0].'.jpg');
						$tpl_sub->Parse('ICON', 'icon');
					} 
					else
					{
						$tpl_sub->Assign('ICON', '');
					}
					// Parse unit
					if ( is_array($init_values[$hash[0]]) )
					{
						( in_array($hash_value[0], $init_values[$hash[0]]) ) ? $tpl_sub->Parse('UNIT', '.unit_sel') 
																		 	 : $tpl_sub->Parse('UNIT', '.unit');
					}
					else 
					{
						$tpl_sub->Parse('UNIT', '.unit');
					}
					$value_code .= $hash_value[0].'I';
				}	
			
				// Parsing empty units  
				if ( $hash[7] == 0 && $value_rows > $hash[6] ) 
				{
					for ( $n = $col_cnt; $n <= $hash[6]; $n++ ) 
					{
						$tpl_sub->Parse('UNIT', '.unit_empty');
					}		
				}
				$tpl_sub->Assign(array('COLSPAN'	=> $hash[6],
								   	   'INFOID'		=> $hash[0],
								   	   'VALUECODE'	=> $value_code
								  	   ));
				$tpl_sub->Parse('MAIN', 'main');
				$tpl->Assign('FILTER', $tpl_sub->Fetch('MAIN'));
				// Parse filter end
			}
			else
			{
				$tpl->Assign('FILTER', '');
			}
			$tpl->Assign(array('NAME'		=> htmlspecialchars($hash[1]),
		                	   'LEVEL'		=> $hash[2]
							  ));			
			$tpl->Parse('UNIT', ',unit');
		}
		$tpl->Assign(array('NAME'		=> $gPage['select_name'],
		               	   'FILTERCODE'	=> $filter_code,
		               	   'TOPIC'		=> $mTopic,
		               	   'PRICEFROM'	=> htmlspecialchars($_GET['price_from']),
		               	   'PRICETO'	=> htmlspecialchars($_GET['price_to'])
						  ));			
		
	}
	if ( count($allow) > 0 ) 
	{
		    $tpl->Parse('MAIN', 'main');
			return $tpl->Fetch('MAIN');
	}
	else
	{
		return '';
	}	
	
}

?>