<?php

/**
 * goods.php
 * ---------
 * @version 5.4.0
 * @copyright 2002-2010 Melbis Company
 * @link http://www.melbis.com
 * @author Dmitriy Kasyanov
 **/
 

/**
 * Function can_buy_now
 * Testing can buy now?
 **/
function can_buy_now($mStoreID, $mCacheBaseParam)
{
	global $gData;
	
	if ( $mCacheBaseParam == -1 )
	{
		$mCacheBaseParam = $gData->CalcBaseParamGoods($mStoreID);
		$gData->UpdateGoodsCache($mStoreID, 'cache_base_param', $mCacheBaseParam);
	}
	
	return ( $mCacheBaseParam == 0 );
}
 
 
/**
 * Function calc_goods_price
 * Calc the goods price offer on catalog pages
 **/
function calc_goods_price($mStoreID, $mPrice, $mDiscPrice, $mHow = 1)
{
	global $gData;
	
	$client_proc = $_SESSION['client']['proc'];
	$client_category = $_SESSION['client']['category_id'];	
	$price = $mPrice;
	$price_offer = 'price_simple';
		
	// Client special
	if ( $client_category > 0 || $client_proc > 0 )
	{
		// Discount system
		list($disc_proc, $disc_suma) = $gData->GetGoodsDiscParam($mStoreID, $mHow, $client_category);
		$new_price = round($price*(1 - $disc_proc/100) - $disc_suma, 2);		
		if ( $price == $new_price )
		{
			$disc_proc = $client_proc;
			$new_price = round($price*(1 - $client_proc/100), 2);
		}	
		if ( $price != $new_price) $price_offer = 'price_client';
	}
	// Simple client
	else
	{
		// Total sale
		if ( ( $mDiscPrice > 0 ) && ( $price != 0 ) ) 
		{
			$disc_proc = round(100 - 100*$mDiscPrice/$price, 2);
			$new_price = $mDiscPrice;
			$price_offer = 'price_new';
		}
		// Discount system
		else 
		{
			list($disc_proc, $disc_suma) = $gData->GetGoodsDiscParam($mStoreID, $mHow, 0);
			$new_price = round($price*(1 - $disc_proc/100) - $disc_suma, 2);			
			if ( $price != $new_price ) $price_offer = 'price_new';
		}	
	}
	return array($new_price, $disc_proc, $disc_suma, $price_offer);
} 
 
 
/**
 * Function main_goods
 * Return text block of main goods
 **/
function main_goods($mGoods, $mHow, $mFrom, $mStep, $mCol, $mTemplate)
{
	global $gData, $gOptions;
	
	// Init templates
	$tpl = new FastTemplate('./'.TEMPLATES.'/goods');
	$tpl->DefineTemplate(array('main' 			=> $mTemplate.'/main.htm',  	 
			 				   'unit'			=> $mTemplate.'/unit.htm',
							   'between_row'	=> $mTemplate.'/between_row.htm',
							   'link_order'		=> $mTemplate.'/link_order.htm',
							   'no_order'		=> $mTemplate.'/no_order.htm',
							   'order_form'		=> $mTemplate.'/order_form.htm',
							   'price_client'	=> $mTemplate.'/price_client.htm',
							   'price_new'		=> $mTemplate.'/price_new.htm',
							   'price_simple'	=> $mTemplate.'/price_simple.htm',
							   'apendix_name'	=> $mTemplate.'/apendix_name.htm',
							   'status0'		=> $mTemplate.'/status0.htm',
							   'status1'		=> $mTemplate.'/status1.htm',
							   'status2'		=> $mTemplate.'/status2.htm',
							   'status3'		=> $mTemplate.'/status3.htm',
							   'status4'		=> $mTemplate.'/status4.htm',
							   'voice'			=> $mTemplate.'/voice.htm',
							   'voice_put'		=> $mTemplate.'/voice_put.htm',
			    			   'new'			=> $mTemplate.'/new.htm',
			    			   'hit'			=> $mTemplate.'/hit.htm'
							  ));
	// Get all info keynames
	$info_key = $gData->GetInfoAllKeyName('in_main');
	$info_key_rows = $gData->GetNumRows($info_key);
		
	// Start parse goods
	$col_cnt = 1; 
	$ic_value = $_SESSION['payment']['multiplex'];
	$gData->DataSeek($mGoods, $mFrom);
	$end = $mStep;
	if ( $mHow < ($mFrom + $mStep) ) 
	{ 
		$end = $mHow - $mFrom; 
	}
	$line = 1;
	for ( $i = 1; $i <= $end; $i++ ) 
	{
		$hash = $gData->FetchRow($mGoods);
		// Parse info keynames
		$gData->DataSeek($info_key, 0);
		for ( $n = 1; $n <= $info_key_rows; $n++ ) 
		{			
			$hash_key = $gData->FetchRow($info_key);
			$tpl->Assign($hash_key[0], '');
		}
		// Parse info tree
		$info = $gData->GetInfoGoods($hash[0], 'in_main');
		$info_rows = $gData->GetNumRows($info);
		if ( $info_rows > 0 ) 
		{ 
			$tpl_sub = new FastTemplate('./'.TEMPLATES.'/goods/'.$mTemplate.'/info');
			$tpl_sub->DefineTemplate(array('main' 		=> 'main.htm',  	 
					 				   	   'unit'		=> 'unit.htm',
					 				   	   'icon'		=> 'icon.htm',
					 				   	   'descr'		=> 'descr.htm',
					 				   	   'elem_file'	=> 'elem_file.htm',
					 				   	   'elem_folder'=> 'elem_folder.htm'
									   	   ));
			$allow = array();
			$line = 0;
			for ( $n = 1; $n <= $info_rows; $n++ ) 
			{			
				$hash_info = $gData->FetchRow($info);
				if ( (strlen($hash_info[5]) > 0) || ($allow[$hash_info[0]] == 1) ) 
				{
					if ( $hash_info[8] > 0 ) 
					{
						$tpl_sub->Assign('ID', $hash_info[0]);
						$tpl_sub->Parse('DESCR', 'descr');	
					}
					else 
					{
						$tpl_sub->Assign('DESCR', '');
					}
					if ( $hash_info[4] == 1)
					{
						$tpl_sub->Assign(array('NAME'	=> htmlspecialchars($hash_info[1]),
											   'LEVEL'	=> $hash_info[2],
											   'LINE'	=> ( $line % 2 )
											   ));
						$tpl_sub->Parse('ELEMENT', 'elem_folder');
					}
					else 
					{
						$icon_exists = is_file('./files/info_value'.$hash_info[7].'.jpg');
						$value = htmlspecialchars($hash_info[5]);
						if ( strpos($hash_info[5], 'ftp://') !== false || strpos($hash_info[5], 'http://') !== false ) 
						{
							if ( strlen($value) > 30 ) $value = substr($value, 0, 30).'...';
							$value = '<a href="'.$hash_info[5].'" target=_blank>'.$value.'</a>';
						}						
						$tpl_sub->Assign(array('NAME'	=> htmlspecialchars($hash_info[1]),
			            	       		 	   'VALUE'	=> $value,
											   'LEVEL'	=> $hash_info[2],
											   'URL'	=> './files/info_value'.$hash_info[7].'.jpg',
											   'LINE'	=> ( $line % 2 )
											   ));
						if ( $icon_exists ) $tpl_sub->Parse('VALUE', ',icon');						
						$tpl_sub->Parse('ELEMENT', 'elem_file');
					}
					if ( strlen($hash_info[3]) > 0 ) 
					{
						$tpl->Assign($hash_info[3], $tpl_sub->Fetch('VALUE'));
					}
					else 
					{
						$allow[$hash_info[6]] = 1;
						$tpl_sub->Parse('UNIT', ',unit');
						$line++;
					}
				}
			}
			if ( count($allow) > 0 ) 
			{
			    $tpl_sub->Parse('MAIN', 'main');
				$tpl->Assign('INFO', $tpl_sub->Fetch('MAIN'));
			}
			else
			{
				$tpl->Assign('INFO', '');
			}
		}
		else
		{
			$tpl->Assign('INFO', '');
		}
		
		// Calc prices
		list($new_price, $disc_proc, $disc_suma, $price_offer) = calc_goods_price($hash[0], $hash[6], $hash[11]);
		$can_buy = can_buy_now($hash[0], $hash[29]);
		$price = $hash[6];
		$left_sum = $price - $new_price;

		// Parsing parameters
		$tpl->Assign('PARAM', '');
		if ( $gOptions['dir_get_param'] == 'True' ) 
		{
		    $need_param = false;
			$param = $gData->GetParamGoods($hash[0]);
			$param_rows = $gData->GetNumRows($param);
			$param_base_exists = false;
			$param_code = '';
			if ( $param_rows > 0 ) 
			{ 			
				$tpl_sub = new FastTemplate('./'.TEMPLATES.'/goods/'.$mTemplate.'/param');
				$tpl_sub->DefineTemplate(array('main' => 'main.htm'));
				for ( $n = 1; $n <= $param_rows; $n++ ) 
				{			
					$hash_param = $gData->FetchRow($param);				
					if ( $hash_param[2] == 0) 
					{
					    // Select value will be in pop-up window
						$file = 'form';
						$options = '';
						$values_how = '';
					}
					else
					{
						// Select value through combobox
						$file = 'list';
						$values = $gData->GetParamGoodsValues($hash[0], $hash_param[0], $hash[23]);
						$val_rows = $gData->GetNumRows($values);
						$options = '';
						$values_how = '';
						for ( $m = 1; $m <= $val_rows; $m++ )
						{
							$hash_value = $gData->FetchRow($values);
							if ( strlen($hash_value[5]) > 0 ) 
							{
								// Special fixed price for "real goods" or add price for "modification"
								if ( $hash_value[7] == 1 ) continue; 
								if ( $hash_param[9] == 0 ) 
								{
									// Phis type of param is "real goods"
									$add_price = round($hash_value[5]*(1-$disc_proc/100), 2) - ($disc_suma+$new_price);
								}
								else 
								{
									// Phis type of param is "modification"
									$add_price = $hash_value[5];
									$add_price = round($add_price*(1-$disc_proc/100), 2);
								}
							}
							else
							{
								// Price calc with proc and sum
								if ( $hash_param[9] == 0 )
								{
									// Phis type of param is "real goods"
									$param_price = round($price*(1+$hash_value[3]/100), 2)+$hash_value[4];
									$add_price = round($param_price*(1-$disc_proc/100), 2) - ($disc_suma+$new_price);
								}
								else 
								{
									// Phis type of param is "modification"
									$add_price = round($price*$hash_value[3]/100, 2)+$hash_value[4];
									$add_price = round($add_price*(1-$disc_proc/100), 2);
								}
							}
							$sum_price = $add_price + $new_price;
							$sign = '';
							if ( $add_price >= 0 ) 
							{
							    $sign = '+';
							}
							if ( $ic_value > 0 ) 
							{
								$add_price = round($add_price*$ic_value, 2);
								$sum_price = round($sum_price*$ic_value, 2);
							}								
							$options .= '<option value="'.$hash_value[0].'">'.
										htmlspecialchars($hash_value[1]).' ['.
										$sign.number_format($add_price, $gOptions['main_prec'], "," ,"'").
										' {CURR}]</option>';
							$values_how .= '<input type="hidden" name="param'.$hash_param[0].
										   '_value'.$hash_value[0].'_how" value="'.$hash_value[8].'">';
							$values_how .= '<input type="hidden" name="param'.$hash_param[0].'_value'.
											$hash_value[0].'_price" value="'.
											number_format($sum_price, $gOptions['main_prec'], "." ,"").'">';
						} 
					}
					$tpl_sub->ClearTpl('unit');
					$tpl_sub->DefineTemplate(array('unit' => $file.'.htm'));
					$tpl_sub->Assign(array('NAME'		=> htmlspecialchars($hash_param[1]),
										   'STOREID'	=> $hash[0],
			                   		 	   'ID'			=> $hash_param[0],
			                   		 	   'GRPID'		=> $hash_param[9],
			                   		 	   'GRPTYPE'	=> ( $hash_param[9] == 0 ) ? 'radio' : 'checkbox',
										   'OPTIONS'	=> $options,
										   'VALUESHOW'	=> $values_how,
										   'WINSIZE'	=> $hash_param[5].','.$hash_param[6].','.
										   				   $hash_param[7].','.$hash_param[8] 
										   ));
					$param_code .= $hash_param[0].'I';
					if ( $hash_param[9] == 0 ) $param_base_exists = true;
					$tpl_sub->Parse('UNIT', '.unit');
				}
				$tpl_sub->Assign('PARAMCODE', $param_code);
				$tpl_sub->Parse('MAIN', 'main');
				$tpl->Assign('PARAM', $tpl_sub->Fetch('MAIN'));
			}
		}
		else
		{	
			if ( $hash[32] == -1 )
			{
				$hash[32] = $gData->GetNeedParam($hash[0]);
				$gData->UpdateGoodsCache($hash[0], 'cache_param', $hash[32]);
			}
			$need_param = ( $hash[32] > 0 );
		}
			
		// Testing for needed link to other goods information	
		// info
		if ( $hash[30] == -1 )
		{
			$hash[30] = $gData->GetNeedInfo($hash[0]);
			$gData->UpdateGoodsCache($hash[0], 'cache_info_preview', $hash[30]);
		}
		$need_info = ( $hash[30] > 0 );
		$need_info = $need_info && !( is_file('./files/apendix'.$hash[0].'.htm') && $gOptions['main_descr_info'] == 'True');
		// discount
		if ( $hash[33] == -1 )
		{
			$hash[33] = $gData->GetGoodsDiscounts($hash[0], $_SESSION['client']['category_id']);
			// $hash[33] = $gData->GetNeedDiscount($hash[0]);
			$gData->UpdateGoodsCache($hash[0], 'cache_disc', $hash[33]);
		}
		$need_discount = ( $hash[33] > 0 );		
		// complectation
		$need_comp = ( $hash[19] == 2 );
		// family
		if ( $hash[31] == -1 )
		{
			$hash[31] = $gData->GetNeedFamily($hash[20]);
			$gData->UpdateGoodsCache($hash[0], 'cache_family', $hash[31]);
		}
		$need_family = ( $hash[31] > 1 );
		// advert
		if ( $hash[34] == -1 )
		{
			$hash[34] = $gData->GetNeedAdvert($hash[0]);
			$gData->UpdateGoodsCache($hash[0], 'cache_advert', $hash[34]);
		}
		$need_advert = ( $hash[34] > 0 );
		
		// Parsing more
		if ( $need_info || $need_discount || $need_comp || $need_family || $need_advert ) 
		{
			$tpl_sub = new FastTemplate('./'.TEMPLATES.'/goods/'.$mTemplate.'/more');
			$tpl_sub->DefineTemplate(array('main'		=> 'main.htm',
							   			   'comp'		=> 'comp.htm',
							   			   'disc'		=> 'disc.htm',
							   			   'family'		=> 'family.htm',
							   			   'info'		=> 'info.htm',
							   			   'advert'		=> 'advert.htm'
							   			  ));		    
			if ( $need_info ) $tpl_sub->Parse('UNIT', '.info');
			if ( $need_discount ) $tpl_sub->Parse('UNIT', '.disc');
			if ( $need_advert ) $tpl_sub->Parse('UNIT', '.advert');
			if ( $need_comp ) $tpl_sub->Parse('UNIT', '.comp');
			if ( $need_family ) $tpl_sub->Parse('UNIT', '.family');
			$tpl_sub->Parse('MAIN', 'main');
			$tpl->Assign('MORE', $tpl_sub->Fetch('MAIN'));
		}
		else
		{
			$tpl->Assign('MORE', '');
		}
		
		// Parse between row
		if ( $col_cnt == 1 ) $line++;
		if ( ($col_cnt == $mCol) && ($i <> $end) ) 
		{
			$tpl->Parse('BETWEENROW', 'between_row');  
			$col_cnt = 1; 
		} 
		else 
		{ 
			$tpl->Assign('BETWEENROW', ''); 
			$col_cnt += 1; 
		}
		// Parse icon
		if ( is_file('./files/store'.$hash[0].'.jpg') ) 
		{
		    $img_file = 'files/store'.$hash[0].'.jpg';
		} 
		else
		{
			$img_file = 'files/store_default.jpg';
		}
		$link = ( strlen($hash[28]) > 0 ) ? 'goods_'.urlencode($hash[28]).'.htm' : 'goods.php?id='.$hash[0];
		$tpl->Assign('LINK', $link);
		// Parse apendix
		if ( is_file('./files/apendix'.$hash[0].'.htm') ) 
		{
		    if ( $hash[13] == 0) 
			{
		        
				$link_app = ( strlen($hash[28]) > 0 ) ? 'descr_'.urlencode($hash[28]).'.htm' : 'descr.php?id='.$hash[0];
				$apendix_link = ' href="'.$link_app.'" ';
	        	$apendix_link .= ' onclick="ShowApendix('."$hash[0], $hash[15], $hash[16], $hash[17], $hash[18]".'); return false;" ';	        		
				$tpl->Assign('APENDIXLINK', $apendix_link);
		    }
			else
			{
				$tpl->Assign('APENDIXLINK', "href=\"$link\"");
			}
			$tpl->Parse('APENDIXNAME', 'apendix_name');
		} 
		else
		{
			$tpl->Assign(array('APENDIXNAME'	=> '', 
							   'APENDIXLINK'	=> ''
							   ));
		}

		// Info currency
		if ( $ic_value > 0 ) 
		{
			$price = round($price*$ic_value, 2);
			$new_price = round($new_price*$ic_value, 2);
			$left_sum = round($left_sum*$ic_value, 2);
		}	
		
		// Parsing voices
		if ( $gOptions['goods_comm_allow'] == 'True' )
		{
			if ( $hash[27] > 0 )
			{
				$tpl->Assign(array('AVGCOMM'	=> number_format($hash[26], 1, "," ,""),
					   		   	   'HOWCOMM'	=> $hash[27]));
				$tpl->Parse('VOICE', 'voice');
			}
			else 
			{
				$tpl->Parse('VOICE', 'voice_put');
			}
		}
		else 
		{
			$tpl->Assign('VOICE', '');
		}		
		
		// Price offer
		$tpl->Assign(array('PRICE'		=> number_format($price, $gOptions['main_prec'], "," ,"'"),
						   'NEWPRICE'	=> number_format($new_price, $gOptions['main_prec'], "," ,"'"),
						   'LEFTSUM'	=> number_format($left_sum, $gOptions['main_prec'], "," ,"'"),
				   		   'CALCPRICE'	=> number_format($new_price, $gOptions['main_prec'], "." ,""),
						   'STOREID'	=> $hash[0]
						   ));
		$tpl->Parse('PRICEOFFER', $price_offer);
		
		// Order form
		if ( $hash[4] == 1 ) 
		{
		    $tpl->Parse('ORDER', 'no_order');
		}
		else
		{
			if ( $need_param ) 
			{
		    	$tpl->Parse('ORDER', 'link_order');
			}
			else
			{
				// max order goods
				$max_order = ( $param_base_exists ) ? '?' : $hash[23];
				$tpl->Assign(array('CALCPRICE'	=> number_format($new_price, $gOptions['main_prec'], "." ,""),
							   	   'SUMA'		=> number_format($new_price*$hash[9], $gOptions['main_prec'], "." ,""),
								   'STEPORDER'	=> $hash[8],
								   'MINORDER'	=> $hash[9],
								   'MAXORDER'	=> $max_order
								   ));			
				$tpl->Parse('ORDER', 'order_form');
			}
		}
		
		// Parse status
		if ( $param_base_exists )
		{
			$tpl->Parse('STATUS', 'status4');
		}
		else 
		{
			$tpl->Parse('STATUS', 'status'.$hash[4]);
		}
		
		// Echo unit
		$tpl->Assign(array('CODE'		=> htmlspecialchars($hash[1]),
		                   'NAME'		=> htmlspecialchars($hash[3]),
				   		   'NOTE'   	=> $hash[5],
						   'ICON'		=> $img_file,
						   'MEAS'		=> htmlspecialchars($hash[2]),
				   		   'LABEL'  	=> '',
						   'BUY'		=> ( $can_buy && $hash[4] != 1 ) ? 'SimpleBuy('.$hash[0].')' : 'ToGoods('.$hash[0].')',
				   		   'RANK'		=> ( $i == 1 ) ? '_first' : ( ( $i == $end ) ? '_last' : '' ),
				   		   'DIV'		=> ( $col_cnt > 1 && $i < $end ) ? '_yes' : '_no',
				   		   'LINE'		=> ( $line % 2 ),
				   		   'ALT'		=> htmlspecialchars(str_replace('{NAME}', $hash[3], $hash[25])),
				   		   'LINKTITLE'	=> htmlspecialchars(str_replace('{NAME}', $hash[3], $hash[24]))
	        	           ));
		if ( $hash[21]*1 > 0 ) $tpl->Parse('LABEL', 'new'); 
		if ( $hash[22]*1 > 0 ) $tpl->parse('LABEL', 'hit'); 
		$tpl->Parse('UNIT', '.unit'); 
	}
	$tpl->Assign('COLSPAN', $mCol); 

	// Parse main page
	if ( $end > 0 )
	{
		$tpl->Parse('MAIN', 'main');
	}
	else 
	{
		$tpl->Assign('MAIN', '');
	}
	
	return $tpl->Fetch('MAIN');
} 

/**
 * Function advert_goods
 * Return text block of advert goods
 **/
function advert_goods($mPageID, $mGoodsID = 0)
{
	global $gData, $gOptions;

	$parse = array();
	$places = explode(';', $gOptions['main_how_advert']);
	foreach ( $places as $key ) $parse[$key] = '';
	$ic_value = $_SESSION['payment']['multiplex']*1;
	$goods_name_max = $gOptions['main_goods_name'];
	$goods_descr_max = $gOptions['main_goods_descr'];
	
	// Get Advert blocks
	if ( $mGoodsID == 0 )
	{
		$advert = $gData->GetAdvertForTopic($mPageID);
	}
	else 
	{
		$advert = $gData->GetAdvertForGoods($mPageID, $mGoodsID);
	}
	$adv_rows = $gData->GetNumRows($advert);
	if ( $adv_rows == 0 ) return $parse;
	for ( $n = 1; $n <= $adv_rows; $n++ )
	{
		$hash_adv = $gData->FetchRow($advert);
		
		if ( $hash_adv[7] == 1 && $mGoodsID == 0 && ( $_GET['from']*1 > 0 || isset($_GET['filter']) || isset($_GET['order']) ) ) continue;
		
		// Define templates
		$tpl = new FastTemplate('./'.TEMPLATES.'/goods/advert');
		$tpl->DefineTemplate(array('main' 			=> $hash_adv[3].'/main.htm',
								   'text' 			=> $hash_adv[3].'/text.htm'
								   ));
		// Get advert goods
		$goods = $gData->GetAdvertGoods($hash_adv[0]);
		$rows = $gData->GetNumRows($goods);
		if ( $rows > 0 )
		{								   
			$tpl_sub = new FastTemplate('./'.TEMPLATES.'/goods/advert');
			if ( $hash_adv[6] == 0 )
			{
				$tpl_sub->DefineTemplate(array('main' 			=> $hash_adv[3].'/simple/main.htm',
					 						   'unit'			=> $hash_adv[3].'/simple/unit.htm',
											   'between_row'	=> $hash_adv[3].'/simple/between_row.htm',
						    				   'discount'		=> $hash_adv[3].'/simple/discount.htm',
					    					   'new'			=> $hash_adv[3].'/simple/new.htm',
			    							   'hit'			=> $hash_adv[3].'/simple/hit.htm'
											  ));		
			}
			else 
			{
				$tpl_sub->DefineTemplate(array('main' 			=> $hash_adv[3].'/compare/main.htm',
					 				   	   	   'price'			=> $hash_adv[3].'/compare/price.htm',
										       'name'			=> $hash_adv[3].'/compare/name.htm',
										       'icon'			=> $hash_adv[3].'/compare/icon.htm',
										       'descr'			=> $hash_adv[3].'/compare/descr.htm',
					 				   	       'unit'			=> $hash_adv[3].'/compare/unit.htm',
										       'values'			=> $hash_adv[3].'/compare/values.htm',
										       'status0'		=> $hash_adv[3].'/compare/status0.htm',
								   		       'status1'		=> $hash_adv[3].'/compare/status1.htm',
						   				       'status2'		=> $hash_adv[3].'/compare/status2.htm',
								   		       'status3'		=> $hash_adv[3].'/compare/status3.htm',
								   		       'apendix_name'	=> $hash_adv[3].'/compare/apendix_name.htm'
									   	       ));			
			}
			// Parse goods
			$adv_col = $hash_adv[5];
			$col_cnt = 1;
			// Simple list
			if ( $hash_adv[6] == 0 )
			{
				$line = 1;
				for ( $i = 1; $i <= $rows; $i++ ) 
				{
					$hash = $gData->FetchRow($goods);
					if ( $col_cnt == 1 ) $line++;
					if ( ($col_cnt == $adv_col) && ($i <> $rows) ) 
					{
						$tpl_sub->Parse('BETWEENROW', 'between_row');  
						$col_cnt = 1; 
					} 
					else 
					{ 
						$tpl_sub->Assign('BETWEENROW', ''); 
						$col_cnt += 1; 
					}
					if ( is_file('./files/store'.$hash[0].'.jpg') ) 
					{
			    		$img_file = 'files/store'.$hash[0].'.jpg';
					} 
					else
					{
						$img_file = 'files/store_default.jpg';
					}
					// Calc prices
					list($new_price, $disc_proc, $disc_suma, $price_offer) = calc_goods_price($hash[0], $hash[4], $hash[5]);
					$can_buy = can_buy_now($hash[0], $hash[16]);
					// Info currency
					if ( $ic_value > 0 ) $new_price = round($new_price*$ic_value, 2);
					// Goods name and descr
					$goods_name = $hash[2];
					if ( strlen($goods_name) > $goods_name_max && $goods_name_max > 0 ) $goods_name = substr($goods_name, 0, $goods_name_max).'...';
					$goods_descr = html2text($hash[3]);
					if ( strlen($goods_descr) > $goods_descr_max && $goods_descr_max > 0 ) $goods_descr = substr($goods_descr, 0, $goods_descr_max).'...';
					$link = ( strlen($hash[15]) > 0 ) ? 'goods_'.urlencode($hash[15]).'.htm' : 'goods.php?id='.$hash[0];
					// Echo unit
					$tpl_sub->Assign(array('CODE'		=> htmlspecialchars($hash[1]),
		    	    	          	   	   'NAME'		=> htmlspecialchars($goods_name),
							   		   	   'NOTE'   	=> htmlspecialchars($goods_descr),
						   			   	   'PRICE'  	=> number_format($new_price, $gOptions['main_prec'], "," ,"'"),
					   				   	   'ICON'		=> $img_file,
					   			   	   	   'LINK'		=> $link,
					   			   	   	   'BUY'		=> ( $can_buy && $hash[8] != 1) ? 'SimpleBuy('.$hash[0].')' : 'ToGoods('.$hash[0].')',
				   		   				   'ID'			=> $hash[0],
						   			   	   'LABEL'  	=> '',
						   			   	   'RANK'		=> ( $i == 1 ) ? '_first' : ( ( $i == $rows ) ? '_last' : '' ),
						   			   	   'DIV'		=> ( $col_cnt > 1 && $i < $rows ) ? '_yes' : '_no',
						   			   	   'LINE'		=> ( $line % 2 ),
						   			   	   'ALT'		=> htmlspecialchars(str_replace('{NAME}', $hash[2], $hash[14])),
				   		   				   'LINKTITLE'	=> htmlspecialchars(str_replace('{NAME}', $hash[2], $hash[13]))
				        	           		));
					if ( $hash[6]*1 > 0 ) $tpl_sub->Parse('LABEL', 'new'); 
					if ( $hash[7]*1 > 0 ) $tpl_sub->Parse('LABEL', 'hit'); 
					if ( $hash[5]*1 > 0 ) $tpl_sub->Parse('LABEL', 'discount'); 
					$tpl_sub->Parse('UNIT', '.unit'); 
				}
			}
			// Compare list
			else 
			{
				for ( $i = 1; $i <= $rows; $i++ ) 
				{
					$hash = $gData->FetchRow($goods);
					if ( is_file('./files/store'.$hash[0].'.jpg') ) 
					{
			    		$img_file = 'files/store'.$hash[0].'.jpg';
					} 
					else
					{
						$img_file = 'files/store_default.jpg';
					}	
					$link = ( strlen($hash[15]) > 0 ) ? 'goods_'.urlencode($hash[15]).'.htm' : 'goods.php?id='.$hash[0];
					// Make Apendix link
					$tpl_sub->Assign('GOODSNAME', htmlspecialchars($hash[2]));
					if ( is_file('./files/apendix'.$hash[0].'.htm') ) 
					{
	    				if ( $hash['apendix_type'] == 0) 
						{
	        				$link_app = ( strlen($hash[15]) > 0 ) ? 'descr_'.urlencode($hash[15]).'.htm' : 'descr.php?id='.$hash[0];
							$apendix_link = ' href="'.$link_app.'" ';
	        				$apendix_link .= ' onclick="ShowApendix('."$hash[0], $hash[9], $hash[10], $hash[11], $hash[12]".'); return false;" ';	        		
							$tpl_sub->Assign('APENDIXLINK', $apendix_link);
							$tpl_sub->Parse('APENDIXNAME', 'apendix_name');
						}
						else 
						{
							$tpl_sub->Assign('APENDIXLINK', "href=\"$link\"");
							$tpl_sub->Parse('APENDIXNAME', 'apendix_name');
						}
					}
					else 
					{
						$tpl_sub->Assign(array('APENDIXLINK' => "href=\"$link\"", 
											   'APENDIXNAME' => ''));
					}
					// Make price offer
					list($new_price, $disc_proc, $disc_suma, $price_offer) = calc_goods_price($hash[0], $hash[4], $hash[5]);			
					$can_buy = can_buy_now($hash[0], $hash[16]);
					// Info currency
					if ( $ic_value > 0 ) 
					{
						$new_price = round($new_price*$ic_value, 2);
					}				
					// Goods name and descr
					$goods_name = $hash[2];
					if ( strlen($goods_name) > $goods_name_max && $goods_name_max > 0 ) $goods_name = substr($goods_name, 0, $goods_name_max).'...';
					$goods_descr = html2text($hash[3]);
					if ( strlen($goods_descr) > $goods_descr_max && $goods_descr_max > 0 ) $goods_descr = substr($goods_descr, 0, $goods_descr_max).'...';
					// Assign vars	
					$tpl_sub->Assign(array('VALUE'		=> htmlspecialchars($goods_name),
										   'LINK'		=> $link,
										   'BUY'		=> ( $can_buy && $hash[8] != 1) ? 'SimpleBuy('.$hash[0].')' : 'ToGoods('.$hash[0].')',
				   		   				   'ID'			=> $hash[0],
				   		   				   'ALT'		=> htmlspecialchars(str_replace('{NAME}', $hash[2], $hash[14])),
				   		   				   'LINKTITLE'	=> htmlspecialchars(str_replace('{NAME}', $hash[2], $hash[13]))
								   			));
					$tpl_sub->Parse('NAMES', '.name');
					$tpl_sub->Assign('VALUE', htmlspecialchars($goods_descr));
					$tpl_sub->Parse('DESCRS', '.descr');
					$tpl_sub->Assign('ICON', $img_file);
					$tpl_sub->Parse('ICONS', '.icon');
					$tpl_sub->Assign('VALUE', number_format($new_price, $gOptions['main_prec'], "," ,"'"));
					$tpl_sub->Parse('PRICES', '.price');
					$tpl_sub->Parse('STATUSES', '.status'.$hash[8]);
				}
				// Parse goods information		
				$advert_compare = $gData->GetInfoAdvertGoods($hash_adv[0]);
				$adv_comp_rows = $gData->GetNumRows($advert_compare);
				$allow = array();
				$tpl_sub->Assign('UNIT', '');
				for ( $m = 1; $m <= $adv_comp_rows; $m++ ) 
				{			
					$hash = $gData->FetchHash($advert_compare);
					if ( ($hash['info_id']*1 > 0) || ($allow[$hash['id']] == 1) ) 
					{
						$allow[$hash['tindex']] = 1;
						$tpl_sub->Assign(array('NAME'	=> htmlspecialchars($hash['name']),
											   'LEVEL'	=> $hash['tlevel']
											   ));
						$info_values = $gData->GetAdvertInfoValues($hash_adv[0], $hash['id']);
						$tpl_sub->Clear('VALUES');
						for ( $g = 1; $g <= $rows; $g++ ) 
						{
							$hash_value = $gData->FetchRow($info_values);
							$value = htmlspecialchars($hash_value[0]);
							if ( strpos($hash_value[0], 'ftp://') !== false || strpos($hash_value[0], 'http://') !== false ) 
							{
								if ( strlen($value) > 15 ) $value = substr($value, 0, 15).'...';
								$value = '<a href="'.$hash_value[0].'" target=_blank>'.$value.'</a>';
							}						
							$tpl_sub->Assign('VALUE', $value);
							$tpl_sub->Parse('VALUES', '.values');
						}
						$tpl_sub->Parse('UNIT', ',unit');
					}
				}
			} // end compare list	
			$tpl_sub->Assign('COLSPAN', $adv_col);
			$tpl_sub->Parse('MAIN', 'main');
			$tpl->Assign('GOODS', $tpl_sub->Fetch('MAIN'));
		} // end if $rows > 0
		else
		{
			$tpl->Assign('GOODS', '');			
		}
		// Parse description
		if ( strlen($hash_adv[2]) > 0 )
		{
			$tpl->Assign('DESCR', $hash_adv[2]);		
			$tpl->Parse('TEXT', 'text');
		}
		else 
		{
			$tpl->Assign('TEXT', '');
		}
		// Parse main page
		$tpl->Assign('NAME', htmlspecialchars($hash_adv[1]));
		$tpl->Parse('MAIN', 'main');
		$parse[$hash_adv[4]] .= $tpl->Fetch('MAIN');
	}
	
	return $parse;
}

/**
 * Function new_goods
 * Return text block of new_goods
 **/
function new_goods()
{
	global $gData, $gOptions;
	
	if ( $gOptions['index_new_how'] <= 0 || $gOptions['index_new_col'] <= 0 ) return '';
	
	$goods_name_max = $gOptions['main_goods_name'];
	$goods_descr_max = $gOptions['main_goods_descr'];
		
	// Init templates
	$tpl = new FastTemplate('./'.TEMPLATES.'/goods');
	$tpl->DefineTemplate(array('main' 			=> 'new/main.htm',  	 
			 				   'unit'			=> 'new/unit.htm',
							   'between_row'	=> 'new/between_row.htm',
			    			   'discount'		=> 'discount.htm',
			    			   'hit'			=> 'hit.htm'
							  ));

	// Get new goods
	$goods = $gData->GetNewGoods($gOptions['index_new_how']*1);
	$rows = $gData->GetNumRows($goods);
	if ( $rows == 0 ) return ''; 
	$col_cnt = 1;
	$ic_value = $_SESSION['payment']['multiplex']*1;
	$line = 1;
	for ( $i = 1; $i <= $rows; $i++ ) 
	{
		$hash = $gData->FetchRow($goods);
		if ( $col_cnt == 1 ) $line++;
		if ( ($col_cnt == $gOptions['index_new_col']) && ($i <> $rows) ) 
		{
			$tpl->parse('BETWEENROW', 'between_row');  
			$col_cnt = 1; 
		} 
		else 
		{ 
			$tpl->assign('BETWEENROW', ''); 
			$col_cnt += 1; 
		}
		if ( is_file('./files/store'.$hash[0].'.jpg') ) 
		{
		    $img_file = 'files/store'.$hash[0].'.jpg';
		} 
		else
		{
			$img_file = 'files/store_default.jpg';
		}

		// Calc prices
		list($new_price, $disc_proc, $disc_suma, $price_offer) = calc_goods_price($hash[0], $hash[4], $hash[5]);
		$can_buy = can_buy_now($hash[0], $hash[11]);
		// Info currency
		if ( $ic_value > 0 ) $new_price = round($new_price*$ic_value, 2);
		// Goods name and descr
		$goods_name = $hash[2];
		if ( strlen($goods_name) > $goods_name_max && $goods_name_max > 0 ) $goods_name = substr($goods_name, 0, $goods_name_max).'...';
		$goods_descr = html2text($hash[3]);
		if ( strlen($goods_descr) > $goods_descr_max && $goods_descr_max > 0 ) $goods_descr = substr($goods_descr, 0, $goods_descr_max).'...';
		$link = ( strlen($hash[10]) > 0 ) ? 'goods_'.urlencode($hash[10]).'.htm' : 'goods.php?id='.$hash[0];
		// Echo unit
		$tpl->Assign(array('CODE'		=> htmlspecialchars($hash[1]),
		                   'NAME'		=> htmlspecialchars($goods_name),
				   		   'NOTE'   	=> htmlspecialchars($goods_descr),
				   		   'PRICE'  	=> number_format($new_price, $gOptions['main_prec'], "," ,"'"),
				   		   'ICON'		=> $img_file,
				   		   'LINK'		=> $link,
				   		   'BUY'		=> ( $can_buy && $hash[7] != 1) ? 'SimpleBuy('.$hash[0].')' : 'ToGoods('.$hash[0].')',
				   		   'ID'			=> $hash[0],
				   		   'LABEL'  	=> '',
				   		   'RANK'		=> ( $i == 1 ) ? '_first' : ( ( $i == $rows ) ? '_last' : '' ),
				   		   'DIV'		=> ( $col_cnt > 1 && $i < $rows ) ? '_yes' : '_no',
				   		   'LINE'		=> ( $line % 2 ),
				   		   'ALT'		=> htmlspecialchars(str_replace('{NAME}', $hash[2], $hash[9])),
				   		   'LINKTITLE'	=> htmlspecialchars(str_replace('{NAME}', $hash[2], $hash[8]))
	        	           ));
		if ( $hash[6]*1 > 0 ) $tpl->parse('LABEL', 'hit'); 
		if ( $hash[5]*1 > 0 ) $tpl->Parse('LABEL', 'discount'); 
		$tpl->Parse('UNIT', '.unit'); 
	}
	$tpl->Assign('COLSPAN', $gOptions['index_new_col']); 

	// Parse main page
	$tpl->Parse('MAIN', 'main');
	
	return $tpl->Fetch('MAIN');
}


/**
 * Function new_topic_goods
 * Return text block of new_topic_goods
 **/
function new_topic_goods($mTopic, $mCol, $mHow)
{
	global $gData, $gOptions;
	
	if ( $mCol <= 0 || $mHow <= 0 ) return '';
	
	$goods_name_max = $gOptions['main_goods_name'];
	$goods_descr_max = $gOptions['main_goods_descr'];
		
	// Init templates
	$tpl = new FastTemplate('./'.TEMPLATES.'/goods');
	$tpl->DefineTemplate(array('main' 			=> 'new/main.htm',  	 
			 				   'unit'			=> 'new/unit.htm',
							   'between_row'	=> 'new/between_row.htm',
			    			   'discount'		=> 'discount.htm',
			    			   'hit'			=> 'hit.htm'
							  ));

	// Parse sections
	$goods = $gData->GetNewTopicGoods($mTopic*1, $mHow*1);
	$rows = $gData->GetNumRows($goods);
	if ( $rows == 0 ) return ''; 
	$col_cnt = 1;
	$ic_value = $_SESSION['payment']['multiplex']*1;
	$line = 1;
	for ( $i = 1; $i <= $rows; $i++ ) 
	{
		$hash = $gData->FetchRow($goods);
		if ( $col_cnt == 1 ) $line++;
		if ( ($col_cnt == $mCol) && ($i <> $rows) ) 
		{
			$tpl->parse('BETWEENROW', 'between_row');  
			$col_cnt = 1; 
		} 
		else 
		{ 
			$tpl->assign('BETWEENROW', ''); 
			$col_cnt += 1; 
		}
		if ( is_file('./files/store'.$hash[0].'.jpg') ) 
		{
		    $img_file = 'files/store'.$hash[0].'.jpg';
		} 
		else
		{
			$img_file = 'files/store_default.jpg';
		}
		// Calc prices
		list($new_price, $disc_proc, $disc_suma, $price_offer) = calc_goods_price($hash[0], $hash[4], $hash[5]);
		$can_buy = can_buy_now($hash[0], $hash[11]);
		// Info currency
		if ( $ic_value > 0 ) $new_price = round($new_price*$ic_value, 2);		
		// Goods name and descr
		$goods_name = $hash[2];
		if ( strlen($goods_name) > $goods_name_max && $goods_name_max > 0 ) $goods_name = substr($goods_name, 0, $goods_name_max).'...';
		$goods_descr = html2text($hash[3]);
		if ( strlen($goods_descr) > $goods_descr_max && $goods_descr_max > 0 ) $goods_descr = substr($goods_descr, 0, $goods_descr_max).'...';
		$link = ( strlen($hash[10]) > 0 ) ? 'goods_'.urlencode($hash[10]).'.htm' : 'goods.php?id='.$hash[0];
		// Echo unit
		$tpl->Assign(array('CODE'		=> htmlspecialchars($hash[1]),
		                   'NAME'		=> htmlspecialchars($goods_name),
				   		   'NOTE'   	=> htmlspecialchars($goods_descr),
				   		   'PRICE'  	=> number_format($new_price, $gOptions['main_prec'], "," ,"'"),
				   		   'ICON'		=> $img_file,
				   		   'LINK'		=> $link,
				   		   'BUY'		=> ( $can_buy && $hash[7] != 1) ? 'SimpleBuy('.$hash[0].')' : 'ToGoods('.$hash[0].')',
				   		   'ID'			=> $hash[0],
				   		   'LABEL'  	=> '',
				   		   'RANK'		=> ( $i == 1 ) ? '_first' : ( ( $i == $rows ) ? '_last' : '' ),
				   		   'DIV'		=> ( $col_cnt > 1 && $i < $rows ) ? '_yes' : '_no',
				   		   'LINE'		=> ( $line % 2 ),
				   		   'ALT'		=> htmlspecialchars(str_replace('{NAME}', $hash[2], $hash[9])),
				   		   'LINKTITLE'	=> htmlspecialchars(str_replace('{NAME}', $hash[2], $hash[8]))
	        	           ));
		if ( $hash[6]*1 > 0 ) $tpl->parse('LABEL', 'hit'); 
		if ( $hash[5]*1 > 0 ) $tpl->Parse('LABEL', 'discount'); 
		$tpl->Parse('UNIT', '.unit'); 
	}
	$tpl->Assign('COLSPAN', $mCol); 

	// Parse main page
	$tpl->Parse('MAIN', 'main');
	
	return $tpl->Fetch('MAIN');
}

/**
 * Function hit_goods
 * Return text block of hit goods
 **/
function hit_goods($mCol, $mHow)
{
	global $gData, $gOptions;
	
	if ( $mCol <= 0 || $mHow <= 0 ) return '';
	
	$goods_name_max = $gOptions['main_goods_name'];
	$goods_descr_max = $gOptions['main_goods_descr'];	
	
	// Init templates
	$tpl = new FastTemplate('./'.TEMPLATES.'/goods');
	$tpl->DefineTemplate(array('main' 			=> 'hit/main.htm',  	 
			 				   'unit'			=> 'hit/unit.htm',
							   'between_row'	=> 'hit/between_row.htm',
			    			   'discount'		=> 'discount.htm',
			    			   'new'			=> 'new.htm'
							  ));

	// Parse sections
	$goods = $gData->GetHitGoods($mHow*1);
	$rows = $gData->GetNumRows($goods);
	if ( $rows == 0 ) return ''; 
	$col_cnt = 1;
	$ic_value = $_SESSION['payment']['multiplex']*1;
	$line = 1;
	for ( $i = 1; $i <= $rows; $i++ ) 
	{
		$hash = $gData->FetchRow($goods);
		if ( $col_cnt == 1 ) $line++;
		if ( ($col_cnt == $mCol) && ($i <> $rows) ) 
		{
			$tpl->parse('BETWEENROW', 'between_row');  
			$col_cnt = 1; 
		} 
		else 
		{ 
			$tpl->assign('BETWEENROW', ''); 
			$col_cnt += 1; 
		}
		if ( is_file('./files/store'.$hash[0].'.jpg') ) 
		{
		    $img_file = 'files/store'.$hash[0].'.jpg';
		} 
		else
		{
			$img_file = 'files/store_default.jpg';
		}
		// Calc prices
		list($new_price, $disc_proc, $disc_suma, $price_offer) = calc_goods_price($hash[0], $hash[4], $hash[5]);
		$can_buy = can_buy_now($hash[0], $hash[11]);
		// Info currency
		if ( $ic_value > 0 ) $new_price = round($new_price*$ic_value, 2);		
		// Goods name and descr
		$goods_name = $hash[2];
		if ( strlen($goods_name) > $goods_name_max && $goods_name_max > 0 ) $goods_name = substr($goods_name, 0, $goods_name_max).'...';
		$goods_descr = html2text($hash[3]);
		if ( strlen($goods_descr) > $goods_descr_max && $goods_descr_max > 0 ) $goods_descr = substr($goods_descr, 0, $goods_descr_max).'...';
		$link = ( strlen($hash[10]) > 0 ) ? 'goods_'.urlencode($hash[10]).'.htm' : 'goods.php?id='.$hash[0];
		// Echo unit
		$tpl->Assign(array('CODE'		=> htmlspecialchars($hash[1]),
		                   'NAME'		=> htmlspecialchars($goods_name),
				   		   'NOTE'   	=> htmlspecialchars($goods_descr),
				   		   'PRICE'  	=> number_format($new_price, $gOptions['main_prec'], "," ,"'"),
				   		   'ICON'		=> $img_file,
				   		   'LINK'		=> $link,
				   		   'BUY'		=> ( $can_buy && $hash[7] != 1) ? 'SimpleBuy('.$hash[0].')' : 'ToGoods('.$hash[0].')',
				   		   'ID'			=> $hash[0],
				   		   'LABEL'  	=> '',
				   		   'RANK'		=> ( $i == 1 ) ? '_first' : ( ( $i == $rows ) ? '_last' : '' ),
				   		   'DIV'		=> ( $col_cnt > 1 && $i < $rows ) ? '_yes' : '_no',
				   		   'LINE'		=> ( $line % 2 ),
				   		   'ALT'		=> htmlspecialchars(str_replace('{NAME}', $hash[2], $hash[9])),
				   		   'LINKTITLE'	=> htmlspecialchars(str_replace('{NAME}', $hash[2], $hash[8]))
	        	           ));
		if ( $hash[6]*1 > 0 ) $tpl->parse('LABEL', 'new'); 
		if ( $hash[5]*1 > 0 ) $tpl->Parse('LABEL', 'discount'); 
		$tpl->Parse('UNIT', '.unit'); 
	}
	$tpl->Assign('COLSPAN', $mCol); 

	// Parse main page
	$tpl->Parse('MAIN', 'main');
	
	return $tpl->Fetch('MAIN');
}

/**
 * Function gift_goods
 * Return text block of gift goods
 **/
function gift_goods()
{
	global $gData, $gOptions;
	
	if ( $gOptions['index_gift_col'] <= '0' ) return '';
	
	$goods_name_max = $gOptions['main_goods_name'];
	$goods_descr_max = $gOptions['main_goods_descr'];
		
	// Init templates
	$tpl = new FastTemplate('./'.TEMPLATES.'/goods/gift');
	$tpl->DefineTemplate(array('main' 			=> 'main.htm',  	 
			 				   'unit'			=> 'unit.htm',
							   'between_row'	=> 'between_row.htm',
							   'any'			=> 'any.htm',
							   'from'			=> 'from.htm',
							   'from_to'		=> 'from_to.htm',
							   'to'				=> 'to.htm'
							  ));

	// Parse sections
	$goods = $gData->GetGiftGoods();
	$rows = $gData->GetNumRows($goods);
	if ( $rows == 0 ) return ''; 
	$col_cnt = 1;
	$ic_value = $_SESSION['payment']['multiplex']*1;
	$line = 1;
	for ( $i = 1; $i <= $rows; $i++ ) 
	{
		$hash = $gData->FetchRow($goods);
		if ( $col_cnt == 1 ) $line++;
		if ( ($col_cnt == $gOptions['index_gift_col']) && ($i <> $rows) ) 
		{
			$tpl->parse('BETWEENROW', 'between_row');  
			$col_cnt = 1; 
		} 
		else 
		{ 
			$tpl->assign('BETWEENROW', ''); 
			$col_cnt += 1; 
		}
		if ( is_file('./files/store'.$hash[0].'.jpg') ) 
		{
		    $img_file = 'files/store'.$hash[0].'.jpg';
		} 
		else
		{
			$img_file = 'files/store_default.jpg';
		}
		// Info currency
		if ( $ic_value > 0 ) 
		{
			$tpl->Assign(array(STARTSUM	=>  number_format(round($hash[6]*$ic_value, 2), $gOptions['main_prec'], ",", "'"),
					   		   ENDSUM   =>  number_format(round($hash[7]*$ic_value, 2), $gOptions['main_prec'], ",", "'")
							   ));
		}	
		else
		{
			$tpl->Assign(array(STARTSUM	=>  number_format($hash[6], $gOptions['main_prec'], ",", "'"),
					   		   ENDSUM   =>  number_format($hash[7], $gOptions['main_prec'], ",", "'")
							   ));
		}
		// Make condions
		if ( ($hash[6] == 0)  &&  ($hash[7] == 0) ) $tpl->Parse('CONDITION', 'any'); 
		if ( ($hash[6] == 0)  &&  ($hash[7] >  0) ) $tpl->Parse('CONDITION', 'to');
		if ( ($hash[6] >  0)  &&  ($hash[7] == 0) ) $tpl->Parse('CONDITION', 'from');
		if ( ($hash[6] >  0)  &&  ($hash[7] >  0) ) $tpl->Parse('CONDITION', 'from_to');
		// Goods name and descr
		$goods_name = $hash[2];
		if ( strlen($goods_name) > $goods_name_max && $goods_name_max > 0 ) $goods_name = substr($goods_name, 0, $goods_name_max).'...';
		$goods_descr = html2text($hash[3]);
		if ( strlen($goods_descr) > $goods_descr_max && $goods_descr_max > 0 ) $goods_descr = substr($goods_descr, 0, $goods_descr_max).'...';
		$link = ( strlen($hash[10]) > 0 ) ? 'goods_'.urlencode($hash[10]).'.htm' : 'goods.php?id='.$hash[0];
		// Echo unit
		$tpl->Assign(array('CODE'		=> htmlspecialchars($hash[1]),
		                   'NAME'		=> htmlspecialchars($goods_name),
				   		   'NOTE'   	=> htmlspecialchars($goods_descr),
				   		   'ICON'		=> $img_file,
				   		   'LINK'		=> $link,
				   		   'RANK'		=> ( $i == 1 ) ? '_first' : ( ( $i == $rows ) ? '_last' : '' ),
				   		   'DIV'		=> ( $col_cnt > 1 && $i < $rows ) ? '_yes' : '_no',
				   		   'LINE'		=> ( $line % 2 ),
				   		   'ALT'		=> htmlspecialchars(str_replace('{NAME}', $hash[2], $hash[9])),
				   		   'LINKTITLE'	=> htmlspecialchars(str_replace('{NAME}', $hash[2], $hash[8]))
	        	           ));
		$tpl->Parse('UNIT', '.unit'); 
	}
	$tpl->Assign('COLSPAN', $gOptions['index_gift_col']); 

	// Parse main page
	$tpl->Parse('MAIN', 'main');
	
	return $tpl->Fetch('MAIN');
}


/**
 * Function discount_goods
 * Return text block of discount_goods
 **/
function discount_goods()
{
	global $gData, $gOptions;
	
	if ( $gOptions['index_disc_how'] <= 0 || $gOptions['index_disc_col'] <= 0 ) return '';
	
	$goods_name_max = $gOptions['main_goods_name'];
	$goods_descr_max = $gOptions['main_goods_descr'];	
	
	// Init templates
	$tpl = new FastTemplate('./'.TEMPLATES.'/goods');
	$tpl->DefineTemplate(array('main' 			=> 'discount/main.htm',  	 
			 				   'unit'			=> 'discount/unit.htm',
							   'between_row'	=> 'discount/between_row.htm',
			    			   'new'			=> 'new.htm',
			    			   'hit'			=> 'hit.htm'
							  ));

	// Parse sections
	$goods = $gData->GetDiscountGoods($gOptions['index_disc_how']);
	$rows = $gData->GetNumRows($goods);
	if ( $rows == 0 ) return ''; 
	$col_cnt = 1;
	$ic_value = $_SESSION['payment']['multiplex']*1;
	$line = 1;
	for ( $i = 1; $i <= $rows; $i++ ) 
	{
		$hash = $gData->FetchRow($goods);
		if ( $col_cnt == 1 ) $line++;
		if ( ($col_cnt == $gOptions['index_disc_col']) && ($i <> $rows) ) 
		{
			$tpl->parse('BETWEENROW', 'between_row');  
			$col_cnt = 1; 
		} 
		else 
		{ 
			$tpl->assign('BETWEENROW', ''); 
			$col_cnt += 1; 
		}
		if ( is_file('./files/store'.$hash[0].'.jpg') ) 
		{
		    $img_file = 'files/store'.$hash[0].'.jpg';
		} 
		else
		{
			$img_file = 'files/store_default.jpg';
		}
		
		// Make price offer
		$price = $hash[4];
		$new_price = $hash[5]*1;
		$left_sum = $price - $new_price;
		// Info currency
		if ( $ic_value > 0 ) 
		{
			$price = round($price*$ic_value, 2);
			$new_price = round($new_price*$ic_value, 2);
			$left_sum = round($left_sum*$ic_value, 2);
		}	
		// can buy?
		$can_buy = can_buy_now($hash[0], $hash[12]);
		// Goods name and descr
		$goods_name = $hash[2];
		if ( strlen($goods_name) > $goods_name_max && $goods_name_max > 0 ) $goods_name = substr($goods_name, 0, $goods_name_max).'...';
		$goods_descr = html2text($hash[3]);
		if ( strlen($goods_descr) > $goods_descr_max && $goods_descr_max > 0 ) $goods_descr = substr($goods_descr, 0, $goods_descr_max).'...';
		$link = ( strlen($hash[11]) > 0 ) ? 'goods_'.urlencode($hash[11]).'.htm' : 'goods.php?id='.$hash[0];
		// Echo unit
		$tpl->Assign(array('CODE'		=> htmlspecialchars($hash[1]),
		                   'NAME'		=> htmlspecialchars($goods_name),
				   		   'NOTE'   	=> htmlspecialchars($goods_descr),
				   		   'PRICE'  	=> number_format($price, $gOptions['main_prec'], "," ,"'"),
				   		   'NEWPRICE'  	=> number_format($new_price, $gOptions['main_prec'], "," ,"'"),
				   		   'LEFTSUM'  	=> number_format($left_sum, $gOptions['main_prec'], "," ,"'"),
				   		   'ICON'		=> $img_file,
				   		   'LINK'		=> $link,
				   		   'BUY'		=> ( $can_buy && $hash[8] != 1) ? 'SimpleBuy('.$hash[0].')' : 'ToGoods('.$hash[0].')',
				   		   'ID'			=> $hash[0],
				   		   'LABEL'  	=> '',
				   		   'RANK'		=> ( $i == 1 ) ? '_first' : ( ( $i == $rows ) ? '_last' : '' ),
				   		   'DIV'		=> ( $col_cnt > 1 && $i < $rows ) ? '_yes' : '_no',
				   		   'LINE'		=> ( $line % 2 ),
				   		   'ALT'		=> htmlspecialchars(str_replace('{NAME}', $hash[2], $hash[10])),
				   		   'LINKTITLE'	=> htmlspecialchars(str_replace('{NAME}', $hash[2], $hash[9]))
	        	           ));
		if ( $hash[6]*1 > 0 ) $tpl->Parse('LABEL', 'new'); 
		if ( $hash[7]*1 > 0 ) $tpl->parse('LABEL', 'hit'); 
		$tpl->Parse('UNIT', '.unit'); 
	}
	$tpl->Assign('COLSPAN', $gOptions['index_disc_col']); 

	// Parse main page
	$tpl->Parse('MAIN', 'main');
	
	return $tpl->Fetch('MAIN');
}

?>