<?php

/**
 * guide_line.php
 * --------------
 * @version 5.4.0
 * @copyright 2002-2010 Melbis Company
 * @link http://www.melbis.com
 * @author Dmitriy Kasyanov
 **/
 

/**
 * Function guide_line
 * Return text block with guide line
 **/
function guide_line($mFrom, $mStep, $mHow, $mPath, $mType)
{
	// Init templates
	$tpl = new FastTemplate(SHOP_CWD.$mType);
	$tpl->DefineTemplate(array('main' 		=> 'main.htm',  	 
			 				   'cell'		=> 'cell.htm',
			    			   'now_cell'	=> 'now_cell.htm',
							   'begin'		=> 'begin.htm',
							   'end'		=> 'end.htm'
							   ));

	// Init
	$sect = 3;
	if ( $mFrom >= $mHow ) $mFrom = $mHow - $mStep;	
	
	// Before
	$last = 0;
	while ( $last < $mHow ) 
	{
		$last += $mStep;
	}
	$last -= $mStep;
	$min = $last-2*$mStep*$sect+1;
	if ( $min > ($mFrom-$mStep*$sect+1) ) 
	{ 
		$min = $mFrom-$mStep*$sect+1; 
	}
	if ( $min < 0 ) 
	{ 
		$min = 1; 
	}
	$tpl->Assign('PATH', $mPath.'&from=0');
	$tpl->Parse('CELLBEFORE', 'begin');
	for ( $i = $min; $i <= $mFrom; $i = $i+$mStep) 
	{
		$ii = $i+$mStep-1;
		if ( $ii == $i ) 
		{ 
			$ii = ''; 
		} 
		else 
		{ 
			$ii = "-$ii"; 
		}
		$tpl->Assign(array('RANGE'  =>  "$i$ii",
				   		   'PATH'	=>  $mPath.'&from='.($i-1)
        	        	   ));
		$tpl->Parse('CELLBEFORE', '.cell'); 
	}
	// Print Center
	$to = $mFrom+$mStep;
	if ( $to > $mHow ) 
	{ 
		$to = $mHow; 
	}
	if ( $to == $mFrom+1 ) 
	{ 
		$to = ''; 
	} 
	else 
	{ 
		$to = "-$to"; 
	}
	$tpl->Assign(array('RANGE'  =>	($mFrom+1).$to,
					   'PATH'	=>  ''
       	        	   ));
	$tpl->Parse('NOWCELL', 'now_cell'); 
	
	// Print After
	$min = $mFrom-$mStep*$sect+1;
	if ( $min < 0 ) 
	{ 
		$min = 1; 
	}
	$max = 2*$mStep*$sect+$min;
	if ( $max > $mHow ) 
	{ 
		$max = $mHow; 
	}
	for ( $i = $mFrom+$mStep+1; $i <= $max; $i = $i+$mStep) 
	{
		$ii = $i+$mStep-1;
		if ( $ii > $mHow ) 
		{ 
			$ii = $mHow; 
		}
		if ( $ii == $i ) 
		{ 
			$ii = ''; 
		} 
		else 
		{ 
			$ii = "-$ii"; 
		}
		$tpl->Assign(array('RANGE'  =>  "$i$ii",
				   		   'PATH'	=>  $mPath.'&from='.($i-1)
        	        	   ));
		$tpl->parse('CELLAFTER', '.cell'); 
	}
	$tpl->Assign('PATH', $mPath.'&from='.($mStep*floor($mHow/$mStep)));
	$tpl->Parse('CELLAFTER', '.end');
	$tpl->Assign('HOW', $mHow); 
	$tpl->Parse('MAIN', 'main');

	return $tpl->Fetch(MAIN);
}

?>