<?php

/**
 * section.php
 * -----------
 * @version 5.4.0
 * @copyright 2002-2010 Melbis Company
 * @link http://www.melbis.com
 * @author Dmitriy Kasyanov
 **/
 

/**
 * Function sections
 * Return text block of sections list
 **/
function sections($mTopic = 0, $mIsFirstPage = false, $mHiddenTopic = false)
{
	global $gData, $gOptions;

	$to_parse['SECTIONNAME'] = '';
	$to_parse['CATLEFT'] = '';
	$to_parse['CATMENU'] = '';
	$to_parse['CATDOWN'] = '';
	$to_parse['CATCENTER'] = '';
	
	// Parsing left catalog
	//=====================

	// Get section list
	list($max_level, $topic) = $gData->GetCatLeft($gOptions['main_sec_level'], $mTopic);
	$rows = $gData->GetNumRows($topic);		
	if ( $rows > 0 )
	{	
		// Define page type
		$page_type[0] = 'goods_';
		$page_type[1] = 'page_';
		$page_type[2] = 'link_';			
		// Init templates
		$tpl = new FastTemplate('./'.TEMPLATES.'/sections/cat/left');
		$tpl->DefineTemplate(array('main' 			=> 'main.htm',  	 
				 				   'between_row'	=> 'between_row.htm',
				    			   'divider'		=> 'divider.htm'
								   ));
		for ( $i=1; $i <= $max_level; $i++ ) 
		{
			$tpl->DefineTemplate(array('goods_'.$i 	    	=> "goods_{$i}.htm",
					    			   'goods_'.$i.'_sel'	=> "goods_{$i}_sel.htm",
		 			    			   'page_'.$i 	    	=> "page_{$i}.htm",
				    				   'page_'.$i.'_sel'  	=> "page_{$i}_sel.htm",
				    				   'link_'.$i 	     	=> "link_{$i}.htm"
				   				 	   ));
		}
		for ( $i = 1; $i <= $rows; $i++ ) 
		{
			$hash = $gData->FetchRow($topic);
			if ($hash[4] == 1) $tpl->Parse('UNIT', '.divider');  
			if ($i == $rows) $tpl->Assign('BETWEENROW', ''); 
			if ($hash[5] == 2) 
			{ 
				$link = $hash[6]; 
			} 
			else 
			{ 
				if ( strlen($hash[8]) == 0 )
				{
					$link = 'dir.php?id='.$hash[0]; 
				}
				else 
				{
					$link = './dir_'.urlencode($hash[8]).'.htm';
				}
			}
			$title = ( strlen($hash[7]) > 0 ) ? $hash[7] : $hash[1];
			// define icon file
			if ( is_file('./files/topic'.$hash[0].'.jpg') ) 
			{
		   		$img_file = 'files/topic'.$hash[0].'.jpg';
			} 
			else
			{
				$img_file = 'files/topic_default.jpg';
			}			
			$tpl->Assign(array('LINK'  => $link,
						   	   'NAME'  => htmlspecialchars($hash[1]),
						   	   'TITLE' => htmlspecialchars($title),
						   	   'LINE'  => ( ( $i + 1 ) % 2 ),
						   	   'HOW'   => $hash[9],
						   	   'ID'	   => $hash[0],
							   'ICON'  => $img_file						   	   
	       	 		           ));
			if ($mTopic == $hash[0]) 
			{ 
				$tpl->parse('UNIT', '.'.$page_type[$hash[5]].($hash[2]+1).'_sel'); 
			} 
			else 
			{ 
				$tpl->parse('UNIT', '.'.$page_type[$hash[5]].($hash[2]+1));
			}
		}
		$tpl->Parse('BETWEENROW', 'between_row');  
		// Parse main page
		$tpl->Parse('MAIN', 'main');
		$to_parse['CATLEFT'] = $tpl->Fetch('MAIN');
	} 
	else 
	{
		$to_parse['CATLEFT'] = '';
	}

	// Parsing down catalog
	//=====================
	$topic = $gData->GetCatDown($gOptions['main_down_level']);
	$rows = $gData->GetNumRows($topic);	
	if ( $rows > 0 ) 
	{
		$max_level = $gOptions['main_down_level'];
		// Init templates
		$tpl = new FastTemplate('./'.TEMPLATES.'/sections/cat/down');
		$tpl->DefineTemplate(array('main' 			=> 'main.htm',  	 
				    			   'divider'		=> 'divider.htm'
								   ));
		for ( $i=1; $i <= $max_level; $i++ ) 
		{
			$tpl->DefineTemplate(array('unit_'.$i 	    	=> "unit_{$i}.htm",
					    			   'unit_'.$i.'_sel'	=> "unit_{$i}_sel.htm"
				   				 	   ));
		}
		for ( $i = 1; $i <= $rows; $i++ ) 
		{
			$hash = $gData->FetchRow($topic);
			if ($hash[4] == 1) $tpl->Parse('UNIT', '.divider');  
			if ($hash[5] == 2) 
			{ 
				$link = $hash[6]; 
			} 
			else 
			{ 
				if ( strlen($hash[8]) == 0 )
				{
					$link = 'dir.php?id='.$hash[0]; 
				}
				else 
				{
					$link = './dir_'.urlencode($hash[8]).'.htm';
				}				
			}
			$tpl->Assign(array('LINK' => $link,
						   	   'NAME' => htmlspecialchars($hash[1]),
						   	   'LINE' => ( ( $i + 1 ) % 2 ),
						   	   'HOW'  => ( $hash[5] == 0 ) ? '('.$hash[9].')' : '',
						   	   'ID'	  => $hash[0]
	       	 		           ));
			if ($mTopic == $hash[0]) 
			{ 
				$tpl->Parse('UNIT', '.unit_'.($hash[2]+1).'_sel'); 
			} 
			else 
			{ 
				$tpl->Parse('UNIT', '.unit_'.($hash[2]+1));
			}
		}
		// Parse main page
		$tpl->Parse('MAIN', 'main');
		$to_parse['CATDOWN'] = $tpl->Fetch('MAIN');
	}	
	else 
	{
		$to_parse['CATDOWN'] = '';
	}
	

	// Parsing center catalog
	//=======================
	if ( $mIsFirstPage ) 
	{
		$topic = $gData->GetCatCenter($gOptions['index_cat_root']);
		$rows = $gData->GetNumRows($topic);	
	}
	else 
	{
		$rows = 0;
	}
	if ( $rows > 0 ) 
	{
		// Init templates
		$tpl = new FastTemplate('./'.TEMPLATES.'/sections/cat/center');
		$tpl->DefineTemplate(array('main' 			=> 'main.htm',  
								   'unit'			=> 'unit.htm',
								   'sub_unit'		=> 'sub_unit.htm',
								   'unit_br'		=> 'unit_br.htm',
								   'sub_unit_br'	=> 'sub_unit_br.htm',
								   'unit_empty'		=> 'unit_empty.htm'
								   ));
		$unit = FALSE;	
		$sub_unit = FALSE;	
		$col_cnt = 1;
		$unit_link = '';
		$unit_icon = '';
		$unit_name = '';
		$unit_descr = '';
		$unit_title = '';
		$unit_how = '';
		$unit_id = 0;
		for ( $i = 1; $i <= $rows+1; $i++ ) 
		{
			$hash = $gData->FetchRow($topic);
			// if second level then assign and parse sub_units
			if ( $hash[2] > 0 ) 
			{
				if ( $sub_unit ) 
				{
				    $tpl->Parse('SUBUNITBR', 'sub_unit_br');
					$tpl->Parse('SUBUNIT', '.sub_unit');
				}	
				if ($hash[5] == 2) 
				{ 
					$link = $hash[6]; 
				} 
				else 
				{ 
					if ( strlen($hash[10]) == 0 )
					{
						$link = 'dir.php?id='.$hash[0]; 
					}
					else 
					{
						$link = './dir_'.urlencode($hash[10]).'.htm';
					}				
				}				
				$tpl->Assign(array('LINK' 	=> $link,
							   	   'NAME' 	=> htmlspecialchars($hash[1]),
							   	   'TITLE'	=> ( strlen($hash[9]) > 0 ) ? htmlspecialchars($hash[9]) : htmlspecialchars($hash[1]),
							   	   'HOW'  	=>  ( $hash[5] == 0 ) ? '('.$hash[11].')' : '',
							   	   'ID'		=> $hash[0]
	    	   	 		           ));
				$sub_unit = TRUE;			   
			}			
			// if first level assign and parse units
			if ( ($hash[2] == 0) || ($i == $rows+1) ) 
			{
				// parse last sub unit
				if ( $sub_unit ) 
				{
				    $tpl->Assign('SUBUNITBR', '');
					$tpl->Parse('SUBUNIT', '.sub_unit');
					$sub_unit = FALSE;
				}	
				// parse unit				
				if ( $unit ) 
				{
					// parse on colums
					if ( ($col_cnt == $gOptions['index_cat_col']) && ($i <> $rows+1) ) 
					{
						$tpl->Parse('UNITBR', 'unit_br');
						$col_cnt = 1; 
					} 
					else 
					{ 
						$tpl->Assign('UNITBR', ''); 
						$col_cnt += 1; 
					}
					$tpl->Assign(array('LINK'  => $unit_link,
									   'ICON'  => $unit_icon,
								   	   'NAME'  => $unit_name,
								   	   'DESCR' => $unit_descr,
								   	   'TITLE' => ( strlen($unit_title) > 0 ) ? $unit_title : $unit_name,
								   	   'HOW'   => $unit_how,
								   	   'ID'	   => $unit_id
	    	   		 		           ));
					$tpl->parse('UNIT', '.unit');
				}
				// define icon file
				if ( is_file('./files/topic'.$hash[0].'.jpg') ) 
				{
			   		$img_file = 'files/topic'.$hash[0].'.jpg';
				} 
				else
				{
					$img_file = 'files/topic_default.jpg';
				}
				$unit = true;	
				if ($hash[5] == 2) 
				{ 
					$unit_link = $hash[6]; 
				} 
				else 
				{ 
					if ( strlen($hash[10]) == 0 )
					{
						$unit_link = 'dir.php?id='.$hash[0]; 
					}
					else 
					{
						$unit_link = './dir_'.urlencode($hash[10]).'.htm';
					}				
				}				
				$unit_icon = $img_file;
				$unit_name = htmlspecialchars($hash[1]);
				$unit_descr = $hash[8];
				$unit_title = htmlspecialchars($hash[9]);
				$unit_how =  ( $hash[5] == 0 ) ? '('.$hash[11].')' : '';
				$unit_id = $hash[0];
				$tpl->Assign('SUBUNIT', '');
			}
		}
		// Parsing empty units  
		for ( $i = $col_cnt; $i <= $gOptions['index_cat_col']; $i++ ) 
		{
			$tpl->parse('UNIT', '.unit_empty');
		}
		// Parse main page
		$tpl->Parse('MAIN', 'main');
		$to_parse['CATCENTER'] = $tpl->Fetch('MAIN');
	}	
	else 
	{
		$to_parse['CATCENTER'] = '';
	}
	

	// Parsing menu catalog
	//=====================
	$topic = $gData->GetCatMenu();
	$rows = $gData->GetNumRows($topic);		
	if ( $rows > 0 ) 
	{
		// Init templates
		$tpl = new FastTemplate('./'.TEMPLATES.'/sections/cat/menu');
		$tpl->DefineTemplate(array('main' 			=> 'main.htm',  
								   'layer'			=> 'layer.htm',
								   'unit_goods'		=> 'unit_goods.htm',
								   'unit_goods_sel'	=> 'unit_goods_sel.htm',
								   'unit_page'		=> 'unit_page.htm',
								   'unit_page_sel'	=> 'unit_page_sel.htm',
								   'unit_link'		=> 'unit_link.htm',
								   'sub_unit'		=> 'sub_unit.htm',
								   'sub_unit_sel'	=> 'sub_unit_sel.htm',
								   'divider'		=> 'divider.htm'
								   ));
		$unit = false;
		$sub_unit = false;	
		$how_layer = 0;		
		$unit_name = ''; 
		$unit_id = 0;
		$unit_div = false;
		$unit_type = 0;
		$unit_how = 0;
		// Define page type
		$page_type[0] = 'goods';
		$page_type[1] = 'page';
		$page_type[2] = 'link';			
		$id = 0; 
		for ( $i = 1; $i <= $rows+1; $i++ ) 
		{
			$hash = $gData->FetchRow($topic);
			if ($hash[5] == 2) 
			{ 
				$link = $hash[6]; 
			} 
			else 
			{ 
				if ( strlen($hash[8]) == 0 )
				{
					$link = 'dir.php?id='.$hash[0]; 
				}
				else 
				{
					$link = './dir_'.urlencode($hash[8]).'.htm';
				}					
			}
			// if second level then assign and parse sub_units
			if ( $hash[2] > 0 ) 
			{
				if ( $sub_unit ) 
				{
					$tpl->Parse('SUBUNIT', ($id == $mTopic) ? '.sub_unit_sel' : '.sub_unit' );
				}
				$id = $hash[0];
				$tpl->Assign(array('LINK' => $link,
							   	   'NAME' => htmlspecialchars($hash[1]),
							   	   'HOW'  => ( $hash[5] == 0 ) ? '('.$hash[9].')' : '',
							   	   'ID'	  => $hash[0]
	    	   	 		           ));
				$sub_unit = TRUE;			   
			}			
			// if first level assign and parse units
			if ( ($hash[2] == 0) || ($i == $rows+1) ) 
			{
				// parse last sub unit
				if ( $sub_unit ) 
				{
					$tpl->Parse('SUBUNIT', ($id == $mTopic) ? '.sub_unit_sel' : '.sub_unit' );
					$sub_unit = FALSE;
				}	
				// parse layer	
				if ( $unit ) 
				{
					$how_layer++;
					if ( $unit_div ) $tpl->Parse(UNIT, '.divider');
					$tpl->Assign(array('LINK' => $unit_link,
								   	   'NUM'  => $how_layer,
							   	   	   'NAME' => htmlspecialchars($unit_name),
							   	   	   'HOW'  => $unit_how,
							   	   	   'ID'	  => $unit_id
	    	   	 		           	    ));
	    	   	 	$tpl->Parse('LAYER', 'layer');
					$sel = ( $mTopic == $unit_id ) ? '_sel' : '';
	    	   	 	$tpl->Parse('UNIT', '.unit_'.$page_type[$unit_type].$sel);
				}
				$unit = TRUE;		
				$unit_link = $link;
				$unit_name = $hash[1];
				$unit_id = $hash[0];
				$unit_div = ( $hash[4] == 1 );
				$unit_type = $hash[5];
				$unit_how = ( $hash[5] == 0 ) ? $hash[9] : '';
				$tpl->Assign('SUBUNIT', '');
			}
		}
		$tpl->Assign('HOWLAYER', $how_layer); 
		// Parse main page
		$tpl->Parse('MAIN', 'main');
		$to_parse['CATMENU'] = $tpl->Fetch('MAIN');
	}	
	else 
	{
		$to_parse['CATMENU'] = '';
	}

	
	// Parse page path
	//================	
	if ( $mTopic > 0 ) 
	{
		list($path, $link, $link_title) = $gData->GetPath($mTopic);
		$tpl = new FastTemplate('./'.TEMPLATES.'/sections/path');
		$tpl->DefineTemplate(array('main' 	=> 'main.htm',  	 
			 				   	   'unit'	=> 'unit.htm'
							  	  ));		
		$tpl->Assign('UNIT', '');
		foreach ( array_reverse($path, true) as $id => $name)
		{
			$tpl->Assign(array('LINK'  => $link[$id],
						   	   'NAME'  => htmlspecialchars($name),
						   	   'TITLE' => ( strlen($link_title[$id]) > 0 ) ? htmlspecialchars($link_title[$id]) : htmlspecialchars($name),
		        		       ));	
			if ( $mTopic == $id ) $to_parse['SECTIONNAME'] = $name;
			$tpl->Parse('UNIT', '.unit');
		}
		$tpl->Parse('PATH', 'main');
		$to_parse['PATH'] = $tpl->Fetch('PATH');
	}
	else
	{
		if ( !$mHiddenTopic )
		{
			$tpl = new FastTemplate('./'.TEMPLATES.'/sections/path');
			$tpl->DefineTemplate(array('search'	=> 'search.htm'));
			$to_parse['PATH'] = $tpl->FetchTpl('search');
		}
		else 
		{
			$to_parse['PATH'] = '';
		}
	}
	
	return $to_parse;
}



/**
 * Function sub sections search
 * Return text block of sub sections for search goods
 **/
function sub_sections_search($mApplyFilter, $mFilterPath)
{
	global $gData, $gOptions;
	
	// Init templates
	$tpl = new FastTemplate('./'.TEMPLATES.'/sections/sub/search');
	$tpl->DefineTemplate(array('main' 			=> 'main.htm',  	 
			 				   'between_row'	=> 'between_row.htm',
			    			   'unit'			=> 'unit.htm'
							  ));
	
	// Parse sections
	$topic = $gData->GetSubSectionsSearch($mApplyFilter);
	$rows = $gData->GetNumRows($topic);
	$col_cnt = 1;
	if ( $rows == 0 ) return '';
	for ( $i = 1; $i <= $rows; $i++ ) 
	{
		$hash = $gData->FetchRow($topic);
		if ( ($col_cnt == $gOptions['main_sub_sec_col']) && ($i <> $rows) ) 
		{
			$tpl->Parse('BETWEENROW', 'between_row');  
			$col_cnt = 1; 
		} 
		else 
		{ 
			$tpl->Assign('BETWEENROW', ''); 
			$col_cnt += 1; 
		}
		if ( is_file('./files/topic'.$hash[0].'.jpg') ) 
		{
		    $img_file = 'files/topic'.$hash[0].'.jpg';
		} 
		else
		{
			$img_file = 'files/topic_default.jpg';
		}
		if ($hash[5] == 2) 
		{ 
			$link = $hash[6]; 
		} 
		else 
		{ 
			if ( strlen($hash[8]) == 0 || strlen($mFilterPath) > 0 )
			{
				$link = "dir.php?id=".$hash[0].$mFilterPath; 
			}
			else 
			{
				$link = './dir_'.urlencode($hash[8]).'.htm';
			}			
			
		}
		$tpl->Assign(array('LINK' 	=> $link,
					   	   'NAME' 	=> htmlspecialchars($hash[1]),
						   'DESCR'	=> $hash[4],
						   'ICON'   => $img_file,
						   'TITLE'	=> ( strlen($hash[7]) > 0 ) ? htmlspecialchars($hash[7]) : htmlspecialchars($hash[1]),
						   'HOW'	=> ( $hash[5] == 0 ) ? '('.$hash[9].')' : '',
						   'ID'		=> $hash[0]
	        		       ));
		$tpl->Parse('UNIT', '.unit'); 
	}
	$tpl->Assign('COLSPAN', $gOptions['main_sub_sec_col']);
	
	// Parse main page
	$tpl->Parse('MAIN', 'main');
	
	return $tpl->Fetch('MAIN');
}



/**
 * Function sub sections simple
 * Return text block of sub sections simple list
 **/
function sub_sections_simple($mTopic)
{
	global $gData, $gOptions;
	
	// Init templates
	$tpl = new FastTemplate('./'.TEMPLATES.'/sections/sub/simple');
	$tpl->DefineTemplate(array('main' 			=> 'main.htm',  	 
			 				   'between_row'	=> 'between_row.htm',
			    			   'unit'			=> 'unit.htm'
							  ));
	
	// Parse sections
	$topic = $gData->GetSubSectionsSimple($mTopic);
	$rows = $gData->GetNumRows($topic);
	$col_cnt = 1;
	if ( $rows == 0 ) return '';
	for ( $i = 1; $i <= $rows; $i++ ) 
	{
		$hash = $gData->FetchRow($topic);
		if ( ($col_cnt == $gOptions['main_sub_sec_col']) && ($i <> $rows) ) 
		{
			$tpl->Parse('BETWEENROW', 'between_row');  
			$col_cnt = 1; 
		} 
		else 
		{ 
			$tpl->Assign('BETWEENROW', ''); 
			$col_cnt += 1; 
		}
		if ( is_file('./files/topic'.$hash[0].'.jpg') ) 
		{
		    $img_file = 'files/topic'.$hash[0].'.jpg';
		} 
		else
		{
			$img_file = 'files/topic_default.jpg';
		}
		if ($hash[5] == 2) 
		{ 
			$link = $hash[6]; 
		} 
		else 
		{ 
			if ( strlen($hash[8]) == 0 )
			{
				$link = "dir.php?id=".$hash[0]; 
			}
			else 
			{
				$link = './dir_'.urlencode($hash[8]).'.htm';
			}			
		}
		$tpl->Assign(array('LINK' 	=> $link,
					   	   'NAME' 	=> htmlspecialchars($hash[1]),
						   'DESCR'	=> $hash[4],
						   'ICON'   => $img_file,
						   'TITLE'	=> ( strlen($hash[7]) > 0 ) ? htmlspecialchars($hash[7]) : htmlspecialchars($hash[1]),
						   'HOW'	=> ( $hash[5] == 0 ) ? '('.$hash[9].')' : '',
						   'ID'		=> $hash[0]
	        		       ));
		$tpl->Parse('UNIT', '.unit'); 
	}
	$tpl->Assign('COLSPAN', $gOptions['main_sub_sec_col']);
	
	// Parse main page
	$tpl->Parse('MAIN', 'main');
	
	return $tpl->Fetch('MAIN');
}


/**
 * Function sub sections hard
 * Return text block of sub sections hard list
 **/
function sub_sections_hard($mTopic, $mLevel)
{
	global $gData, $gOptions;
	
	
	//Get Data
	$topic = $gData->GetSubSectionsHard($mTopic);
	$rows = $gData->GetNumRows($topic);
	// Init templates
	$tpl = new FastTemplate('./'.TEMPLATES.'/sections/sub/hard');
	$tpl->DefineTemplate(array('main' 			=> 'main.htm',  
							   'unit'			=> 'unit.htm',
							   'sub_unit'		=> 'sub_unit.htm',
							   'unit_br'		=> 'unit_br.htm',
							   'sub_unit_br'	=> 'sub_unit_br.htm',
							   'unit_empty'		=> 'unit_empty.htm'
							   ));
	$unit = false;	
	$sub_unit = false;	
	$col_cnt = 1;			
	if ( $rows == 0 ) return '';
	for ( $i = 1; $i <= $rows+1; $i++ ) 
	{
		$hash = $gData->FetchRow($topic);
		if ($hash[5] == 2) 
		{ 
			$link = $hash[6]; 
		} 
		else 
		{ 
			if ( strlen($hash[8]) == 0 )
			{
				$link = "dir.php?id=".$hash[0]; 
			}
			else 
			{
				$link = './dir_'.urlencode($hash[8]).'.htm';
			}			
		}
		// if second level then assign and parse sub_units
		if ( $hash[2]-$mLevel > 1 ) 
		{
			if ( $sub_unit ) 
			{
			    $tpl->Parse('SUBUNITBR', 'sub_unit_br');
				$tpl->Parse('SUBUNIT', '.sub_unit');
			}					
			$tpl->Assign(array('LINK' 	=> $link,
						   	   'NAME' 	=> htmlspecialchars($hash[1]),
						   	   'TITLE'	=> ( strlen($hash[7]) > 0 ) ? htmlspecialchars($hash[7]) : htmlspecialchars($hash[1]),
						   	   'HOW'  	=> ( $hash[5] == 0 ) ? '('.$hash[9].')' : '',
						   	   'ID'		=> $hash[0]
    	   	 		           ));
			$sub_unit = TRUE;			   
		}			
		// if first level assign and parse units
		if ( ($hash[2] - $mLevel == 1) || ($i == $rows + 1) ) 
		{
			// define icon file
			if ( is_file('./files/topic'.$hash[0].'.jpg') ) 
			{
		   		$img_file = 'files/topic'.$hash[0].'.jpg';
			} 
			else
			{
				$img_file = 'files/topic_default.jpg';
			}
			// parse last sub unit
			if ( $sub_unit ) 
			{
			    $tpl->Assign('SUBUNITBR', '');
				$tpl->Parse('SUBUNIT', '.sub_unit');
				$sub_unit = FALSE;
			}	
			// parse unit				
			if ( $unit ) 
			{
				// parse on colums
				if ( ($col_cnt == $gOptions['main_sub_sec_col']) && ($i <> $rows+1) ) 
				{
					$tpl->Parse('UNITBR', 'unit_br');
					$col_cnt = 1; 
				} 
				else 
				{ 
					$tpl->Assign('UNITBR', ''); 
					$col_cnt += 1; 
				}
				$tpl->Assign(array('LINK' 	=> $unit_link,
								   'ICON' 	=> $unit_icon,
							   	   'NAME' 	=> $unit_name,
							   	   'DESCR'	=> $unit_descr,
							   	   'TITLE'  => ( strlen($unit_title) > 0 ) ? $unit_title : $unit_name,
							   	   'HOW'  	=> $unit_how,
							   	   'ID'	    => $hash[0]
    	   		 		           ));
				$tpl->parse('UNIT', '.unit');
			}
			$unit = TRUE;		
			$unit_link = $link;
			$unit_icon = $img_file;
			$unit_name = htmlspecialchars($hash[1]);
			$unit_descr = $hash[4];
			$unit_title = htmlspecialchars($hash[7]);
			$unit_how = ( $hash[5] == 0 ) ? '('.$hash[9].')' : '';
			$unit_id = $hash[0];
			$tpl->Assign('SUBUNIT', '');
		}
	}
	// Parsing empty units  
	for ( $i = $col_cnt; $i <= $gOptions['main_sub_sec_col']; $i++ ) 
	{
		$tpl->parse('UNIT', '.unit_empty');
	}
	// Parse main page
	$tpl->Parse('MAIN', 'main');

	return $tpl->Fetch('MAIN');
}

?>