<?php

/**
 * server.php
 * ----------
 * @version 5.4.0
 * @copyright 2002-2010 Melbis Company
 * @link http://www.melbis.com
 * @author Dmitriy Kasyanov
 **/

// Define script folder 
define('FOLDER', './../');
 
// Require classes and includes
require_once('./privat/privat.php');
$gNewCWD = 'FALSE';
if ( !file_exists(SHOP_CWD.'/admin/includes/common.php') ) 
{
    chdir('./..');
	$gCWD= getcwd();
	$gNewCWD = 'TRUE';
	chdir('./admin');
}
else
{
	$gCWD = '';
}
require_once('./includes/common.php');
require_once('./includes/admin.php');
require_once('./class/show/class.XML.php');
require_once('./class/util/class.PclZip.php');

// Set time limit 
@set_time_limit(300); 

// Start session
session_start();

// What you need?
switch ($_POST['command'])
{
	case 'GET_SERVER_PARAMS' : 
		get_server_params(); 
	 	break;
	case 'SAVE_SERVER_PARAMS' : 
		save_server_params(); 
		break;
	case 'TEST_SERVER_PARAMS' : 
		test_server_params(); 
		break;
	case 'INSTALL_TABLES' : 
		install_tables(); 
		break;
	case 'REPAIR_TABLES' : 
		repair_tables(); 
		break;
	case 'DOWNLOAD_TEMPLATES' : 
		download_templates(); 
		break;
	case 'UPLOAD_TEMPLATES' : 
		upload_templates(); 
		break;
	default : 
		echo "PHP_ERROR: Unknow command in line [".__LINE__."] :: Fail Command";
}


/**
 * Function get_server_params
 * Return server parameters from file privat.php
 **/
function get_server_params()
{
	global $gNewCWD, $gCWD;
	
	
	// Start XML file
	$xml_file = './tmp/'.md5(session_id()).'.xml';
	$xml = new XML(SHOP_CHARSET, $xml_file);
	$xml->StartTag('MELBISSHOP');
	$xml->PutTag('SCRIPT_VERSION', array(), SCRIPT_VERSION);
	$xml->PutTag('MYIP', array(), user_ip());
	$xml->PutTag('NEWCWD', array(), $gNewCWD);
	$xml->PutTag('SEC_ENTER_IP', array(), SEC_ENTER_IP);
	$xml->PutTag('DB_TYPE', array(), DB_TYPE);
	$xml->PutTag('DB_HOST_NAME', array(), DB_HOST_NAME);
	$xml->PutTag('DB_USER_NAME', array(), DB_USER_NAME);
	$xml->PutTag('DB_USER_PASS', array(), DB_USER_PASS);
	$xml->PutTag('DB_NAME', array(), DB_NAME);
	$xml->PutTag('DB_NICK', array(), DB_NICK);
	$xml->PutTag('MAIL_SERVER', array(), MAIL_SERVER);
	$xml->PutTag('SHOP_GMT', array(), SHOP_GMT);
	( $gNewCWD != 'TRUE' ) ? $xml->PutTag('SHOP_CWD', array(), SHOP_CWD)
						   : $xml->PutTag('SHOP_CWD', array(), $gCWD);
	$xml->PutTag('SHOP_LOCALE', array(), SHOP_LOCALE);
	$xml->PutTag('SHOP_CHARSET', array(), SHOP_CHARSET);
	$xml->PutTag('TEMPLATES', array(), TEMPLATES);
	$xml->PutTag('AGENT_PASS', array(), AGENT_PASS);
	$xml->PutTag('SPIDER_PASS', array(), SPIDER_PASS);
	$xml->PutTag('LOCK_SHOP', array(), LOCK_SHOP);
	$xml->CloseTag('MELBISSHOP');
	$xml->Free();
	
	// Put result to archive
	xml_to_zip_answer($xml_file);
}


/**
 * Function save_server_params
 * Save server parameters in file privat.php
 **/
function save_server_params()
{
	$post_values = xml_to_array($_POST['values']);
	foreach ( $post_values as $key => $value )
	{
		$param[$key] = ( $key == 'SEC_PASSWORD' ) ? md5(iconv("UTF-8", SHOP_CHARSET, $value))
												  : iconv("UTF-8", SHOP_CHARSET, $value);
	}	
	if ( !isset($param['SEC_PASSWORD']) ) $param['SEC_PASSWORD'] = SEC_PASSWORD;
	$fd = @fopen('./privat/privat.php', "w");
	if ( !$fd ) die("PHP_ERROR: Wrong mode for /admin/privat/privat.php, need read/write/execute access mode");
	$line = "<?php\n"; 
	fputs($fd, $line, strlen($line));
	$line = 'define(\'SCRIPT_VERSION\', \''.SCRIPT_VERSION.'\');'."\n";
	fputs($fd, $line, strlen($line));	
	foreach ( $param as $key => $value )
	{
		$line = 'define(\''.addslashes($key).'\', \''.addslashes($value).'\');'."\n";
		fputs($fd, $line, strlen($line));
	}
	$line = '?>'; 
	fputs($fd, $line, strlen($line));
	fclose($fd);
	echo "QUERY_EXECUTE";
}

/**
 * Function test_server_params
 * Test server parametrs, try connect to database
 **/
function test_server_params()
{
	$post_values = xml_to_array($_POST['values']);
	foreach ( $post_values as $key => $value )
	{
		$param[$key] = $value;
	}		
	$data = data_connect(true, $param, true);
	echo "QUERY_EXECUTE";
}

/**
 * Function install_tables
 * Do tables installation in database
 **/
function install_tables()
{
	$post_values = xml_to_array($_POST['values']);
	foreach ( $post_values as $key => $value )
	{
		$param[$key] = $value;
	}		
	$data = data_connect(true, $param, true);
	$data->InstallTables();
	
	echo "QUERY_EXECUTE";
}

/**
 * Function repair_tables
 * Repair tables in database
 **/
function repair_tables()
{
	$post_values = xml_to_array($_POST['values']);
	foreach ( $post_values as $key => $value )
	{
		$param[$key] = $value;
	}		
	$data = data_connect(true, $param, true);
	$data->RepairTables();
	
	echo "QUERY_EXECUTE";
}

/**
 * Function download_templates
 * Download templates archive
 **/
function download_templates()
{
	$template_dir = $_POST['values'];

	echo "ZIP_FILE";
	
 	$archive = new PclZip(SHOP_CWD.'/admin/tmp/templates.zip');
  	$v_list = $archive->create(SHOP_CWD.'/'.trim($template_dir, '/'), PCLZIP_OPT_REMOVE_PATH, SHOP_CWD.'/'.trim($template_dir, '/'));
  	if ( $v_list == 0 ) 
  	{
    	die("PHP_ERROR: Error line [".__LINE__."] \r\n".$archive->errorInfo(true));
  	}
  	
  	echo @implode("", (file(SHOP_CWD.'/admin/tmp/templates.zip')));
  	
  	@unlink(SHOP_CWD.'/admin/tmp/templates.zip');
  	
}

/**
 * Function del_dir
 * Delete file
 **/
function del_dir( $mFile, $mMainDir = false ) 
{
	if ( is_dir($mFile) ) 
	{
 		$handle = @opendir($mFile); 
 		while( $filename = @readdir($handle) ) 
 		{
  			if ( $filename != '.' && $filename != '..' ) 
  			{
   				del_dir($mFile.'/'.$filename);
  			}
 		}
 		@closedir($handle);
 		if ( !$mMainDir ) @rmdir($mFile);
	} 
	else 
	{
 		@unlink($mFile);
	}
}

/**
 * Function upload_templates
 * Upload templates archive
 **/
function upload_templates()
{
	$template_dir = $_POST['values'];

	if ( !file_exists($_FILES['data_file']['tmp_name']) ) die("PHP_ERROR: Don't received data file");

	// Remove all old data
	chdir(SHOP_CWD);
	del_dir(trim($template_dir, '/'), true);
	
	// Unpack new data
	$Archive = new PclZip($_FILES['data_file']['tmp_name']);
	chdir(SHOP_CWD);
	if ( is_dir(trim($template_dir, '/')) )
	{
		if ( $Archive->extract(trim($template_dir, '/')) <= 0 ) die("PHP_ERROR: Archive unpack error");
	}
	else 
	{
		die("PHP_ERROR: Directory '".trim($template_dir, '/')."' don't exists");
	}
  	
  	echo "QUERY_EXECUTE";
}



?>