<?php

/**
 * templ.php
 * ---------
 * @version 5.4.0
 * @copyright 2002-2010 Melbis Company
 * @link http://www.melbis.com
 * @author Dmitriy Kasyanov
 **/
 
// Define script folder 
define('FOLDER', './../');

// Require classes and includes
require_once('./privat/privat.php');
require_once('./includes/common.php');
require_once('./includes/admin.php');
require_once('./class/show/class.XML.php');
require_once('./class/util/class.PclZip.php');

// Set time limit 
@set_time_limit(300); 

// Start session
session_start();

// Connect to Data
$gData = data_connect(true);

// What you need?
switch ($_POST['command'])
{
	case 'GET_TREE_LIST' : 
		get_tree_list(); 
		break;
	case 'GET_TEMPL_FILE' : 
		get_templ_file(); 
		break;
	case 'SAVE_TEMPL_FILE' : 
		save_templ_file(); 
		break;		
	default : 
		echo "PHP_ERROR: Unknow command in line [".__LINE__."] :: Fail Command";
}

/**
* Function dir_content
* Return dir content
**/
function dir_content($mDir, &$mReestr)
{
	$dir = opendir(str_replace('/0', '/', $mDir));
	while ( false !== ($file = readdir($dir)) ) 
	{ 
		if ( $file == "." || $file == ".." ) continue;
	 	if ( is_dir(str_replace('/0', '/', $mDir).$file) ) dir_content($mDir.'0'.$file.'/', $mReestr);
	 	if ( is_file(str_replace('/0', '/', $mDir).$file) ) 
	 	{ 
	 		array_push($mReestr, $mDir.'1'.$file);
	 	}
	 	else 
	 	{
	 		array_push($mReestr, $mDir.'0'.$file);
	 	}
	}
	closedir($dir); 
}


/**
 * Function get_tree_list
 * Return tree list of templates
 **/
function get_tree_list()
{
	global $gData;

	// Start XML file
	$xml_file = './tmp/'.md5(session_id()).'.xml';
	$xml = new XML(SHOP_CHARSET, $xml_file);
	$xml->StartTag('MELBISSHOP');

	$reestr = array();
	dir_content('./../'.TEMPLATES.'/', $reestr);

	sort($reestr);
	reset($reestr);	
	foreach ( $reestr as $path) 
	{
		$dir = explode('/', substr($path, 6 +  strlen(TEMPLATES)));
		$level = count($dir)-1;
		$name = substr($dir[$level], 1);
		$type = ( substr($dir[$level], 0, 1) == 1 ) ? 'file' : 'dir';
		$xml->PutTag('RECORD', array('path'		=> str_replace('/1', '/', str_replace('/0', '/', substr($path, 5 +  strlen(TEMPLATES)))), 
									 'level'	=> $level, 
									 'name'		=> $name, 
									 'type'		=> $type));
	}
	
	$xml->CloseTag('MELBISSHOP');
	$xml->Free();
	
	// Put result to archive
	xml_to_zip_answer($xml_file);
}


/**
 * Function get_templ_file
 * Return file content for edit
 **/
function get_templ_file()
{
	global $gData;

	$file_name = './../'.TEMPLATES.$_POST['values'];

	$reestr = array();
	dir_content('./../'.TEMPLATES.'/', $reestr);
	
	$right_file	= false;
	foreach ( $reestr as $path) 
	{
		if ( str_replace('/1', '/', str_replace('/0', '/', $path)) == $file_name ) 
		{
			$right_file = true;
			break;
		}
	}
	if ( !$right_file ) 
	{
		"PHP_ERROR: Hack atac through file [".__LINE__."] :: Fail Command";	
		exit;
	}
	
	string_to_zip_answer( @implode("", (file($file_name))) );
}



/**
 * Function save_templ_file
 * Do save send file
 **/
function save_templ_file()
{
	global $gData;

	$file_name = './../'.TEMPLATES.$_POST['values'];
	$content = zip_file_to_string($_FILES['string_file']['tmp_name']);

	$reestr = array();
	dir_content('./../'.TEMPLATES.'/', $reestr);
	
	$right_file	= false;
	foreach ( $reestr as $path) 
	{
		if ( str_replace('/1', '/', str_replace('/0', '/', $path)) == $file_name ) 
		{
			$right_file = true;
			break;
		}
	}
	if ( !$right_file ) 
	{
		"PHP_ERROR: Hack atac through file [".__LINE__."] :: Fail Command";	
		exit;
	}
	
	$f_out = @fopen($file_name, 'w');
	if ( !$f_out ) die("PHP_ERROR: Wrong mode for ".SHOP_CWD."/".TEMPLATES.$_POST['values'].", need read/write access mode");
	fputs($f_out, $content);
	fclose($f_out);

	echo "QUERY_EXECUTE";
}

?>