<?php

/**
 * terminal.php
 * ------------
 * @version 5.4.0
 * @copyright 2002-2010 Melbis Company
 * @link http://www.melbis.com
 * @author Dmitriy Kasyanov
 **/
 
// Define script folder 
define('FOLDER', './../');


// Require classes and includes
require_once('./privat/privat.php');
require_once('./includes/common.php');
require_once('./includes/admin.php');
require_once('./class/show/class.XML.php');
require_once('./class/util/class.PclZip.php');

// Set time limit 
@set_time_limit(300); 

// Start session
session_start();

// Connect to Data
$gData = data_connect(true);

// Go!
main();

/**
 * Function main
 * Return result of SQL-query
 **/
function main()
{
	global $gData;

	// Start XML file
	$xml_file = './tmp/'.md5(session_id()).'.xml';
	$xml = new XML(SHOP_CHARSET, $xml_file);
	$xml->StartTag('MELBISSHOP', array('Version' => 'Melbis Shop v'.SCRIPT_VERSION));
	
	$answer = $gData->DoSQLCommand($_POST['command']);
	$rows = $gData->GetNumRows($answer);
	$fields = $gData->GetNumFields($answer);
	$xml->StartTag('FIELDS');
	for ( $n = 1; $n <= $fields; $n++ ) 
	{	
		$field_name[$n-1] = $gData->GetFieldName($answer, $n-1);
		$xml->PutTag('FIELD', array('name'	=> $field_name[$n-1]));
	}
	$xml->CloseTag('FIELDS');
	$xml->StartTag('TABLE');
	for ( $i = 1; $i <= $rows; $i++ ) 
	{	
		$hash = $gData->FetchHash($answer);
		$xml->PutTag('ROW', $hash);
	}
	$xml->CloseTag('TABLE');
	$xml->CloseTag('MELBISSHOP');
	$xml->Free();
	
	// Put result to archive
	xml_to_zip_answer($xml_file);
}

?>