<?php

/**
 * to_xml.php
 * ----------
 * @version 5.4.0
 * @copyright 2002-2010 Melbis Company
 * @link http://www.melbis.com
 * @author Dmitriy Kasyanov
 **/


// Define script folder 
define('FOLDER', './../');

 
// Require classes and includes
require_once('./privat/privat.php');
require_once('./includes/common.php');
require_once('./class/show/class.XML.php');

// Start sessions
shop_session();

// Go!
main();


/**
 * Function main
 **/
function main()
{
	global $gData, $gOptions, $gTpl, $gStartPoint;

	// Get start point for time
	$gStartPoint = run_time(0);
	
	// Connect to Data 
	$gData = data_connect();	

	$prec = $gOptions['main_prec'];
	$url = rtrim($gOptions['attr_base_url'], '/');	
	
	// Start XML file
	$xml_file = './tmp/'.md5(session_id()).'.xml';
	$xml = new XML(SHOP_CHARSET, $xml_file);
	$xml->StartTag('MELBISSHOP', array('Version' 	=> 'Melbis Shop v'.SCRIPT_VERSION,
									   'ShopName'	=> $gOptions['attr_shop_name'],
									   'Currency'	=> $gOptions['main_base_curr']
									   ));
	
	// Request topic & goods
	$topic = $gData->GetCatForXML();
	$rows = $gData->GetNumRows($topic);
	if ( $rows == 0 )  exit;	
	for ( $n = 1; $n <= $rows; $n++ ) 
	{			
		$hash = $gData->FetchRow($topic);
		// Create Topic
		if ( $hash[5] == 2 ) 
		{
			$link = $hash[6];
		}
		else 
		{
			if ( strlen($hash[8]) == 0 )
			{
				$link = "dir.php?id=".$hash[0].'&partner='.$_GET['id']; 
			}
			else 
			{
				$link = 'dir_'.urlencode($hash[8]).'.htm?partner='.$_GET['id'];
			}
		}		
		$xml->StartTag('TOPIC', array('id'		=> $hash[0],
									  'name' 	=> $hash[1],
									  'link'	=> $url.'/'.$link,
									  'level'	=> $hash[2],
									  'parent'	=> $hash[7]
									  ));
		// Create Goods
		$goods = $gData->GetGoodsForXML($hash[0]);
		$goods_rows = $gData->GetNumRows($goods);
		for ( $i = 1; $i <= $goods_rows; $i++ ) 
		{			
			$g_hash = $gData->FetchRow($goods);
			$price = ( $g_hash[11] > 0 ) ? $g_hash[11] : $g_hash[6];
			$link = ( strlen($g_hash[15]) > 0 ) ? 'goods_'.urlencode($g_hash[15]).'.htm?partner='.$_GET['id'] : 'goods.php?id='.$g_hash[0].'&partner='.$_GET['id'];
			$img_file = ( is_file('./../files/store'.$g_hash[0].'.jpg') ) ? 'files/store'.$g_hash[0].'.jpg' : 'files/store_default.jpg';
			$xml->PutTag('GOODS', array('id'			=> $g_hash[0],
										'code'			=> $g_hash[1],
									  	'name' 			=> $g_hash[3],
									  	'descr'			=> html2text($g_hash[5]),
									  	'base_price'	=> number_format($g_hash[6], $prec, "." ,""),
									  	'price'			=> number_format($price, $prec, "." ,""),
									  	'picture'		=> $url.'/'.$img_file,
										'link'			=> $url.'/'.$link,
										'how'			=> $g_hash[14],
										'meas'			=> $g_hash[2],
										'partner_proc'	=> number_format($g_hash[7], 2, "." ,"")
										));
		}
		$xml->CloseTag('TOPIC');
	}

	$xml->CloseTag('MELBISSHOP');
	$xml->Free();
	
	header('Content-type: text/xml; charset=UTF-8');
	echo implode('',file($xml_file));
	@unlink($xml_file);
	
}
?>