<?php

/**
 * trader.php
 * ----------
 * @version 5.4.0
 * @copyright 2002-2010 Melbis Company
 * @link http://www.melbis.com
 * @author Dmitriy Kasyanov
 **/
 
// Set Manager info
define('ITS_MANAGER', true); 

// Define script folder 
define('FOLDER', './../');

 
// Require classes and includes
require_once('./privat/privat.php');
require_once('./includes/common.php');
require_once('./includes/admin.php');
require_once('./includes/basket.php');
require_once('./includes/orders.php');
require_once('./class/show/class.XML.php');
require_once('./class/util/class.PclZip.php');
require_once('./class/util/class.Emailer.php');
require_once('./class/show/class.FastTemplate.php');

// Set time limit 
@set_time_limit(300); 

// Start session
session_start();

// Connect to Data
$gData = data_connect(true);

// Search manager
$gManager = $gData->ManagerLogin(addslashes($_POST['login']), addslashes($_POST['code']));
if ( ! is_array($gManager) ) 
{
	die("WRONG_PASSWORD");
}



// What you need?
switch ($_POST['command'])
{
	case 'GET_LAST_UPDATE' : 
		get_last_update(); 
		break;
	case 'GET_TABLES_INFO' : 
		get_tables_info();
		break;
	case 'GET_TABLE_DATA' : 
		get_table_data(); 
		break;		
	case 'SAVE_ORDER_NOTE' : 
		save_order_note(); 
		break;
	case 'UPDATE_ORDERS_ARCHIVE' : 
		update_orders_archive(); 
		break;
	case 'COMPARE_ARCHIVE_ORDERS' : 
		compare_archive_orders(); 
		break;
	case 'APPLY_ORDERS_UPDATE' : 
		apply_orders_update(); 
		break;
	case 'GET_CLIENT_FIELDS' : 
		get_client_fields(); 
		break;		
	case 'GET_ALL_CLIENTS' : 
		get_clients(false); 
		break;
	case 'SEARCH_CLIENTS' : 
		get_clients(true); 
		break;		
	default : 
		echo "PHP_ERROR: Unknow command in line [".__LINE__."] :: Fail Command";
}
 

/**
 * Function get_last_update
 * Get last update date time
 **/
function get_last_update()
{
	global $gOptions, $gManager;
	
	if ( strtotime($gOptions['main_update_time']) <= strtotime($_POST['values']) )
	{
		string_to_zip_answer('DONT_NEED_UPDATE');
	}
	else 
	{
		string_to_zip_answer($gManager['id']);
	}
	
	echo "QUERY_EXECUTE";
}

/**
 * Function get_tables_info
 * Get size data info of the tables
 **/
function get_tables_info()
{
	global $gData;
	
	
	// Start XML file
	$xml_file = './tmp/'.md5(session_id()).'.xml';
	$xml = new XML(SHOP_CHARSET, $xml_file);
	$xml->StartTag('MELBISSHOP', array('Version' => 'Melbis Shop v'.SCRIPT_VERSION));	
	
	// Request tables
	$info = $gData->GetTableStatus();
	$rows = $gData->GetNumRows($info);
	$xml->StartTag('TABLES', array('total' => $rows, 'transfer' => $rows));
	for ( $i = 1; $i <= $rows; $i++ ) 
	{	
		$hash = $gData->FetchHash($info);
		if ( substr($hash['Name'], 0, strlen(DB_NICK.'_')) != DB_NICK.'_' ) continue;
		$hash['Name'] = substr($hash['Name'], strlen(DB_NICK.'_'));
		$xml->PutTag('TABLE', $hash);
	}
	$xml->CloseTag('TABLES');
	$xml->CloseTag('MELBISSHOP');
	$xml->Free();
	
	// Put result to archive
	xml_to_zip_answer($xml_file);
}


/**
 * Function get_table_data
 * Get specificate table data
 **/
function get_table_data()
{
	global $gData;
	

	// Start XML file
	$xml_file = './tmp/'.md5(session_id()).'.xml';
	$xml = new XML(SHOP_CHARSET, $xml_file);
	$xml->StartTag('MELBISSHOP', array('Version' => 'Melbis Shop v'.SCRIPT_VERSION));	
	
	// Request data
	list ($table, $field_list, $start_field, $how_field) = explode(';', $_POST['values']);
	$info = $gData->GetTableValues($table, $field_list, '', false, ($start_field-1).', '.$how_field);
	$rows = $gData->GetNumRows($info);
	$xml->StartTag('PART', array('start' => $start_field, 'how' => $how_field));
	for ( $i = 1; $i <= $rows; $i++ ) 
	{	
		$xml->PutTag('ROW',  $gData->FetchHash($info));
	}
	$xml->CloseTag('PART');
	$xml->CloseTag('MELBISSHOP');
	$xml->Free();
	
	// Put result to archive
	xml_to_zip_answer($xml_file);
}


/**
 * Function apply_orders_update
 * Testing update rules for managers
 **/
function apply_orders_update()
{
	global $gData, $gOptions, $gManager;
	
	
	// Start XML file
	$xml_file = './tmp/'.md5(session_id()).'.xml';
	$xml = new XML(SHOP_CHARSET, $xml_file);
	$xml->StartTag('MELBISSHOP');	
	
	$order_put_result = array();
	
	$orders_tree = xml_get_tree(zip_file_to_string($_FILES['string_file']['tmp_name']));	
	$order_how = count($orders_tree['children']);
	for ( $i = 0; $i <= $order_how-1; $i++ )
	{
		$order = $orders_tree['children'][$i]['attributes']; 
		
		$goods = array();
		$goods_how = count($orders_tree['children'][$i]['children'][0]['children']);
		for ( $n = 0; $n <= $goods_how-1; $n++ )
		{
			$goods[] = $orders_tree['children'][$i]['children'][0]['children'][$n]['attributes'];
		}		
		
		$fields = array();
		$field_how = count($orders_tree['children'][$i]['children'][1]['children']);
		for ( $n = 0; $n <= $field_how-1; $n++ )
		{
			$fields[] = $orders_tree['children'][$i]['children'][1]['children'][$n]['attributes'];
		}	
		
		if ( $order['order_id']	== 0 ) 
		{
			$order['manager_id'] = $gManager['id'];
			$result = order_archive_insert($order, $goods, $fields);
			if ( $result['result'] == 'AddOK' )
			{
				$order_xml = get_order_xml($result['order_id']);
			}
			else 
			{
				$order_xml = '';
			}
		}
		else 
		{
			$hash = $gData->GetArchiveOrder($order['order_id']);
			if ( $hash['manager_id'] > 0 && $hash['manager_id'] != $gManager['id'] )
			{ 
				$result = array('id' 				=> $order['id'], 
			             		'result' 			=> 'ErrorManagerExists', 
						 		'order_code' 		=> $order['code'], 
						 		'order_date_time' 	=> date($gOptions['main_fmt_date_time'], strtotime($order['date_time'])));
				$order_xml = '';
			}
			else 
			{
				$order['manager_id'] = $gManager['id'];
				$result = order_archive_update($order, $goods, $fields);
				if ( $result['result'] == 'EditOK' )
				{
					$order_xml = get_order_xml($result['order_id']);
				}
				else 
				{
					$order_xml = '';
				}
			}
		}
		$xml->StartTag('ORDER', $result);
		$xml->PutXML($order_xml);
		$xml->CloseTag('ORDER');
	}
	
	$xml->CloseTag('MELBISSHOP');
	$xml->Free();
	
	// Put result to archive
	xml_to_zip_answer($xml_file);	
}

/**
 * Function get_clients
 * Return clients and their fields
 **/
function get_clients($mSearch)
{
	global $gData;
	
	// Prepare if do search
	if ( $mSearch ) 
	{
		$vars = explode('&', zip_file_to_string($_FILES['string_file']['tmp_name']));
		foreach ($vars as $var)
		{
			list($key, $value) = explode('=', $var);
			$input[$key] = urldecode($value);
		}
	}

	// Start XML file
	$xml_file = './tmp/'.md5(session_id()).'.xml';
	$xml = new XML(SHOP_CHARSET, $xml_file);
	$xml->StartTag('MELBISSHOP');
		
	// Parse client
	$clients = $gData->GetAllClients($input);
	$rows = $gData->GetNumRows($clients);
	$how = ( $rows > 500 ) ? 500 : $rows;
	$xml->StartTag('CLIENTS', array('total' => $rows, 'transfer' => $how));
	for ( $i = 1; $i <= $how; $i++ ) 
	{	
		$client = $gData->FetchHash($clients);
		unset($client['charset']);
		$xml->PutTag('CLIENT', $client);		
	}
	$xml->CloseTag('CLIENTS');
	
	// Parse client fields
	$gData->DataSeek($clients, 0);
	$xml->StartTag('CLIENTFIELD');
	for ( $i = 1; $i <= $how; $i++ ) 
	{	
		$client = $gData->FetchHash($clients);

		$field = $gData->GetClientData($client['id']);
		$field_rows = $gData->GetNumRows($field);
		
		for ( $n = 1; $n <= $field_rows; $n++ ) 
		{	
			$hash = $gData->FetchHash($field);
			( $hash['isfolder'] != 1 ) ? $dot = ' ' : $dot = '';
			$hash['name'] = str_repeat('    ', $hash['tlevel']).$dot.$hash['name'];
			$hash['client_id'] = $client['id'];
			unset($hash['descr']);
			unset($hash['tlevel']);
			unset($hash['tindex']);
			unset($hash['need']);
			$xml->PutTag('FIELD', $hash);
		}
	}
	$xml->CloseTag('CLIENTFIELD');
	
	
	$xml->CloseTag('MELBISSHOP');
	$xml->Free();
	
	// Put result to archive
	xml_to_zip_answer($xml_file);	
}



?>