<?php

/**
 * basket.php
 * ----------
 * @version 5.4.0
 * @copyright 2002-2010 Melbis Company
 * @link http://www.melbis.com
 * @author Dmitriy Kasyanov
 **/

// Define script folder 
define('FOLDER', './');
 
// Require classes and includes
require_once('./admin/privat/privat.php');
require_once('./admin/includes/common.php');
require_once('./admin/includes/client.php');
require_once('./admin/includes/goods.php');
require_once('./admin/includes/basket.php');
require_once('./admin/includes/section.php');
require_once('./admin/class/show/class.FastTemplate.php');

// Start sessions
shop_session();


// Go!
main();


/**
 * Function main
 **/
function main()
{
	global $gData, $gOptions, $gTpl, $gStartPoint;

	// Get start point for time
	$gStartPoint = run_time(0);
	
	// Connect to Data 
	$gData = data_connect();	

	// Get base shop options
	if ($_SESSION['payment']['multiplex']*1 > 0) 
	{
	    $gOptions['main_base_curr'] = $_SESSION['payment']['curr_name'];
		$gOptions['main_prec'] = $_SESSION['payment']['curr_prec'];
	}		

	// Double order if need
	if ( isset($_GET['double_sid']) ) order_double($_GET['double_id']*1, $_GET['double_sid']);
	
	// Define client
	if ( !isset($_SESSION['client']) ) 
	{ 
		new_client(); 
	}

	// Test for reload database
	if ( test_basket_reload() ) exit;
	
	// Make path for back
	make_back_path();	
	
	// Save basket goods 
	if ( $_POST['action'] == 'save' ) save_basket();
	
	// Init templates
	$gTpl = new FastTemplate('./'.TEMPLATES);
	$gTpl->DefineTemplate(array('blank' 		=> 'blank.htm',
							    'main'			=> '_basket/main.htm',
							    'unit'			=> '_basket/unit.htm',
							    'unit_gift'		=> '_basket/unit_gift.htm',
							    'empty'			=> '_basket/empty.htm',
							    'status0'		=> '_basket/status0.htm',
							    'status1'		=> '_basket/status1.htm',
							    'status2'		=> '_basket/status2.htm',
							    'status3'		=> '_basket/status3.htm',
							    'page_title'	=> '_basket/page_title.htm'
							    ));
	
	// Define useful variales
	$ic_value = $_SESSION['payment']['multiplex']*1;
	
	// Get Goods list
	$goods = $gData->GetCurrentBasket(session_id());
	$rows = $gData->GetNumRows($goods);
	$_SESSION['total_sum'] = 0;
	$_SESSION['how_ordered'] = 0;
	if ( $rows > 0 ) 
	{
	    // Parse goods
		$itogo_sum = 0;
		$basket_num = '';
		for ( $i = 1; $i <= $rows; $i++ ) 
		{			
			$hash = $gData->FetchHash($goods);
			
			// Calc prices
			list($price, $new_price) = calc_basket_goods($hash, $_SESSION['client']);
			$disc_suma = $price - $new_price;
			
			// Total sum
			$itogo_sum += $new_price*$hash['how'];
			$itogo = $new_price*$hash['how'];

			// Info currency
			if ( $ic_value > 0 ) 
			{
				$itogo = round($itogo*$ic_value, 2);
				$price = round($price*$ic_value, 2);
				$new_price = round($new_price*$ic_value, 2);
				$disc_suma = round($disc_suma*$ic_value, 2);
			}	
			
			// Icon
			if ( is_file('./files/store'.$hash['store_id'].'.jpg') ) 
			{
			    $img_file = 'files/store'.$hash['store_id'].'.jpg';
			} 
			else
			{
				$img_file = 'files/store_default.jpg';
			}		
			
			// Assign vars
			$gTpl->Assign(array('NAME'  	=> htmlspecialchars($hash['name']),
							    'MEAS'		=> htmlspecialchars($hash['meas']),
							    'CODE'		=> htmlspecialchars($hash['code']),
							    'KIT'		=> htmlspecialchars($hash['param_name']),
							    'PRICE'		=> number_format($price, $gOptions['main_prec'], "," ,"'"),
							    'NEWPRICE'	=> number_format($new_price, $gOptions['main_prec'], "," ,"'"),
							    'DISCSUMA'	=> number_format($disc_suma, $gOptions['main_prec'], "," ,"'"),
							    'SUMASEL'	=> ($disc_suma != 0) ? '1' : '0',
							    'ITOGO'		=> number_format($itogo, $gOptions['main_prec'], "," ,"'"),
			   				    'HOW' 		=> $hash['how'],
							    'ID'		=> $hash['id'],
							    'ICON'		=> $img_file,
							    'STOREID'	=> $hash['store_id'],
							    'MAXORDER'	=> $hash['max_order'],
							    'MINORDER'  => $hash['min_order'],
							    'STEPORDER'	=> $hash['step_order']
        			            ));			
			$gTpl->Parse('STATUS', 'status'.$hash['status']);
			$gTpl->Parse('UNIT', '.unit');
			$basket_num .= $hash[id].'I';
			$_SESSION['how_ordered'] += $hash['how'];
		}
		// Parse gifts
		$gift = $gData->GetGiftForSum($itogo_sum);
		$rows = $gData->GetNumRows($gift);
		for ( $i = 1; $i <= $rows; $i++ ) 
		{			
			$hash = $gData->FetchHash($gift);
			$gTpl->Assign(array('NAME'  	=> htmlspecialchars($hash['name']),
							    'CODE'		=> htmlspecialchars($hash['code']),
							    'NOTE'		=> $hash['descr'],
							    'STOREID'	=> $hash['id']
        			            ));			
			$gTpl->Parse('UNIT', '.unit_gift');			
		}		
		
		// Common discount for order sum
		$disc_order_sum = $_SESSION['client']['suma'];
		if ( $_SESSION['client']['proc'] == 0 && $_SESSION['client']['suma'] == 0 && $_SESSION['client']['category_id'] == 0 ) 
		{
			$calc_disc_sum = ( $gOptions['main_disc_type'] == 'True' ) ? $itogo_sum + $_SESSION['client']['orders_suma']*1 : $itogo_sum;
			$disc = $gData->GetDiscountOrder($calc_disc_sum);
			if ( $disc['id'] > 0 ) $disc_order_sum = round($itogo_sum * $disc['proc'] / 100, 2);
		}
		$total_sum = $itogo_sum - $disc_order_sum;
		$_SESSION['total_sum'] = round($total_sum, 2);
		
		// Info currency
		if ( $ic_value > 0 ) 
		{
			$itogo_sum = round($itogo_sum*$ic_value, 2);
			$disc_order_sum = round($disc_order_sum*$ic_value, 2);
			$total_sum = round($total_sum*$ic_value, 2);
		}			
		$gTpl->Assign(array('ITOGOSUM'	=> number_format($itogo_sum, $gOptions['main_prec'], "," ,"'"),
						    'DISCSUM'	=> number_format($disc_order_sum, $gOptions['main_prec'], "," ,"'"),
						    'DISCSEL'	=> ($disc_order_sum != 0) ? '1' : '0',
						    'TOTALSUM'	=> number_format($total_sum, $gOptions['main_prec'], "," ,"'"),
						    'BASKETNUM'	=> $basket_num
					));
		$gTpl->Parse('CONTENT', 'main');
	}
	else
	{
		$gTpl->Parse('CONTENT', 'empty');
	}
	
	// Echo shop variables
	echo_shop_variables('in_techpage', true);	

	// Additional modules
	use_php_mod('other');
	
	$gTpl->Parse('PAGETITLE', 'page_title');
					   	
	// Parse main page
	$gTpl->Parse('BLANK', 'blank');
	$gEndPoint = run_time($gStartPoint);
	$gTpl->FastPrint('BLANK');
	
	// Echo page compilate time
	echo_page_time($gEndPoint);
		
}



/**
 * Function save_basket
 * Save changes to current basket
 **/
function save_basket()
{
	global $gData;
	
	// Get Goods options
	$goods = $gData->GetCurrentBasket(session_id());
	$rows = $gData->GetNumRows($goods);
	
	if ( $rows > 0 ) 
	{
	    // Calc changes
		for ( $i = 1; $i <= $rows; $i++ ) 
		{			
			$hash = $gData->FetchHash($goods);
			$how = $_POST['how'.$hash['id']]*1;
			if ( $how > 0 ) 
			{
				$max_order = $gData->GetMaxOrderGoods($hash['store_id'], $hash['param_value_id']);
				if ( $how > $max_order ) $how = $max_order;
				if ( $how != $max_order )
				{
					$how = $how - ($how % $hash['step_order']);
					if ( $how < $hash['step_order'] ) $how = $hash['step_order'];
					if ( $how < $hash['min_order'] ) $how = $hash['min_order'];
				}
			    
				$gData->UpdateCurrentBasket($hash['id'], $how);
			}
			else
			{
				$gData->RemoveCurrentBasket($hash['id']);
			}
		}	
	}
}



/**
 * Function order_double
 * Doublecate order to current basket
 **/
function order_double($mID, $mSID)
{
	global $gData;

	// Load order
	$order = $gData->GetArchiveOrder($mID);
	if ( $order['sid'] != $mSID )
	{ 
		header("Location: ./");  
	 	exit; 
	} 
	
	// Clear current basket
	$goods = $gData->GetCurrentBasket(session_id());
	$rows = $gData->GetNumRows($goods);
	if ( $rows > 0 ) 
	{
		for ( $i = 1; $i <= $rows; $i++ ) 
		{			
			$hash = $gData->FetchHash($goods);
			$gData->RemoveCurrentBasket($hash['id']);
		}
	}
	
	// Activate client
	client_activate($order['client_id']);
	
	// Save partner info
	$_SESSION['partner_id'] = $order['partner_id'];
	
	// Restore order info
	$_SESSION['order_deliv_id'] = $order['deliv_id'];
	$_SESSION['order_cond_code'] = $order['cond_code'];
	$_SESSION['order_payment_id'] = $order['payment_id'];
	$_SESSION['order_notice'] = $order['notice'];
		
	// Try add goods to basket
	$goods = $gData->GetArchiveGoods($order['id']);
	$rows = $gData->GetNumRows($goods);
	$time = 0;
	for ( $i = 1; $i <= $rows; $i++ ) 
	{			
		$hash = $gData->FetchHash($goods);
		if ( $hash['status'] != 10 )
		{
			// Put to basket
			buy_goods($hash['how'], $hash['store_id'], $hash['param_value_id'], $hash['modify_code'], $time);
			$time++;
		}
	}
	
	
	
	
}	

?>