<?php

/**
 * buy.php
 * -------
 * @version 5.4.0
 * @copyright 2002-2010 Melbis Company
 * @link http://www.melbis.com
 * @author Dmitriy Kasyanov
 **/

// Define script folder 
define('FOLDER', './');
 
// Require classes and includes
require_once('./admin/privat/privat.php');
require_once('./admin/includes/common.php');
require_once('./admin/includes/goods.php');
require_once('./admin/includes/basket.php');
require_once('./admin/class/util/class.Emailer.php');
require_once('./admin/class/show/class.FastTemplate.php');

// Start sessions
shop_session();

// Go!
if ( $_POST['action'] == 'save_remember' ) 
{
	if ( @eregi("^[_a-z0-9-]+(\.[_a-z0-9-]+)*@([0-9a-z](-?[0-9a-z])*\.)+[a-z]{2}([zmuvtg]|fo|me)?$", $_POST['email']) )
	{
		save_remember();
	} 
	else 
	{
		main(true);
	}
}
else 
{
	main(false);
}


/**
 * Function save_remember
 **/
function save_remember()
{
	global $gData, $gOptions, $gTpl, $gStartPoint;

	// Get start point for time
	$gStartPoint = run_time(0);
	
	// Connect to Data 
	$gData = data_connect();	

	

	$gData->SaveRemember(addslashes($_POST['email']), 
						 $_POST['store_id']*1, 
						 $_POST['param_value_id']*1,
						 get_now());
						 
	//Send email for admin
	$goods = $gData->GetGoods($_POST['store_id']*1);
	$tplm = new FastTemplate(SHOP_CWD.'/'.TEMPLATES.'/_buy');
	$tplm->DefineTemplate(array('mail_message'	=>	'mail_message_admin.htm'));
	$tplm->Assign(array('NAMES'  	=>  $goods['name'],
						'NAME'  	=>  htmlspecialchars($goods['name']),
						'CLNAME'  	=>  htmlspecialchars($_POST['name']),
						'CLPHONE'  	=>  htmlspecialchars($_POST['phone']),
						'CLEMAIL'  	=>  htmlspecialchars($_POST['email']),
				    	'URL'   	=>  rtrim($gOptions['attr_base_url'], '/').'/goods.php?id='.$goods['id'],
						'CHARSET' 	=>	SHOP_CHARSET,
						'SHOPNAMES'	=>  $gOptions['attr_shop_name'],
				    	'SHOPNAME'	=>  htmlspecialchars($gOptions['attr_shop_name']),
				    	'SHOPURL'	=>  htmlspecialchars($gOptions['attr_shop_url']),
				    	'SHOPEMAIL'	=>  htmlspecialchars($gOptions['attr_shop_email']),
				    	'SHOPORG'	=>  htmlspecialchars($gOptions['attr_shop_org']),
				    	'SHOPPHONE'	=>  htmlspecialchars($gOptions['attr_shop_phone']),
				    	'SHOPICQ'	=>  htmlspecialchars($gOptions['attr_shop_icq'])
					   ));
	$tplm->Parse('MAIL', 'mail_message');
	$mailer = new Emailer(MAIL_SERVER);
	$mailer->SetCharset($gOptions['attr_admin_charset']);
	$mailer->SetTypeHTML();
	$all_message = $tplm->Fetch('MAIL');
	$subject = substr($all_message, strpos($all_message, 'Message_subject:')+16, strpos($all_message, 'Message_content:')-16);
	$message = substr($all_message, strpos($all_message, 'Message_content:')+16);		
	$mailer->AddMessage($message);
  	$mailer->BuildMessage();
	$mailer->Send($gOptions['attr_admin_email'], $_POST['email'], ltrim($subject, " "));	
	
	// Init templates
	$gTpl = new FastTemplate('./'.TEMPLATES.'/_buy');
	$gTpl->DefineTemplate(array('main' 			=> 'main.htm',
							    'remember_ok'	=> 'remember_ok.htm'
							    ));
	$gTpl->Parse('CONTENT', 'remember_ok');
						    
	// Echo shop variables
	echo_shop_variables('in_techpage');	

	// Parse main page
	$gTpl->Parse('MAIN', 'main');
	$gEndPoint = run_time($gStartPoint);
	$gTpl->FastPrint('MAIN');
	
	// Echo page compilate time
	echo_page_time($gEndPoint);
		
}

/**
 * Function main
 **/
function main($mWasError)
{
	global $gData, $gOptions, $gTpl, $gStartPoint;

	// Get start point for time
	$gStartPoint = run_time(0);
	
	// Connect to Data 
	$gData = data_connect();	

	

	// Get and test properties
	if ( !isset($_GET['store_id']) || !isset($_SESSION['client']) )
	{ 
	 		header("Location: ./");  
	 		exit; 
	}

	// Define info currency
	if ($_SESSION['payment']['multiplex']*1 > 0) 
	{
	    $gOptions['main_base_curr'] = $_SESSION['payment']['curr_name'];
		$gOptions['main_prec'] = $_SESSION['payment']['curr_prec'];
	}	
	
	$how = $_GET['how']*1;
	if ( $how <= 0 ) $how = 1;
	$store_id = $_GET['store_id']*1;
	$param_value_id = $_GET['param_value_id']*1;
	$modify_code = $_GET['modify_code'];


	// Add goods to basket
	$how_put = buy_goods($how, $store_id, $param_value_id, $modify_code);

	// Get Goods options
	$goods = $gData->GetGoods($store_id);

	// Init templates
	$gTpl = new FastTemplate('./'.TEMPLATES.'/_buy');
	$gTpl->DefineTemplate(array('main' 			=> 'main.htm',
								'goods'			=> 'goods.htm',
							    'limit'			=> 'limit.htm',
							    'error'			=> 'error.htm',
							    'remember_form'	=> 'remember_form.htm'
							    ));
	$gTpl->Assign(array('NAME'  		=> htmlspecialchars($goods['name']),
					    'MEAS'			=> htmlspecialchars($goods['meas']),
			   		    'HOW' 			=> $how_put,
					    'LIMIT'  		=> '',
						'STOREID'		=> $store_id,
						'PARAMVALUEID'	=> $param_value_id
        	            ));
	
	if ( $how_put == 0 ) 
	{
		$gTpl->Assign(array('CLNAME' 	=> htmlspecialchars($_POST['name']),
						    'CLPHONE'	=> htmlspecialchars($_POST['phone']),
						    'CLEMAIL'	=> htmlspecialchars($_POST['email'])
	        	            ));		
		
		( $mWasError ) ? $gTpl->Parse('CONTENT', '.error') : $gTpl->Parse('CONTENT', 'limit');
		$gTpl->Parse('CONTENT', '.remember_form');
	}
	else 
	{
		$gTpl->Parse('CONTENT', 'goods');
	}
	
	// Recalc order sum
	list($how_ordered, $itogo_sum, $total_sum, $tax_sum) = calc_basket_info($_SESSION['client']);
	$_SESSION['total_sum'] = round($total_sum, 2);
	$_SESSION['how_ordered'] = $how_ordered;
	
	// Echo shop variables
	echo_shop_variables('in_techpage');	

	// Parse main page
	$gTpl->Parse('MAIN', 'main');
	$gEndPoint = run_time($gStartPoint);
	$gTpl->FastPrint('MAIN');
	
	// Echo page compilate time
	echo_page_time($gEndPoint);
		
}

?>