<?php

/**
 * final.php
 * ---------
 * @version 5.4.0
 * @copyright 2002-2010 Melbis Company
 * @link http://www.melbis.com
 * @author Dmitriy Kasyanov
 **/

// Define script folder 
define('FOLDER', './');

 
// Require classes and includes
require_once('./admin/privat/privat.php');
require_once('./admin/includes/common.php');
require_once('./admin/includes/client.php');
require_once('./admin/includes/basket.php');
require_once('./admin/includes/section.php');
require_once('./admin/class/show/class.FastTemplate.php');

// Start sessions
shop_session();

// Go!
main();


/**
 * Function main
 **/
function main()
{
	global $gData, $gOptions, $gTpl, $gStartPoint;

	// Get start point for time
	$gStartPoint = run_time(0);
	
	// Connect to Data 
	$gData = data_connect();	

	// Reload order info
	$order = $gData->GetArchiveOrder($_GET['order_id']*1);
	if ( $order['sid'] != $_GET['last_sid'] )
	{ 
		header("Location: ./");  
	 	exit; 
	} 
	if ( ( strtotime(get_now()) - strtotime($order['date_time']) ) > 300 )
	{
		header("Location: ./");  
	 	exit; 
	}
	client_activate($order['client_id']);

	// Init templates
	$gTpl = new FastTemplate('./'.TEMPLATES);
	$gTpl->DefineTemplate(array('blank' 		=> 'blank.htm',
							    'main'			=> '_final/main.htm',
							    'online'		=> '_final/online.htm',
							    'ok'			=> '_final/ok.htm',
							    'page_title'	=> '_final/page_title.htm'
							    ));

	// Assign vars
	$gTpl->Assign(array('BACKPATH'	=> $_GET['last_path'],
			    		'SSID'		=> $order['sid'],
			    		'ORDERID'	=> $order['id']
			    		));
							
	// Parse order notice payment variant
	if ( $_GET['online'] == 1 ) 
	{
		$gTpl->Parse('NOTICE', 'online');
	}
	else
	{
		$gTpl->Parse('NOTICE', 'ok');
	}
	
	
	$gTpl->Parse('CONTENT', 'main');
	
	// Echo shop variables
	echo_shop_variables('in_techpage', true);	

	// Additional modules
	use_php_mod('other');
	
	$gTpl->Parse('PAGETITLE', 'page_title');
				
	// Parse main page
	$gTpl->Parse('BLANK', 'blank');
	$gEndPoint = run_time($gStartPoint);
	$gTpl->FastPrint('BLANK');

				
	// Echo page compilate time
	echo_page_time($gEndPoint);
}

?>