<?php

/**
 * invoice.php
 * -----------
 * @version 5.4.0
 * @copyright 2002-2010 Melbis Company
 * @link http://www.melbis.com
 * @author Dmitriy Kasyanov
 **/

// Define script folder 
define('FOLDER', './');

 
// Require classes and includes
require_once('./admin/privat/privat.php');
require_once('./admin/includes/common.php');
require_once('./admin/includes/basket.php');
require_once('./admin/class/show/class.FastTemplate.php');


// Start session
session_name(DB_NICK.'_MSS');
session_start();

// Go!
main();


/**
 * Function main
 **/
function main()
{
	global $gData, $gTpl, $gOptions, $order;

	// Get start point for time
	$gStartPoint = run_time(0);
	
	// Connect to Data 
	$gData = data_connect();	

	
	$order_id = $_GET['order_id']*1;
	$order_sid = addslashes($_GET['order_sid']);
	$order = $gData->GetArchiveOrder($order_id);	
	if ( $order['sid'] != $order_sid ) shop_die('no_found_order', $order_sid.$order_id, __LINE__, $_SERVER['REQUEST_URI']);

	// Init templates
	$gTpl = new FastTemplate('./'.TEMPLATES.'/_invoice');
	$gTpl->DefineTemplate(array('main'			=> 'main.htm',
							    'unit'			=> 'unit.htm',
							    'error_accept'	=> 'error_accept.htm',
							    'error_gone'	=> 'error_gone.htm',
							    'status0'		=> 'status0.htm',
							    'status1'		=> 'status1.htm',
							    'status2'		=> 'status2.htm',
							    'status3'		=> 'status3.htm',							   
							    'client_unit'	=> 'client/unit.htm',
							    'elem_file'		=> 'client/elem_file.htm',
							    'elem_folder'	=> 'client/elem_folder.htm',
							    'vat'			=> 'vat.htm'
							    ));

	// Can pay this order?
	if ( $order['status'] == 0 )
	{
		$payment = $gData->GetPaymentValue($order['payment_id']);
		$rows = $gData->GetNumRows($payment);
		if ( $rows > 0 ) 
		{
			$hash = $gData->FetchHash($payment);			
			$can_payment = ( $hash['online'] == 1 );
		}
		else 
		{
			$can_payment = false;
		}
		if ( !$can_payment ) 
		{
			$gTpl->Assign(array('ORDERCODE'		=> htmlspecialchars($order['code']),
					    		'DATETIME'		=> date($gOptions['main_fmt_date'], strtotime($order['date_time'])),
					    		'CHARSET'		=> SHOP_CHARSET,
					    		'PHPSESSID'		=> session_name().'='.session_id()					    
								));			
			$gTpl->Parse('MAIN', 'error_accept');
			$gTpl->FastPrint('MAIN');
			return false;
		}		
	}
	else 
	{
		$can_payment = ( $order['status'] == 1 && $order['get_payment'] == 1 );
		if ( !$can_payment ) 
		{
			$gTpl->Assign(array('ORDERCODE'		=> htmlspecialchars($order['code']),
					    		'DATETIME'		=> date($gOptions['main_fmt_date'], strtotime($order['date_time'])),
					    		'CHARSET'		=> SHOP_CHARSET,
					    		'PHPSESSID'		=> session_name().'='.session_id()					    
								));			
			$gTpl->Parse('MAIN', 'error_gone');
			$gTpl->FastPrint('MAIN');
			return false;
		}		
	}
	
	// Get payment parametrs
	$mult = $order['payment_cost']/$order['total_sum'];
	$curr = $order['payment_curr'];
	$payment = $gData->GetPaymentValue($order['payment_id']);
	$rows = $gData->GetNumRows($payment);
	if ( $rows > 0 ) 
	{
		$hash = $gData->FetchHash($payment);
		$vat = $hash['vat_value'];
		$gTpl->Assign('PAYTEMPLATE', $hash['pay_template']);
	} 
	else
	{
		$vat = 0;
		$gTpl->Assign('PAYTEMPLATE', ' ');
	}	
	
	// Parse fields tree client
	$client_sth = $gData->GetArchiveClientField($order['id']);
	$rows = $gData->GetNumRows($client_sth);
	$gTpl->Assign('CLUNIT', '');
	for ( $n = 1; $n <= $rows; $n++ ) 
	{			
		$hash = $gData->FetchHash($client_sth);
		if ( $n == 1 ) 
		{
			$gTpl->Assign('LOGIN', htmlspecialchars($hash['value_text']));
			$_SESSION['client_info']['login'] = $hash['value_text'];
		}
		if ( $n == 2 ) 
		{
			$gTpl->Assign('EMAIL', htmlspecialchars($hash['value_text']));
			$_SESSION['client_info']['email'] = $hash['value_text'];
		}
		if ( $n < 4 ) continue;
		$gTpl->Assign('NAME', htmlspecialchars($hash['name']));
		if ( $hash['isfolder'] == 1) 
		{
			$gTpl->Parse('ELEMENT', 'elem_folder');
		}
		else
		{
			$gTpl->Assign(array('VALUE'						=> htmlspecialchars($hash['value_text']),
								'CLIENT'.$hash['field_id']	=> htmlspecialchars($hash['value_text'])));
			$gTpl->Parse('ELEMENT', 'elem_file');
			$_SESSION['client_info']['CLIENT'.$hash['field_id']] = $hash['value_text'];
		}
		$gTpl->Assign('LEVEL', $hash['tlevel']);
		$gTpl->Parse('CLUNIT', '.client_unit');
	}
		
	// Get Goods list
	$goods = $gData->GetArchiveGoods($order['id']);
	$rows = $gData->GetNumRows($goods);
	
    // Parse goods
	$itogo_sum_out = 0;
	for ( $i = 1; $i <= $rows; $i++ ) 
	{			
		$hash = $gData->FetchHash($goods);
		if ( $hash[status] == 10 ) continue; 
		$new_price = round($hash['new_price']*$mult/(1+$vat/100), 2);
		$itogo = $new_price*$hash['how'];
		$itogo_sum_out += $new_price*$hash['how'];
		$gTpl->Assign(array('NAME'  		=> htmlspecialchars($hash['name']),
						    'MEAS'			=> htmlspecialchars($hash['meas']),
						    'CODE'			=> htmlspecialchars($hash['code']),
						    'KIT'			=> htmlspecialchars($hash['param_name']),
						    'NEWPRICE'		=> number_format($new_price, 2, "," ,"'"),
						    'ITOGO'			=> number_format($itogo, 2, "," ,"'"),
		   				    'HOW' 			=> $hash['how']
       			            ));			
		$gTpl->Parse('STATUS', 'status'.$hash['status']);
		$gTpl->Parse('UNIT', '.unit');
		$_SESSION['goods_info']['code'] .= $hash['code'].'|';
		$_SESSION['goods_info']['name'] .= $hash['name'].'|';
		$_SESSION['goods_info']['meas'] .= $hash['meas'].'|';
		$_SESSION['goods_info']['param_name'] .= $hash['param_name'].'|';
		$_SESSION['goods_info']['price'] .= number_format($new_price, 2, "." ,"").'|';
		$_SESSION['goods_info']['how'] .= $hash['how'].'|';		
	}
	
	// Delivery
	$deliv_cost_out = round($order['deliv_cost']*$mult/(1+$vat/100), 2);
	$gTpl->Assign(array('DELIVERYCOST'	=> number_format($deliv_cost_out, 2, "," ,"'"),
						'DELIVERYNAME'	=> htmlspecialchars($order['deliv_name'])
						));
	$_SESSION['order_info']['delivery_cost'] = number_format($deliv_cost_out, 2, "." ,"");
	$_SESSION['order_info']['delivery_name'] = $order['deliv_name'];						
	
	// Disc sum out
	$disc_sum_out = round($order['payment_cost']/(1+$vat/100), 2) - $deliv_cost_out - $itogo_sum_out;
	$disc_sign = ( $disc_sum_out > 0 ) ? '+' : '';
	if ( $disc_sum_out == 0 ) $disc_sign = '';

	// VAT
	if ( $vat > 0 )
	{
		$vat_cost = round(($itogo_sum_out+$disc_sum_out+$deliv_cost_out)*$vat/100, 2);
		$gTpl->Assign(array('VATVALUE'	=> number_format($vat, 2, "," ,"'"),
							'VATCOST'	=> number_format($vat_cost, 2, "," ,"'")
							));
		$gTpl->Parse('VAT', 'vat');
		$_SESSION['order_info']['vat_value'] = $vat;
		$_SESSION['order_info']['vat_cost'] = number_format($vat_cost, 2, "." ,"");		
	}
	else 
	{
		$vat_cost = 0;
		$gTpl->Assign('VAT', '');
		$_SESSION['order_info']['vat_value'] = '';
		$_SESSION['order_info']['vat_cost'] = '0.00';		
	}
	
	$gTpl->Assign(array('ITOGOSUM'		=> number_format($itogo_sum_out, 2, "," ,"'"),
					    'DISCSUM'		=> $disc_sign.' '.number_format($disc_sum_out, 2, "," ,"'"),
					    'TOTALSUM'		=> number_format($itogo_sum_out+$deliv_cost_out+$disc_sum_out+$vat_cost, 2, "," ,"'"),
					    'MATHTOTALSUM'	=> number_format($itogo_sum_out+$deliv_cost_out+$disc_sum_out+$vat_cost, 2, "." ,""),
					    'CURR'			=> htmlspecialchars($curr),
						'NOTICE'		=> nl2br(htmlspecialchars($order['notice'])),
					    'ORDERCODE'		=> htmlspecialchars($order['code']),
					    'DATETIME'		=> date($gOptions['main_fmt_date'], strtotime($order['date_time'])),
					    'CHARSET'		=> SHOP_CHARSET,
					    'PHPSESSID'		=> session_name().'='.session_id()					    
						));
	$_SESSION['order_info']['itogo'] = number_format($itogo_sum_out, 2, "." ,"");
	$_SESSION['order_info']['discount'] = number_format($disc_sign.$disc_sum_out, 2, "." ,"");
	$_SESSION['order_info']['totalsum'] = number_format($itogo_sum_out+$deliv_cost_out+$disc_sum_out+$vat_cost, 2, "." ,"");
	$_SESSION['order_info']['curr'] = $curr;
	$_SESSION['order_info']['id'] = $order_id;
	$_SESSION['order_info']['sid'] = $order_sid;
	$_SESSION['order_info']['notice'] = $order['notice'];
	$_SESSION['order_info']['code'] = $order['code'];
	$_SESSION['order_info']['date_time'] = $order['date_time'];
	
				
	$gTpl->Parse('MAIN', 'main');
	$gEndPoint = run_time($gStartPoint);
	$gTpl->FastPrint('MAIN');
	
	// Echo page compilate time
	echo_page_time($gEndPoint);
}


?>