<?php

/**
 * client.php
 * ----------
 * @version 5.4.0
 * @copyright 2002-2010 Melbis Company
 * @link http://www.melbis.com
 * @author Dmitriy Kasyanov
 **/

// Define script folder 
define('FOLDER', './');

 
// Require classes and includes
require_once('./admin/privat/privat.php');
require_once('./admin/includes/common.php');
require_once('./admin/includes/section.php');
require_once('./admin/includes/basket.php');
require_once('./admin/includes/anti_spam.php');
require_once('./admin/class/show/class.FastTemplate.php');
require_once('./admin/class/util/class.Emailer.php');


// Start sessions
shop_session();

// Go!
main();


/**
 * Function main
 **/
function main()
{
	global $gData, $gOptions, $gStartPoint, $gEndPoint;

	// Get start point for time
	$gStartPoint = run_time(0);
	
	// Connect to Data 
	$gData = data_connect();	

		
	// Make path for back
	make_back_path();
	
	// Define what to do
	$action = $_GET['action'];
	if ( isset($_POST['action']) ) $action = $_POST['action'];
	switch ( $action )
	{
		case 'send_message' :
			$verify_code_pass = true;
			if ( $gOptions['main_no_spam'] == 'True' ) $verify_code_pass = right_verify_code();
			if ( $verify_code_pass ) send_message();
			break;
		default :
			show_form();
	} // switch	

	// Echo page compilate time
	echo_page_time($gEndPoint);

}


/**
 * Function show_form
 * Show messenger from
 **/
function show_form()
{
	global $gData, $gOptions, $gTpl, $gStartPoint, $gEndPoint;
	
	// Init templates
	$gTpl = new FastTemplate('./'.TEMPLATES);
	$gTpl->DefineTemplate(array('blank' 		=> 'blank.htm',
							    'main'			=> '_messenger/main.htm',
							    'topic_select'	=> '_messenger/topic_select.htm',
							    'verify_code'	=> '_messenger/verify_code.htm',
							    'page_title'	=> '_messenger/page_title.htm'
							    ));
	
	// Assign vars
	$gTpl->Assign('TOPIC','');
	$topic = $gData->GetMessenger();	
	$rows = $gData->GetNumRows($topic);
	if ( $rows > 0 ) 
	{ 
		$topic_option = '';
		for ( $n = 1; $n <= $rows; $n++ ) 
		{			
			$hash = $gData->FetchHash($topic);
			$topic_option .= '<option value="'.$hash['id'].'" >'.htmlspecialchars($hash['topic_name']).'</option>';
		}
		$gTpl->Assign('OPTION', $topic_option);
		$gTpl->Parse('TOPIC', 'topic_select');
	} 
	
	// Anti spam verify code
	if ( $gOptions['main_no_spam'] == 'True' )
	{
		create_verify_code();
		$gTpl->Parse('VERIFYCODE', 'verify_code');
	}
	else 
	{
		$gTpl->Assign('VERIFYCODE', '');
	}
			
	$gTpl->Parse('CONTENT', 'main');

	// Echo shop variables
	echo_shop_variables('in_techpage', true);

	// Additional modules
	use_php_mod('other');
		
	$gTpl->Parse('PAGETITLE', 'page_title');
					   	
	// Parse main page
	$gTpl->Parse('BLANK', 'blank');
	$gEndPoint = run_time($gStartPoint);
	$gTpl->FastPrint('BLANK');
		
}


/**
 * Function send_message
 * Send message operation
 **/
function send_message()
{
	global $gData, $gOptions, $gMessage, $gTpl, $gStartPoint, $gEndPoint;
	
	// Init templates
	$gTpl = new FastTemplate('./'.TEMPLATES);
	$gTpl->DefineTemplate(array('blank' 		=> 'blank.htm',
							    'ok'			=> '_messenger/ok.htm',
							    'page_title'	=> '_messenger/page_title.htm'
							    ));
	
	// Define send E-mail
	$topic = $gData->GetMessenger();	
	$rows = $gData->GetNumRows($topic);
	$to_email = $gOptions['attr_admin_email'];
	$to_charset = $gOptions['attr_admin_charset'];
	$mail_topic = $gMessage['messenger_subj'];
	if ( $rows > 0 ) 
	{ 
		for ( $n = 1; $n <= $rows; $n++ ) 
		{			
			$hash = $gData->FetchHash($topic);
			if ( $_POST['topic']*1 == $hash['id'] ) 
			{
				$to_email = $hash['email'];
				$to_charset = $hash['charset'];
				$mail_topic = $hash['topic_name'];
			}
		}
	} 	

    //Send mail
	$tplm = new FastTemplate('./'.TEMPLATES);
	$tplm->DefineTemplate(array('mail_message'	=>	'_messenger/mail_message.htm'));
	$tplm->Assign(array('NAME'  	=> htmlspecialchars($_POST['name']),
				    	'EMAIL'   	=> htmlspecialchars($_POST['email']),
				    	'PHONE'		=> htmlspecialchars($_POST['phone']),
				    	'MESSAGE'	=> htmlspecialchars($_POST['message']),
						'CHARSET' 	=> $to_charset,
						'TOPIC'		=> $mail_topic,
						'SHOPNAMES'	=> $gOptions['attr_shop_name'],
				    	'SHOPNAME'	=> htmlspecialchars($gOptions['attr_shop_name']),
				    	'SHOPURL'	=> htmlspecialchars($gOptions['attr_shop_url']),
				    	'SHOPEMAIL'	=> htmlspecialchars($gOptions['attr_shop_email']),
				    	'SHOPORG'	=> htmlspecialchars($gOptions['attr_shop_org']),
				    	'SHOPPHONE'	=> htmlspecialchars($gOptions['attr_shop_phone']),
				    	'SHOPICQ'	=> htmlspecialchars($gOptions['attr_shop_icq'])
				   ));
	$tplm->Parse('MAIL', 'mail_message');
	$mailer = new Emailer(MAIL_SERVER);
	$mailer->SetCharset($to_charset);
	$mailer->SetTypeHTML();
	$all_message = iconv(SHOP_CHARSET, $to_charset, $tplm->Fetch('MAIL'));
	$subject = substr($all_message, strpos($all_message, 'Message_subject:')+16, strpos($all_message, 'Message_content:')-16);
	$message = substr($all_message, strpos($all_message, 'Message_content:')+16);		
	$mailer->AddMessage($message);
	$mailer->BuildMessage();
  	$mailer->Send($to_email, addslashes($_POST['email']), ltrim($subject, " "));					   

  	$gTpl->Parse('CONTENT', 'ok');

	// Echo shop variables
	echo_shop_variables('in_techpage', true);

	// Additional modules
	use_php_mod('other');
		
	$gTpl->Parse('PAGETITLE', 'page_title');
					   	
	// Parse main page
	$gTpl->Parse('BLANK', 'blank');
	$gEndPoint = run_time($gStartPoint);
	$gTpl->FastPrint('BLANK');
		
}

?>