<?php

/**
 * order.php
 * ---------
 * @version 5.4.0
 * @copyright 2002-2010 Melbis Company
 * @link http://www.melbis.com
 * @author Dmitriy Kasyanov
 **/

// Define script folder 
define('FOLDER', './');

 
// Require classes and includes
require_once('./admin/privat/privat.php');
require_once('./admin/includes/common.php');
require_once('./admin/includes/basket.php');
require_once('./admin/includes/section.php');
require_once('./admin/class/show/class.FastTemplate.php');
require_once('./admin/class/util/class.Emailer.php');

// Start sessions
shop_session();

// Go!
main();


/**
 * Function main
 **/
function main()
{
	global $gData, $gOptions, $gStartPoint, $gEndPoint;

	// Get start point for time
	$gStartPoint = run_time(0);
	
	// Connect to Data 
	$gData = data_connect();	


	// Get and test properties
	if ( !isset($_SESSION['client']) )
	{ 
			header("Location: ./");  
	 		exit; 
	}
	
	// Is it register client?
	if ( $_SESSION['client']['id']*1 == 1 ) 
	{
	    $_SESSION['reg_and_back'] = true;
		header("Location: ./client.php?".session_name()."=".session_id());  
	 	exit;
	}
	
	// this client realy exists?
	$hash = $gData->GetClient($_SESSION['client']['id']);
	if ( $hash['id']*1 == 0 ) 
	{
	    $_SESSION['reg_and_back'] = true;
		header("Location: ./client.php?".session_name()."=".session_id());  
	 	exit;
	}	
	
	// Test for reload database
	if ( test_basket_reload() ) exit;
	
	// Make path for back
	make_back_path();
		
	// Define info currency
	$gOptions['orig_base_curr'] = $gOptions['main_base_curr'];
	$gOptions['orig_prec'] = $gOptions['main_prec'];
	if ($_SESSION['payment']['multiplex']*1 > 0) 
	{
	    $gOptions['main_base_curr'] = $_SESSION['payment']['curr_name'];
		$gOptions['main_prec'] = $_SESSION['payment']['curr_prec'];
	}	

	// Create order session array
	if ( !isset($_SESSION['order']) ) 
	{
		// Give chance for partner info in cookie browser
		if ( $_SESSION['partner_id']*1 == 0 )
		{ 
			$cookie_name = @ereg_replace('[^[:alnum:]]', '_', SHOP_CWD.'_last_partner_id');
			$_SESSION['partner_id'] = $_COOKIE[$cookie_name]*1;
		}
		$_SESSION['order']['client_id'] = $_SESSION['client']['id'];
		$_SESSION['order']['partner_id'] = $_SESSION['partner_id'];
		$_SESSION['order']['delivery_id'] = $_SESSION['order_deliv_id']*1;
		$_SESSION['order']['condition_id'] = $_SESSION['order_cond_code'];
		$_SESSION['order']['payment_id'] = $_SESSION['order_payment_id']*1;
		$_SESSION['order']['notice'] = $_SESSION['order_notice'];

		// Use current currency as payment order if it's not define yet
		if ( $_SESSION['order']['payment_id']*1 == 0 ) 
		{
			$_SESSION['order']['payment_id'] = $_SESSION['payment']['id']*1;
		}
	}	
		
	// Define what to do
	$action = ( isset($_POST['action']) ) ? $_POST['action'] : $_GET['action'];
	switch ( $action )
	{
		case 'save_order_params' : 
			if ( save_order_params() )
			{
				last_verify();
			}
			else 
			{
				order_params_error();
			}
			break;
		case 'last_verify_ok' :
			save_order();
			break;
		default :
			if ( !get_order_params() ) last_verify();
	} // switch	
			
	// Echo page compilate time
	echo_page_time($gEndPoint);
		
}


/**
 * Function save_order_params
 * Save order parameters
 **/
function save_order_params()
{
	global $gData;
	
	$_SESSION['order']['delivery_id'] = $_POST['delivery']*1;
	$_SESSION['order']['payment_id'] = $_POST['payment']*1;
	$payment = $gData->GetPaymentValue($_POST['payment']*1);
	$rows = $gData->GetNumRows($payment);
	if ( $rows > 0 ) 
	{
		$hash = $gData->FetchRow($payment);	
		$_SESSION['order']['payment_online'] = $hash[12];
	}		
	$cond = $gData->GetCondition();
	$rows = $gData->GetNumRows($cond);
	if ( $rows > 0 ) 
	{
		$_SESSION['order']['condition_id'] = '';
		for ( $i = 1; $i <= $rows; $i++ ) 
		{			
			$hash = $gData->FetchRow($cond);	
			if ( $_POST['condition'.$hash[0]]*1 > 0 ) 
			{
			    $_SESSION['order']['condition_id'] .= $hash[0].',';
			}
		}
		$_SESSION['order']['condition_id'] = rtrim($_SESSION['order']['condition_id'], ',');
	}
	
	// Test for comparable
	return $gData->TestPaymentDelivery($_SESSION['order']['payment_id'], $_SESSION['order']['delivery_id']);
}

/**
 * Function save_order
 * Save order and go to final page
 **/
function save_order()
{
	global $gData, $gOptions, $gMessage;
	
	// Test exists ordering (stop double click)
	$find_order = $gData->GetArchiveOrder(0, session_id());
	if ( $find_order['id'] > 0 )
	{
		if ( ( strtotime(get_now()) - strtotime($find_order['date_time']) ) < 600 )
		{
			// Order save yet - redirect to last page
			( $_SESSION['order']['payment_online'] ) ? $online = 1 : $online = 0;
			$session_id = session_id();
			$shop_path = $_SESSION['shop_path'];
			@session_destroy();
			setcookie(session_name(), "", time(), "/");
			shop_session();
			header('Location: ./final.php?last_sid='.$session_id.'&order_id='.$find_order['id'].'&online='.$online.'&last_path='.urlencode($shop_path));
	 		exit; 
		}	
	}
	// Stop save order if basket empty
	$goods = $gData->GetCurrentBasket(session_id());
	if ( $gData->GetNumRows($goods) == 0 )
	{
		header("Location: ./");  
	 	exit; 
	}	

	
	// Create new order
	$_SESSION['order']['date_time'] = get_now();
	$_SESSION['order']['code'] = str_replace('{NUM}', $gData->MakeOrderCode(), $gOptions['order_code_templ']);
	$_SESSION['order']['id'] = $gData->AddArchiveOrder(session_id(),
													   addslashes($_SESSION['order']['code']),
	 												   $_SESSION['order']['client_id'],
	 												   $_SESSION['order']['partner_id'],
	 												   $_SESSION['order']['date_time']
	 												   );
	$order_id = $_SESSION['order']['id'];	

	// Save client last order
	$gData->SaveClientBaseField($_SESSION['client']['id'], 'last_date', get_now());
	
	// Client Info =========================================================
	
	// Add special fileds
	$client_category = $gData->GetCategoryName($_SESSION['client']['category_id']);									   
	$gData->SaveArchiveClientField($order_id, -3, $gMessage['login'], 0, 0, 1, addslashes($_SESSION['client']['login']));
	$gData->SaveArchiveClientField($order_id, -2, $gMessage['email'], 0, 1, 1, addslashes($_SESSION['client']['email']));		
	$gData->SaveArchiveClientField($order_id, -1, $gMessage['category'], 0, 2, 1, addslashes($client_category[1]));
	 												   
	// Init templates for full email
	$tpl = new FastTemplate('./'.TEMPLATES.'/_order/mails/for_manager/full');
	$tpl->DefineTemplate(array('main'			=> 'main.htm',
							   'unit'			=> 'unit.htm',
							   'unit_gift'		=> 'unit_gift.htm',
							   'status0'		=> 'status0.htm',
							   'status1'		=> 'status1.htm',
							   'status2'		=> 'status2.htm',
							   'status3'		=> 'status3.htm',	
							   'client_unit'	=> 'client/unit.htm',
							   'elem_file'		=> 'client/elem_file.htm',
							   'elem_folder'	=> 'client/elem_folder.htm',
							   'condition'		=> 'condition.htm',
							   'delivery'		=> 'delivery.htm'
							   ));
	
	// Get client information
	$client = $gData->GetClientData($_SESSION['client']['id']);	
	$rows = $gData->GetNumRows($client);
	$tpl->Assign('CLUNIT', '');
	$allow = array();
	for ( $n = 1; $n <= $rows; $n++ ) 
	{			
		$hash = $gData->FetchRow($client);
		if ( (strlen($hash[8]) > 0) || ($allow[$hash[0]] == 1) ) 
		{
			$allow[$hash[4]] = 1;			
			$tpl->Assign(array('NAME'	=> htmlspecialchars($hash[1]),
							   'LEVEL'	=> $hash[3]
							   ));			
			// if folder
			if ( $hash[7] == 1) 
			{
				$tpl->Parse('ELEMENT', 'elem_folder');
			}
			// if not folder
			else
			{
				$tpl->Assign('VALUE', htmlspecialchars($hash[8]));
				$tpl->Parse('ELEMENT', 'elem_file');
			}
			$tpl->Parse('CLUNIT', ',client_unit');
			
			// Save to order info
			$gData->SaveArchiveClientField($order_id,
										   $hash[0], 
										   addslashes($hash[1]),
										   $hash[3],
										   $hash[5]+3,
										   $hash[7],
										   addslashes($hash[8])
										   );
		}
	}
	
	// common vars
	$tpl->Assign(array('LOGIN'	=> htmlspecialchars($_SESSION['client']['login']),
					   'EMAIL'	=> htmlspecialchars($_SESSION['client']['email'])
					   ));		
					   
	// Goods information =========================================================					   
					   
	// Get Goods list
	$goods = $gData->GetCurrentBasket(session_id());
	$rows = $gData->GetNumRows($goods);
	$itogo_sum = 0;
	$how_ordered = 0;
	$tax_sum = 0;
	$partner_sum = 0;		
	for ( $i = 1; $i <= $rows; $i++ ) 
	{			
		$hash = $gData->FetchHash($goods);
		
		// Calc prices
		list($price, $new_price) = calc_basket_goods($hash, $_SESSION['client']);
		$disc_suma = $price - $new_price;
		
		// Total sum
		$itogo_sum += $new_price*$hash['how'];
		$itogo = $new_price*$hash['how'];
		$how_ordered += $hash['how'];
		$tax_sum += $hash['tax']*$hash['how'];
		
		// Partner
		if ( $_SESSION['order']['partner_id'] > 0 && ( $hash['status'] == 0 || $hash['status'] == 3 ) )
		{
			$part_proc = $hash['part_proc'];
			$part_value = ($price*$part_proc/100 - ($price-$new_price)); 	
			if ( $part_value < 0 ) $part_value = 0;
			$part_itogo = $part_value*$hash['how'];
			$partner_sum += $part_itogo;
		}
		else 
		{
			$part_proc = 0;
			$part_value = 0;
			$part_itogo = 0;
		}
		
		// Assign vars
		$tpl->Assign(array('NAME'  		=> htmlspecialchars($hash['name']),
						   'MEAS'		=> htmlspecialchars($hash['meas']),
						   'CODE'		=> htmlspecialchars($hash['code']),
						   'KIT'		=> htmlspecialchars($hash['param_name']),
						   'PRICE'		=> number_format($price, $gOptions['orig_prec'], "," ,"'"),
						   'NEWPRICE'	=> number_format($new_price, $gOptions['orig_prec'], "," ,"'"),
						   'DISCSUMA'	=> number_format($disc_suma, $gOptions['orig_prec'], "," ,"'"),
						   'SUMASEL'	=> ($disc_suma != 0) ? '1' : '0',
						   'ITOGO'		=> number_format($itogo, $gOptions['orig_prec'], "," ,"'"),
		   				   'HOW' 		=> $hash['how'],
						   'ID'			=> $hash['id'],
						   'STOREID'	=> $hash['store_id']
       			           ));			
		$tpl->Parse('STATUS', 'status'.$hash['status']);
		$tpl->Parse('UNIT', '.unit');
		
		// Save to order info
		$gData->AddArchiveBasket($order_id,
								 $hash['store_id'],
								 addslashes($hash['code']),
								 addslashes($hash['meas']),
								 addslashes($hash['name']),
								 addslashes($hash['param_name']),
								 $hash['param_personal'],
								 $hash['param_value_id'],
								 round($price, 2),
								 round($new_price, 2),
								 $hash['status'],
								 $hash['how'],
								 round($part_proc, 2),
								 round($part_value, 2),
								 addslashes($hash['modify_code']),
								 $hash['provider_id'],
								 $hash['prov_price'],
								 $hash['tax'],
								 0
								 );
		
		// Remove goods from current basket
		$gData->RemoveCurrentBasket($hash['id']);							 

		// Save shop statistic
		$gData->SaveStatGoodsBuy(get_date(), get_week(), get_month(), $hash['store_id'], $new_price);

	}
	
	// Parse gifts
	$gift = $gData->GetGiftForSum($itogo_sum);
	$rows = $gData->GetNumRows($gift);
	for ( $i = 1; $i <= $rows; $i++ ) 
	{			
		$hash = $gData->FetchHash($gift);
		$tpl->Assign(array('NAME'  		=> htmlspecialchars($hash['name']),
						   'CODE'		=> htmlspecialchars($hash['code']),
						   'NOTE'		=> $hash['descr'],
						   'STOREID'	=> $hash['id']
       			           ));			
		$tpl->Parse('UNIT', '.unit_gift');	

		$tax_sum += $hash['tax'];	
		
		// Save to order info
		$gData->AddArchiveBasket($order_id,
							 	 $hash['id'],
							 	 addslashes($hash['code']),
							 	 addslashes($hash['meas']),
							 	 addslashes($hash['name']),
							 	 '',
							 	 '',
							 	 0,
							 	 0,
							 	 0,
							 	 10,
							 	 1,
							 	 0,
							 	 0,
							 	 '',
							 	 $hash['provider_id'],
								 $hash['prov_price'],
								 $hash['tax'],
								 0
							 	 );				
	}		
	
	// Order information =========================================================

	// Common discount for order sum
	$disc_order_sum = $_SESSION['client']['suma'];
	if ( $_SESSION['client']['proc'] == 0 && $_SESSION['client']['suma'] == 0 && $_SESSION['client']['category_id'] == 0 ) 
	{
		$calc_disc_sum = ( $gOptions['main_disc_type'] == 'True' ) ? $itogo_sum + $_SESSION['client']['orders_suma']*1 : $itogo_sum;
		$disc = $gData->GetDiscountOrder($calc_disc_sum);
		if ( $disc['id'] > 0 ) 
		{
		    $disc_order_sum = round($itogo_sum*$disc['proc']/100, 2);
		}
	}
	$total_sum = $itogo_sum - $disc_order_sum;
	
	// Delivery
	list ($get_delivery, $deliv_name, $deliv_cost) = calc_basket_delivery($_SESSION['order']['delivery_id'], $tax_sum, $itogo_sum);
	if ( $get_delivery ) 
	{
		$tpl->Assign(array('COST'	=> number_format($deliv_cost, $gOptions['orig_prec'], "," ,"'"),
						   'NAME'	=> htmlspecialchars($deliv_name)
						  ));
		$tpl->Parse('DELIVERY', 'delivery');
	}	
	else
	{
		$tpl->Assign('DELIVERY', '');
	}
	
	// Condition
	list ($get_condition, $cond_name, $cond_cost) = calc_basket_condition($_SESSION['order']['condition_id'], $tax_sum, $itogo_sum, $how_ordered);
	if ( $get_condition ) 
	{
		$tpl->Assign(array('COST'	=> number_format($cond_cost, $gOptions['orig_prec'], "," ,"'"),
						   'NAME'	=> htmlspecialchars($cond_name)
						  ));
		$tpl->Parse('CONDITION', 'condition');
	}	
	else
	{
		$tpl->Assign('CONDITION', '');
	}	
	
	// Total sum
	$total_sum += $deliv_cost+$cond_cost;
	$order_sum = $total_sum;
	
	// Payment
	list($get_payment, $payment_name, $payment_cost, 
	     $payment_curr, $payment_prec, ) = calc_basket_payment($_SESSION['order']['payment_id'], $order_sum, $gOptions['orig_base_curr'], $gOptions['orig_prec']);
	$tpl->Assign(array('PAYCOST'	=> number_format($payment_cost, $payment_prec, "," ,"'"),
					   'PAYNAME'	=> htmlspecialchars($payment_name),
					   'PAYCURR'	=> htmlspecialchars($payment_curr),
					  ));

	// Save shop statistic
	save_shop_stat('order', 0, addslashes($_SESSION['order']['code']), $total_sum);
					  
	// Save order params
	$gData->SaveArchiveOrder($order_id,
							 round($disc_order_sum, 2),
							 addslashes($cond_name),
							 round($cond_cost, 2),
							 addslashes($deliv_name),
							 round($deliv_cost, 2),
							 addslashes($payment_name),
							 round($payment_cost, 2),
							 addslashes($payment_curr),
							 $_SESSION['order']['payment_id'],
							 round($itogo_sum, 2),
							 round($total_sum, 2),
							 addslashes($_POST['notice']),
							 round($partner_sum, 2),
							 $_SESSION['order']['delivery_id'],
							 addslashes($_SESSION['order']['condition_id'])
							 );

	// Define all other vars					  
	$tpl->Assign(array('ITOGOSUM'	=> number_format($itogo_sum, $gOptions['orig_prec'], "," ,"'"),
					   'DISCSUM'	=> number_format($disc_order_sum, $gOptions['orig_prec'], "," ,"'"),
					   'DISCSEL'	=> ($disc_order_sum != 0) ? '1' : '0',
					   'TOTALSUM'	=> number_format($total_sum, $gOptions['orig_prec'], "," ,"'"),
					   'CURR'		=> htmlspecialchars($gOptions['orig_base_curr']),
					   'BASEURL'	=> rtrim($gOptions['attr_base_url'], '/'),
					   'NOTICE'		=> htmlspecialchars($_POST['notice']),
					   'DATETIME'	=> date($gOptions['main_fmt_date_time'], strtotime($_SESSION['order']['date_time'])),
					   'SHOPNAMES'	=> $gOptions['attr_shop_name'],
					   'ORDERCODE'	=> htmlspecialchars($_SESSION['order']['code']),
					   'SHOPNAME'	=> htmlspecialchars($gOptions['attr_shop_name']),
					   'SHOPURL'	=> htmlspecialchars($gOptions['attr_shop_url']),
					   'SHOPEMAIL'	=> htmlspecialchars($gOptions['attr_shop_email']),
					   'SHOPORG'	=> htmlspecialchars($gOptions['attr_shop_org']),
					   'SHOPPHONE'	=> htmlspecialchars($gOptions['attr_shop_phone']),
					   'SHOPICQ'	=> htmlspecialchars($gOptions['attr_shop_icq'])					   
				));
	$tpl->Parse('FULLMAIL', 'main');
	$full_mail = $tpl->Fetch('FULLMAIL');
	
	// Send full emails
	$mailer = new Emailer(MAIL_SERVER);
	$mailer->SetTypeHTML();
	$charset = '';
	$from_client = ( strlen($_SESSION['client']['email']) > 0 ) ? $_SESSION['client']['email'] : $gOptions['attr_admin_email'];
	
	// Send to admin
	if ( $gOptions['order_send_to_admin'] == 'True' ) 
	{
		$charset = $gOptions['attr_admin_charset'];
		$mailer->SetCharset($charset);
		$all_message = iconv(SHOP_CHARSET, $charset, str_replace('{CHARSET}', $charset, $full_mail));
		$subject = substr($all_message, strpos($all_message, 'Message_subject:')+16, strpos($all_message, 'Message_content:')-16);
		$message = substr($all_message, strpos($all_message, 'Message_content:')+16);		
		$mailer->AddMessage($message);
		$mailer->BuildMessage();
  		$mailer->Send($gOptions['attr_admin_email'], $from_client, ltrim($subject, " "));	
	}
	
	// Send to managers mails
	$man = $gData->GetManFullEmails();
	$rows = $gData->GetNumRows($man);
	if ( $rows > 0 ) 
	{
		// Send full
		for ( $i = 1; $i <= $rows; $i++ ) 
		{		
			$hash = $gData->FetchRow($man);
			if ( $charset != $hash[1] ) 
			{
				$charset = $hash[1];
				$mailer->SetCharset($charset);
				$all_message = iconv(SHOP_CHARSET, $charset, str_replace('{CHARSET}', $charset, $full_mail));
				$subject = substr($all_message, strpos($all_message, 'Message_subject:')+16, strpos($all_message, 'Message_content:')-16);
				$message = substr($all_message, strpos($all_message, 'Message_content:')+16);		
				$mailer->AddMessage($message);
				$mailer->BuildMessage();		    
			}
			$mailer->Send($hash[0], $from_client, ltrim($subject, " "));
		}
	}
	
	// Send short emails
	$man = $gData->GetManShortEmails();
	$rows = $gData->GetNumRows($man);
	if ( $rows > 0 ) 
	{
		$tplm = new FastTemplate('./'.TEMPLATES);
		$tplm->DefineTemplate(array('mail_message'	=>	'_order/mails/for_manager/new_short.htm'));
		$tplm->Assign(array('ORDERCODE'	=> htmlspecialchars($_SESSION['order']['code']),
							'PAYSUM'	=> number_format($payment_cost, $payment_prec, "," ,"'"),
							'PAYNAME'	=> htmlspecialchars($payment_name),
							'PAYCURR'	=> htmlspecialchars($payment_curr),
							'SHOPNAMES'	=> $gOptions['attr_shop_name']
						   ));
		$tplm->Parse('MAIL', 'mail_message');
		$mailer = new Emailer(MAIL_SERVER);
		$mailer->SetTypeText();
		$charset = '';
		for ( $i = 1; $i <= $rows; $i++ ) 
		{		
			$hash = $gData->FetchRow($man);
			if ( $charset != $hash[1] ) 
			{
				$charset = $hash[1];
				$mailer->SetCharset($charset);
				$all_message = iconv(SHOP_CHARSET, $charset, $tplm->Fetch('MAIL'));
				$subject = substr($all_message, strpos($all_message, 'Message_subject:')+16, strpos($all_message, 'Message_content:')-16);
				$message = substr($all_message, strpos($all_message, 'Message_content:')+16);		
				$mailer->AddMessage($message);
	  			$mailer->BuildMessage();
			}
			$mailer->Send($hash[0], $from_client, ltrim($subject, " "));	
		}				   
	}

	// Send email to client
	if ( @eregi("^[_a-z0-9-]+(\.[_a-z0-9-]+)*@([0-9a-z](-?[0-9a-z])*\.)+[a-z]{2}([zmuvtg]|fo|me)?$", $_SESSION['client']['email']) ) 
	{
		$tplm = new FastTemplate('./'.TEMPLATES.'/_order/mails');
		$tplm->DefineTemplate(array('mail_message'	=>	'for_client.htm',
									'pay_online'	=>	'pay_online.htm',
									'wait_accept'	=> 	'wait_accept.htm'
									));
		if ( $_SESSION['order']['payment_online'] )
		{
			$tplm->Parse('ADDINFO', 'pay_online');
		}
		else 
		{
			$tplm->Parse('ADDINFO', 'wait_accept');
		}									
		$tplm->Assign(array('ORDERCODE'	=> htmlspecialchars($_SESSION['order']['code']),
					    	'SSID'   	=> session_id(),
					    	'ORDERID'	=> $order_id,
							'CHARSET' 	=> $_SESSION['client']['charset'],
							'BASEURL'	=> rtrim($gOptions['attr_base_url'], '/'),
							'SHOPNAMES'	=> $gOptions['attr_shop_name'],
					    	'SHOPNAME'	=> htmlspecialchars($gOptions['attr_shop_name']),
					    	'SHOPURL'	=> htmlspecialchars($gOptions['attr_shop_url']),
					    	'SHOPEMAIL'	=> htmlspecialchars($gOptions['attr_shop_email']),
					    	'SHOPORG'	=> htmlspecialchars($gOptions['attr_shop_org']),
					    	'SHOPPHONE'	=> htmlspecialchars($gOptions['attr_shop_phone']),
					    	'SHOPICQ'	=> htmlspecialchars($gOptions['attr_shop_icq'])
					   ));
		$tplm->Parse('MAIL', 'mail_message');
		$mailer = new Emailer(MAIL_SERVER);
		$mailer->SetCharset($_SESSION['client']['charset']);
		$mailer->SetTypeHTML();
		$all_message = iconv(SHOP_CHARSET, $_SESSION['client']['charset'], $tplm->Fetch('MAIL'));
		$subject = substr($all_message, strpos($all_message, 'Message_subject:')+16, strpos($all_message, 'Message_content:')-16);
		$message = substr($all_message, strpos($all_message, 'Message_content:')+16);		
		$mailer->AddMessage($message);
  		$mailer->BuildMessage();
	  	$mailer->Send($_SESSION['client']['email'], $gOptions['attr_shop_email'], ltrim($subject, " "));
	}
	
	// Finalize procedure - redirect to last page
	( $_SESSION['order']['payment_online'] ) ? $online = 1 : $online = 0;
	$session_id = session_id();
	$shop_path = $_SESSION['shop_path'];
	@session_destroy();
	setcookie(session_name(), "", time(), "/");
	shop_session();
	header('Location: ./final.php?last_sid='.$session_id.'&order_id='.$order_id.'&online='.$online.'&last_path='.urlencode($shop_path));
}

/**
 * Function last_verify
 * Do last visual verify order for client
 **/
function last_verify()
{
	global $gData, $gOptions, $gTpl, $gStartPoint, $gEndPoint;
	
	// Init templates
	$gTpl = new FastTemplate('./'.TEMPLATES);
	$gTpl->DefineTemplate(array('blank' 		=> 'blank.htm',
							    'main'			=> '_order/last_verify/main.htm',
							    'unit'			=> '_order/last_verify/unit.htm',
							    'unit_gift'		=> '_order/last_verify/unit_gift.htm',
							    'status0'		=> '_order/last_verify/status0.htm',
							    'status1'		=> '_order/last_verify/status1.htm',
							    'status2'		=> '_order/last_verify/status2.htm',
							    'status3'		=> '_order/last_verify/status3.htm',	
							    'client_unit'	=> '_order/last_verify/client/unit.htm',
							    'elem_file'		=> '_order/last_verify/client/elem_file.htm',
							    'elem_folder'	=> '_order/last_verify/client/elem_folder.htm',
							    'condition'		=> '_order/last_verify/condition.htm',
							    'delivery'		=> '_order/last_verify/delivery.htm',
							    'min_suma'		=> '_order/last_verify/min_suma.htm',
							    'set_params'	=> '_order/last_verify/set_params.htm',
							    'page_title'	=> '_order/last_verify/page_title.htm'
							    ));
	
	// Define useful variables
	$ic_value = $_SESSION['payment']['multiplex']*1;
	
	// Get client information
	$client = $gData->GetClientData($_SESSION['client']['id']);	
	$rows = $gData->GetNumRows($client);
	$gTpl->Assign('CLUNIT', '');
	$allow = array();
	for ( $n = 1; $n <= $rows; $n++ ) 
	{			
		$hash = $gData->FetchRow($client);
		if ( (strlen($hash[8]) > 0) || ($allow[$hash[0]] == 1) ) 
		{
			$allow[$hash[4]] = 1;			
			$gTpl->Assign(array('NAME'	=> htmlspecialchars($hash[1]),
							    'LEVEL'	=> $hash[3]
								));			
			// if folder
			if ( $hash[7] == 1) 
			{
				$gTpl->Parse('ELEMENT', 'elem_folder');
			}
			// if not folder
			else
			{
				$gTpl->Assign('VALUE', htmlspecialchars($hash[8]));
				$gTpl->Parse('ELEMENT', 'elem_file');
			}
			$gTpl->Parse('CLUNIT', ',client_unit');
		}
	}
	// common vars
	$gTpl->Assign(array('LOGIN'	=> htmlspecialchars($_SESSION['client']['login']),
					    'EMAIL'	=> htmlspecialchars($_SESSION['client']['email'])
						));	
						   	
	// Get Goods list
	$goods = $gData->GetCurrentBasket(session_id());
	$rows = $gData->GetNumRows($goods);
	$itogo_sum = 0;
	$how_ordered = 0;
	$tax_sum = 0;
	for ( $i = 1; $i <= $rows; $i++ ) 
	{			
		$hash = $gData->FetchHash($goods);
		
		// Calc prices
		list($price, $new_price) = calc_basket_goods($hash, $_SESSION['client']);
		$disc_suma = $price - $new_price;
		
		// Total sum
		$itogo_sum += $new_price*$hash['how'];
		$itogo = $new_price*$hash['how'];
		$how_ordered += $hash['how'];
		$tax_sum += $hash['tax']*$hash['how'];
		
		// Info currency
		if ( $ic_value > 0 ) 
		{
			$itogo = round($itogo*$ic_value, 2);
			$price = round($price*$ic_value, 2);
			$new_price = round($new_price*$ic_value, 2);
			$disc_suma = round($disc_suma*$ic_value, 2);
		}	
		
		// Icon
		if ( is_file('./files/store'.$hash['store_id'].'.jpg') ) 
		{
		    $img_file = 'files/store'.$hash['store_id'].'.jpg';
		} 
		else
		{
			$img_file = 'files/store_default.jpg';
		}
		
		// Assign vars
		$gTpl->Assign(array('NAME'  	=> htmlspecialchars($hash['name']),
						    'MEAS'		=> htmlspecialchars($hash['meas']),
						    'CODE'		=> htmlspecialchars($hash['code']),
						    'KIT'		=> htmlspecialchars($hash['param_name']),
						    'PRICE'		=> number_format($price, $gOptions['main_prec'], "," ,"'"),
						    'NEWPRICE'	=> number_format($new_price, $gOptions['main_prec'], "," ,"'"),
						    'DISCSUMA'	=> number_format($disc_suma, $gOptions['main_prec'], "," ,"'"),
							'SUMASEL'	=> ($disc_suma != 0) ? '1' : '0',
						    'ITOGO'		=> number_format($itogo, $gOptions['main_prec'], "," ,"'"),
						    'ICON'		=> $img_file,
		   				    'HOW' 		=> $hash['how'],
						    'ID'		=> $hash['id'],
						    'STOREID'	=> $hash['store_id']
       			            ));			
		$gTpl->Parse('STATUS', 'status'.$hash['status']);
		$gTpl->Parse('UNIT', '.unit');
	}
	
	// Parse gifts
	$gift = $gData->GetGiftForSum($itogo_sum);
	$rows = $gData->GetNumRows($gift);
	for ( $i = 1; $i <= $rows; $i++ ) 
	{			
		$hash = $gData->FetchHash($gift);
		$tax_sum += $hash['tax'];
		$gTpl->Assign(array('NAME'  	=> htmlspecialchars($hash['name']),
						    'CODE'		=> htmlspecialchars($hash['code']),
						    'NOTE'		=> $hash['descr'],
						    'STOREID'	=> $hash['id']
       			            ));			
		$gTpl->Parse('UNIT', '.unit_gift');			
	}
	
	// Common discount for order sum
	$disc_order_sum = $_SESSION['client']['suma'];
	if ( $_SESSION['client']['proc'] == 0 && $_SESSION['client']['suma'] == 0 && $_SESSION['client']['category_id'] == 0 ) 
	{
		$calc_disc_sum = ( $gOptions['main_disc_type'] == 'True' ) ? $itogo_sum + $_SESSION['client']['orders_suma']*1 : $itogo_sum;
		$disc = $gData->GetDiscountOrder($calc_disc_sum);
		if ( $disc['id'] > 0 ) 
		{
		    $disc_order_sum = round($itogo_sum*$disc['proc']/100, 2);
		}
	}
	$total_sum = $itogo_sum - $disc_order_sum;
	
	// Delivery
	list ($get_delivery, $deliv_name, $deliv_cost) = calc_basket_delivery($_SESSION['order']['delivery_id'], $tax_sum, $itogo_sum);
	if ( $get_delivery ) 
	{
		$cost = $deliv_cost; 
		// Info currency
		if ( $ic_value > 0 ) $cost = round($cost*$ic_value, 2);	
		$gTpl->Assign(array('COST'	=> number_format($cost, $gOptions['main_prec'], "," ,"'"),
						    'NAME'	=> htmlspecialchars($deliv_name)
						    ));
		$gTpl->Parse('DELIVERY', 'delivery');
	}	
	else
	{
		$gTpl->Assign('DELIVERY', '');
	}
	
	// Condition
	list ($get_condition, $cond_name, $cond_cost) = calc_basket_condition($_SESSION['order']['condition_id'], $tax_sum, $itogo_sum, $how_ordered);
	if ( $get_condition ) 
	{
		$cost = $cond_cost;
		// Info currency
		if ( $ic_value > 0 ) $cost = round($cost*$ic_value, 2);	
		$gTpl->Assign(array('COST'	=> number_format($cost, $gOptions['main_prec'], "," ,"'"),
						    'NAME'	=> htmlspecialchars($cond_name)
						    ));
		$gTpl->Parse('CONDITION', 'condition');
	}	
	else
	{
		$gTpl->Assign('CONDITION', '');
	}	
	
	// Total sum
	$total_sum += $deliv_cost+$cond_cost;
	$order_sum = $total_sum;
	
	// Min suma
	$min_suma = $gOptions['order_min_sum']*1;
	if ( $order_sum < $min_suma )
	{
		if ( $ic_value > 0 ) $min_suma = round($min_suma*$ic_value, 2);	
		$gTpl->Assign('COST', number_format($min_suma, $gOptions['main_prec'], "," ,"'"));
		$gTpl->Parse('MINSUMA', 'min_suma');
	}
	else
	{
		$gTpl->Assign('MINSUMA', '');
	}
	
	// Payment
	list($get_payment, $payment_name, $payment_cost, 
		 $payment_curr, $payment_prec) = calc_basket_payment($_SESSION['order']['payment_id'], $order_sum, $gOptions['orig_base_curr'], $gOptions['orig_prec']);
	$gTpl->Assign(array('PAYCOST'	=> number_format($payment_cost, $payment_prec, "," ,"'"),
					    'PAYNAME'	=> htmlspecialchars($payment_name),
					    'PAYCURR'	=> htmlspecialchars($payment_curr),
					    ));
	// Info currency
	if ( $ic_value > 0 ) 
	{
		$itogo_sum = round($itogo_sum*$ic_value, 2);
		$disc_order_sum = round($disc_order_sum*$ic_value, 2);
		$total_sum = round($total_sum*$ic_value, 2);
	}
	$gTpl->Assign(array('ITOGOSUM'	=> number_format($itogo_sum, $gOptions['main_prec'], "," ,"'"),
					    'DISCSUM'	=> number_format($disc_order_sum, $gOptions['main_prec'], "," ,"'"),
					    'DISCSEL'	=> ($disc_order_sum != 0) ? '1' : '0',
					    'TOTALSUM'	=> number_format($total_sum, $gOptions['main_prec'], "," ,"'"),
					    'NOTICE'	=> htmlspecialchars($_SESSION['order']['notice'])
						));
						
	// Buttons for change order params
	if ( !$get_payment && !$get_delivery && !$get_condition ) 
	{
	    $gTpl->Assign('SETPARAMS', '');
	}
	else
	{
		$gTpl->Parse('SETPARAMS', 'set_params');
	}
	$gTpl->Parse('CONTENT', 'main');
	
	// Echo shop variables
	echo_shop_variables('in_techpage', true);		

	// Additional modules
	use_php_mod('other');
	
	$gTpl->Parse('PAGETITLE', 'page_title');
					   	
	// Parse main page
	$gTpl->Parse('BLANK', 'blank');
	$gEndPoint = run_time($gStartPoint);
	$gTpl->FastPrint('BLANK');
	
	return true;
}	


/**
 * Function order_params_error
 * Echo payment delivery error
 **/
function order_params_error()
{
	global $gData, $gOptions, $gTpl, $gStartPoint, $gEndPoint;
	
	// Init templates
	$gTpl = new FastTemplate('./'.TEMPLATES);
	$gTpl->DefineTemplate(array('blank' 		=> 'blank.htm',
							    'main'			=> '_order/get_params/main.htm',
							    'payment_error'	=> '_order/get_params/payment_error.htm',
							    'page_title'	=> '_order/get_params/page_title.htm'
							    ));
	
	// Echo payment delivery error
	$gTpl->Parse('PAYMENTERROR', 'payment_error');
	$gTpl->Assign(array('DELIVERY'	=> '',
						'CONDITION'	=> '',
						'PAYMENT'	=> '',
						'SUBMIT'	=> ''
						));
	
	$gTpl->Parse('CONTENT', 'main');

	// Echo shop variables
	echo_shop_variables('in_techpage', true);	

	// Additional modules
	use_php_mod('other');
	   
	$gTpl->Parse('PAGETITLE', 'page_title');
					   	
	// Parse main page
	$gTpl->Parse('BLANK', 'blank');
	$gEndPoint = run_time($gStartPoint);
	$gTpl->FastPrint('BLANK');
}


/**
 * Function get_order_params
 * Get Additional order params like delivery, condition, payment
 **/
function get_order_params()
{
	global $gData, $gOptions, $gTpl, $gStartPoint, $gEndPoint;
	
	// Init templates
	$gTpl = new FastTemplate('./'.TEMPLATES);
	$gTpl->DefineTemplate(array('blank' 		=> 'blank.htm',
							    'main'			=> '_order/get_params/main.htm',
							    'submit'		=> '_order/get_params/submit.htm',
							    'page_title'	=> '_order/get_params/page_title.htm'
							    ));
	
	$ic_value = $_SESSION['payment']['multiplex']*1;

	// Calc order sum and tax
	list($how_ordered, $itogo_sum, $total_sum, $tax_sum) = calc_basket_info($_SESSION['client']);
	
	// Test order sum
	if ( $itogo_sum*1 == 0 )
	{ 
		header("Location: ./basket.php?".session_name()."=".session_id());  
	 	exit; 
	}
	$get_payment = false;
	$get_delivery = false;
	$get_condition = false;		
	
	// Make Delivery
	$deliv = $gData->GetDelivery();
	$rows = $gData->GetNumRows($deliv);
	if ( $rows > 0 ) 
	{
		$get_delivery = true;
		$tpl_sub = new FastTemplate('./'.TEMPLATES.'/_order/get_params/delivery');
		$tpl_sub->DefineTemplate(array('main'			=> 'main.htm',
							   		   'unit'			=> 'unit.htm',
							   		   'elem_file'		=> 'elem_file.htm',
							   		   'elem_folder'	=> 'elem_folder.htm',
							   		   'free'			=> 'free.htm'
								       ));
	
		for ( $i = 1; $i <= $rows; $i++ ) 
		{			
			$hash = $gData->FetchRow($deliv);	
			$tpl_sub->Assign(array('NAME'	=> htmlspecialchars($hash[1]),
								   'DESCR'	=> $hash[2],
								   'LEVEL'  => $hash[3],
								   'ID'		=> $hash[0],
								   'PARENT'	=> $hash[4]
								   ));
			// if folder
			if ( $hash[9] == 1) 
			{
				$tpl_sub->Parse('ELEMENT', 'elem_folder');
			}
			// if not folder
			else
			{
				// if avaible free
				$free_from = $hash[8]*1;
				if ( $free_from > 0 ) 
				{
					// Info currency
					if ( $ic_value > 0 ) 
					{
						$free_from = round($hash[8]*$ic_value, 2);
					}
					$tpl_sub->Assign('FREE_FROM', number_format($free_from, $gOptions['main_prec'], "," ,"'"));
					$tpl_sub->Parse('FREE', 'free');
				}
				else
				{
					$tpl_sub->Assign('FREE', '');
				}
				// start calc cost of this varian delivery
				$cost = $hash[7];
				$cost += round($itogo_sum*$hash[6]/100, 2);
				// has multiplex table?
				if ( $hash[10]*1 > 0 ) 
				{
					$multiplex = $gData->GetDeliveryMultiplex($hash[0], $tax_sum);
					$cost += $tax_sum*$multiplex;
				}
				// has add cost from order sum?
				if ( $hash[11]*1 > 0 ) 
				{
					$cost += $gData->GetDeliveryCost($hash[0], $itogo_sum);
				}				
				// do free cost
				if ( $itogo_sum >= $hash[8]*1 && $hash[8]*1 > 0 ) 
				{
				    $cost = 0;
				}
				// check this variant
				if ( $hash[0] == $_SESSION['order']['delivery_id'] )
				{
				    $check = 'CHECKED';
				}
				else
				{
					$check = '';
				}
				// Info currency
				if ( $ic_value > 0 ) $cost = round($cost*$ic_value, 2);
				$tpl_sub->Assign(array('COST'	=> number_format($cost, $gOptions['main_prec'], "," ,"'"),
									   'CHECK'	=> $check
								       ));
				$tpl_sub->Parse('ELEMENT', 'elem_file');
			}
			// common vars
			$tpl_sub->Parse('UNIT', '.unit');			
		}
		$tpl_sub->Parse('MAIN', 'main');
		$gTpl->Assign('DELIVERY', $tpl_sub->Fetch('MAIN'));
	}
	else
	{
		$gTpl->Assign('DELIVERY', '');
	}
	
	
	// Make Condition
	$cond = $gData->GetCondition();
	$rows = $gData->GetNumRows($cond);
	if ( $rows > 0 ) 
	{
		$get_condition = true;
		$tpl_sub = new FastTemplate('./'.TEMPLATES.'/_order/get_params/condition');
		$tpl_sub->DefineTemplate(array('main'			=> 'main.htm',
							   		   'unit'			=> 'unit.htm',
							   		   'elem_file'		=> 'elem_file.htm',
							   		   'elem_folder'	=> 'elem_folder.htm'
								   ));
		$cond_check = explode(",", $_SESSION['order']['condition_id']);
		for ( $i = 1; $i <= $rows; $i++ ) 
		{			
			$hash = $gData->FetchRow($cond);	
			$tpl_sub->Assign(array('NAME'	=> htmlspecialchars($hash[1]),
								   'DESCR'	=> $hash[2],
								   'LEVEL'  => $hash[3],
								   'ID'		=> $hash[0],
								   'PARENT'	=> $hash[4]
								   ));
			// if folder
			if ( $hash[10] == 1) 
			{
				$tpl_sub->Parse('ELEMENT', 'elem_folder');
			}
			// if not folder
			else
			{
				// start calc cost of this varian condition
				$cost = $hash[7];
				$cost += round($itogo_sum*$hash[6]/100, 2);
				$cost += $how_ordered*$hash[8];
				$cost += $tax_sum*$hash[9];
				// check this variant
				if ( in_array($hash[0], $cond_check) )
				{
				    $check = 'CHECKED';
				}
				else
				{
					$check = '';
				}
				// Info currency
				if ( $ic_value > 0 ) $cost = round($cost*$ic_value, 2);
				$tpl_sub->Assign(array('COST'	=> number_format($cost, $gOptions['main_prec'], "," ,"'"),
									   'CHECK'	=> $check
								       ));
				$tpl_sub->Parse('ELEMENT', 'elem_file');
			}
			$tpl_sub->Parse('UNIT', '.unit');			
		}
		$tpl_sub->Parse('MAIN', 'main');
		$gTpl->Assign('CONDITION', $tpl_sub->Fetch('MAIN'));
	}
	else
	{
		$gTpl->Assign('CONDITION', '');
	}
	
	
	// Make Payment
	$payment = $gData->GetPayment();
	$rows = $gData->GetNumRows($payment);
	if ( $rows > 0 ) 
	{
		$get_payment = true;
		$tpl_sub = new FastTemplate('./'.TEMPLATES.'/_order/get_params/payment');
		$tpl_sub->DefineTemplate(array('main'			=> 'main.htm',
							   		   'unit'			=> 'unit.htm',
							   		   'elem_file'		=> 'elem_file.htm',
							   		   'elem_folder'	=> 'elem_folder.htm',
									   'online'			=> 'online.htm'
								       ));
		$allow = array();
		for ( $i = 1; $i <= $rows; $i++ ) 
		{			
			$hash = $gData->FetchRow($payment);	
			// if info type
			if ( $hash[13] == 1 ) 
			{
				if ( $_SESSION['order']['payment_id'] == $hash[0] ) $_SESSION['order']['payment_id'] = 0;
				continue;
			}
			if ( $hash[6] == 1 && $allow[$hash[0]] != 1 ) continue;
			$allow[$hash[4]] = 1;
			$tpl_sub->Assign(array('NAME'	=> htmlspecialchars($hash[1]),
								   'DESCR'	=> $hash[2],
								   'LEVEL'  => $hash[3],
								   'ID'		=> $hash[0],
								   'PARENT'	=> $hash[4]
								   ));
			// if folder
			if ( $hash[6] == 1 ) 
			{
				$tpl_sub->Parse('ELEMENT', 'elem_folder');
			}
			// if not folder
			else
			{
				// is online pay?
				( $hash[12] == 1 ) ? $tpl_sub->Parse('ONLINE', 'online')
								   : $tpl_sub->Assign('ONLINE', '');
				// start calc cost of this varian payment
				$cost = $hash[11];
				// calc multiplexor
				( $hash[9] == 1 && $hash[8] > 0) ? $cost += round($total_sum/$hash[8], 2)
												 : $cost += round($total_sum*$hash[8], 2);
				// check this variant
				( $hash[0] == $_SESSION['order']['payment_id'] ) ? $check = 'CHECKED'
																 : $check = '';
				$tpl_sub->Assign(array('CURRNAME'	=> htmlspecialchars($hash[7]),
									   'COST'		=> number_format($cost, $hash[10], "," ,"'"),
									   'CHECK'		=> $check
								       ));
				$tpl_sub->Parse('ELEMENT', 'elem_file');
			}
			$tpl_sub->Parse('UNIT', ',unit');			
		}
		$tpl_sub->Parse('MAIN', 'main');
		$gTpl->Assign('PAYMENT', $tpl_sub->Fetch('MAIN'));
	}
	else
	{
		$gTpl->Assign('PAYMENT', '');
	}
	
	// if no params then exit
	if ( !$get_payment && !$get_delivery && !$get_condition ) return false;

	$gTpl->Assign('PAYMENTERROR', '');
	$gTpl->Parse('SUBMIT', 'submit');
	$gTpl->Parse('CONTENT', 'main');

	// Echo shop variables
	echo_shop_variables('in_techpage', true);	

	// Additional modules
	use_php_mod('other');
					   
	$gTpl->Parse('PAGETITLE', 'page_title');
					   	
	// Parse main page
	$gTpl->Parse('BLANK', 'blank');
	$gEndPoint = run_time($gStartPoint);
	$gTpl->FastPrint('BLANK');

	return true;
}

?>